package com.yizhi.statistics.application.course.vo;

import java.util.Date;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 课程图表数据
 * @author mei
 *
 */

@Data
public class ReportStudyCourseViewVo {

	@ApiModelProperty(value="账号")
	private Long accountId;

	@ApiModelProperty(value = "用户名")
	private String accountName;

	@ApiModelProperty(value = "姓名")
	private String accountFullName;


	@ApiModelProperty(value="工号")
	private String workNum;

	@ApiModelProperty(value = "所在部门")
	private String orgName;

	@ApiModelProperty(value = "所在组织架构")
	private String orgNames;

	@ApiModelProperty(value = "学习时长（分钟）（空返回0）")
	private String totalDuration="0:0:0";

	@ApiModelProperty(value="学习次数")
	private Integer learnNum=0;

	@ApiModelProperty(value = "开始时间")
	private Date startTime;

	@ApiModelProperty(value = "完成时间")
	private Date endTime;

	@ApiModelProperty(value = "学习状态：1进行中 2已完成")
	private Integer state = 0;


	//报表用到的字段

	@ApiModelProperty(value="课程得分,暂不统计，需求说一个课程会有好几个测验，不知道放哪个测验的得分")
	private Float learnScore;

	@ApiModelProperty(value="获得积分")
	private Integer learnPoint;

	@ApiModelProperty(value="用户状态")
	private Integer accountState = 0;


}
