package com.yizhi.statistics.application.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 积分明细
 * </p>
 *
 * @author hutao123
 * @since 2021-01-25
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("point_log")
public class PointLog extends Model<PointLog> {

    private static final long serialVersionUID = 1L;

    /**
     * 主键Id
     */
    @TableId("id")
    private Long id;
    /**
     * 积分记录ID
     */
    @TableField("point_detail_id")
    private Long pointDetailId;
    /**
     * 学员Id
     */
    @TableField("account_id")
    private Long accountId;
    /**
     * 变动前数量
     */
    @TableField("before_count")
    private Integer beforeCount;
    /**
     * 变动数量
     */
    @TableField("change_count")
    private Integer changeCount;
    /**
     * 变动后数量
     */
    @TableField("after_count")
    private Integer afterCount;
    /**
     * 变动类型
     */
    @TableField("change_type")
    private Integer changeType;
    /**
     * 变动原因（考试名或项目名）
     */
    @TableField("relation_name")
    private String relationName;
    /**
     * 创建人
     */
    @TableField("create_by_id")
    private Long createById;
    /**
     * 创建人姓名
     */
    @TableField("create_by_name")
    private String createByName;
    /**
     * 公司ID
     */
    @TableField("company_id")
    private Long companyId;
    /**
     * 部门ID
     */
    @TableField("org_id")
    private Long orgId;
    /**
     * 站点ID
     */
    @TableField("site_id")
    private Long siteId;
    /**
     * log创建时间
     */
    @TableField("created_at")
    private Date createdAt;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
