package com.yizhi.statistics.application.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;


@Data
@TableName("practice_config")
public class PracticeConfig extends Model<PracticeConfig> {

    private static final long serialVersionUID = 1L;

    @TableId("id")
    private Long id;
    /**
     * 陪练名
     */
    @TableField("name")
    private String name;
    /**
     * 陪练logoURL
     */
    @TableField("logo_url")
    private String logoUrl;
    /**
     * 陪练描述
     */
    @TableField("description")
    private String description;
    /**
     * 80:训练+考核 ,10:训练 20:考核
     */
    @TableField("use_type")
    private Integer useType;
    /**
     * 训练开始时间
     */
    @TableField("practice_start_at")
    private Date practiceStartAt;
    /**
     * 训练结束时间
     */
    @TableField("practice_end_at")
    private Date practiceEndAt;
    /**
     * 考核开始时间
     */
    @TableField("exam_start_at")
    private Date examStartAt;
    /**
     * 考核结束时间
     */
    @TableField("exam_end_at")
    private Date examEndAt;
    /**
     * 允许最大考试；0：无限次；其他有限次；默认0
     */
    @TableField("max_exam_count")
    private Integer maxExamCount;
    /**
     * 自定义关键词，逗号分隔，命中得分
     */
    @TableField("key_word")
    private String keyWord;
    /**
     * 机器人配置ID
     */
    @TableField("robot_id")
    private Long robotId;
    /**
     * 机器人参数
     */
    @TableField("robot_params")
    private String robotParams;
    /**
     * 自定义机器人名字
     */
    @TableField("robot_name")
    private String robotName;
    /**
     * 机器人头像URL null时走默认头像
     */
    @TableField("robot_pic_url")
    private String robotPicUrl;
    /**
     * 陪练状态 80:上架 30:下架 10:草稿
     */
    @TableField("status")
    private Integer status;
    /**
     * 练习可见范围  80:平台可见 40:指定用户可见
     */
    @TableField("visible_type")
    private Integer visibleType;
    /**
     * 跳过对话类型 80允许，10:不允许
     */
    @TableField("skip_type")
    private Integer skipType;
    /**
     * 80:本轮得分超过限制，则进入下轮；10:无论得分多少，直接进入下一轮
     */
    @TableField("start_next_round_type")
    private Integer startNextRoundType;
    /**
     * 超过该分数，进入下一轮对话
     */
    @TableField("start_next_round_score")
    private Integer startNextRoundScore;
    /**
     * 每轮最多失败次数，超过直接到下轮
     */
    @TableField("practice_failed_max_count")
    private Integer practiceFailedMaxCount;
    /**
     * 考试失败最大次数，超过直接到下轮
     */
    @TableField("exam_failed_max_count")
    private Integer examFailedMaxCount;
    /**
     * 80:允许重复提交 10:不允许重复提交
     */
    @TableField("repeat_push")
    private Integer repeatPush;
    /**
     * 多轮对话：80:开启 10:关闭
     */
    @TableField("many_round_chat")
    private Integer manyRoundChat;
    /**
     * 相似度
     */
    @TableField("similarity_rate")
    private Integer similarityRate;
    /**
     * 未识别回复类型 80:默认回复，10:自定义回复
     */
    @TableField("similarity_failed_msg_type")
    private Integer similarityFailedMsgType;
    /**
     * 自定义未识别回复，分号分隔。
     */
    @TableField("similarity_failed_msg")
    private String similarityFailedMsg;
    /**
     * 考试及格分
     */
    @TableField("exam_pass_min_score")
    private Integer examPassMinScore;
    /**
     * 是否发放积分 80:发放 10:不发放
     */
    @TableField("exam_given_point_type")
    private Integer examGivenPointType;
    /**
     * 关键词
     */
    @TableField("score_rule_keyword")
    private Integer scoreRuleKeyword;
    /**
     * 完整性
     */
    @TableField("score_rule_complete")
    private Integer scoreRuleComplete;
    /**
     * 流畅性
     */
    @TableField("score_rule_smooth")
    private Integer scoreRuleSmooth;
    /**
     * 表达能力
     */
    @TableField("score_rule_express")
    private Integer scoreRuleExpress;
    /**
     * 礼貌
     */
    @TableField("score_rule_polite")
    private Integer scoreRulePolite;
    /**
     * 0:未删除 1:已删除
     */
    @TableField("deleted")
    private Boolean deleted;
    /**
     * 部门ID
     */
    @TableField("org_id")
    private Long orgId;
    /**
     * 站点ID
     */
    @TableField("site_id")
    private Long siteId;
    /**
     * 公司ID
     */
    @TableField("company_id")
    private Long companyId;
    /**
     * 创建记录的管理员ID
     */
    @TableField("created_uid")
    private Long createdUid;
    /**
     * 创建时间
     */
    @TableField("created_at")
    private Date createdAt;
    /**
     * 最后一次更新记录的管理员ID
     */
    @TableField("updated_uid")
    private Long updatedUid;
    /**
     * 更新时间
     */
    @TableField("updated_at")
    private Date updatedAt;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
