package com.yizhi.statistics.application.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;


@Data
@TableName("practice_visible")
public class  PracticeVisible extends Model<PracticeVisible> {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    @TableField("visible_id")
    private Long visibleId;
    /**
     * 陪练ID
     */
    @TableField("practice_id")
    private Long practiceId;
    /**
     * 可见站点Id
     */
    @TableField("visible_site_id")
    private Long visibleSiteId;
    /**
     * 可见部门Id
     */
    @TableField("visible_org_id")
    private Long visibleOrgId;
    /**
     * 可见部门名
     */
    @TableField("visible_org_name")
    private String visibleOrgName;
    /**
     * 可见用户Id
     */
    @TableField("visible_account_id")
    private Long visibleAccountId;
    /**
     * 可见用户工号
     */
    @TableField("visible_account_work_num")
    private String visibleAccountWorkNum;
    /**
     * 用户名
     */
    @TableField("visible_account_name")
    private String visibleAccountName;
    /**
     * 用户全名
     */
    @TableField("visible_account_full_name")
    private String visibleAccountFullName;
    /**
     * 陪练可见范围  80:平台可见 50:部门可见 40:指定用户可见
     */
    @TableField("visible_type")
    private Integer visibleType;
    /**
     * 公司Id
     */
    @TableField("company_id")
    private Long companyId;
    /**
     * 0:not deleted, 1:deleted
     */
    @TableField("deleted")
    private Boolean deleted;
    @TableField("created_at")
    private Date createdAt;
    /**
     * 创建管理员ID
     */
    @TableField("created_uid")
    private Long createdUid;
    @TableField("updated_at")
    private Date updatedAt;
    /**
     * 更新管理员ID
     */
    @TableField("updated_uid")
    private Long updatedUid;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
