package com.yizhi.statistics.application.entity;

import java.util.Date;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 平台报告设置表
 * @author fairyland
 *
 */
@Data
@Api(tags = "Report", description = "平台报告设置表")
@TableName("report")
public class Report {

    private static final long serialVersionUID = 1L;
    
    private Long id;
    
    @ApiModelProperty(value = "报告名称")
    private String name;
    
    @ApiModelProperty(value = "报告类型 0一季度 1二季度 2上半年 3三季度 4四季度 5下半年 6全年")
    private Integer type;
    
    @ApiModelProperty(value = "统计开始时间")
	@TableField("start_time")
    private Date startTime;
    
    @ApiModelProperty(value = "统计结束时间")
	@TableField("end_time")
    private Date endTime;
    
    @ApiModelProperty(value = "状态，0下架 1上架 2预定上架 默认下架")
    private Integer state;
    
    @ApiModelProperty(value = "查看人数")
    private Long num;
    
    @ApiModelProperty(value = "模板路径")
    private String url;
    
	@ApiModelProperty(value = "可见范围，1平台用户可见 2指定用户可见 默认全平台可见")
	@TableField("visible_range")
	private Integer visibleRange;
	
	@ApiModelProperty(value = "数据范围，1仅当前站点 2包括下属子站点 默认仅当前站点")
	@TableField("data_range")
	private Integer dataRange;
	
	@ApiModelProperty(value = "创建时间")
	@TableField(value = "create_time", fill = FieldFill.INSERT)
	private Date createTime;

	@ApiModelProperty(value = "创建人ID")
	@TableField(value = "create_by_id", fill = FieldFill.INSERT)
	private Long createById;
	
	@ApiModelProperty(value = "修改时间")
	@TableField(value = "update_time", fill = FieldFill.UPDATE)
	private Date updateTime;

	@ApiModelProperty(value = "修改人ID")
	@TableField(value = "update_by_id", fill = FieldFill.UPDATE)
	private Long updateById;

	@ApiModelProperty(value = "修改人姓名")
	@TableField(value = "update_by_name", fill = FieldFill.UPDATE)
	private String updateByName;

	@ApiModelProperty(value = "站点_ID")
	@TableField("site_id")
	private Long siteId;
	
	@ApiModelProperty(value = "企业_ID")
	@TableField("company_id")
	private Long companyId;
}
