package com.yizhi.statistics.application.entity;

import java.util.Date;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@Api(tags = "ReportDetail", description = "平台报告学员详情表")
@TableName("report_detail")
public class ReportDetail {

    private static final long serialVersionUID = 1L;
    
    private Long id;
    
	@ApiModelProperty(value = "报告id")
	@TableField("report_id")
    private Long reportId;
	
	@ApiModelProperty(value = "报告名称")
	@TableField("report_name")
    private String reportName;
    
	@ApiModelProperty(value = "报告类型")
	@TableField("report_type")
    private Integer reportType;
	
	@ApiModelProperty(value = "用户id")
	@TableField("account_id")
    private Long accountId;
    
	@ApiModelProperty(value = "查看状态 0未查看 1已查看 默认未查看")
	@TableField("state")
	private Integer state;
	
	@ApiModelProperty(value = "注册时间")
	@TableField("register_time")
    private Date registerTime;
	
	@ApiModelProperty(value = "超出比例")
	@TableField("proportion")
    private Integer proportion;
	
	@ApiModelProperty(value = "全站点超出比例")
	@TableField("all_proportion")
    private Integer allProportion;
	
	@ApiModelProperty(value = "用户时长")
	@TableField("user_duration")
    private Long userDuration;
	
	@ApiModelProperty(value = "站点名称")
	@TableField("site_name")
    private String siteName;
    
	@ApiModelProperty(value = "累计打卡数量")
	@TableField("sign_num")
    private Long signNum;
	
	@ApiModelProperty(value = "全站点累计打卡数量")
	@TableField("all_sign_num")
    private Long allSignNum;
    
	@ApiModelProperty(value = "学习总时长")
	@TableField("study_duration")
    private Long studyDuration;
	
	@ApiModelProperty(value = "全站点学习总时长")
	@TableField("all_study_duration")
    private Long allStudyDuration;
    
	@ApiModelProperty(value = "完成任务量")
	@TableField("finish_num")
    private Integer finishNum;
	
	@ApiModelProperty(value = "全站点完成任务量")
	@TableField("all_finish_num")
    private Integer allFinishNum;
    
	@ApiModelProperty(value = "获得积分")
	@TableField("point")
    private Long point;
	
	@ApiModelProperty(value = "全站点获得积分")
	@TableField("all_point")
    private Long allPoint;
    
	@ApiModelProperty(value = "首个证书")
	@TableField("first_certificate")
    private Date firstCertificate;
    
	@ApiModelProperty(value = "全站点首个证书")
	@TableField("all_first_certificate")
    private Date allFirstCertificate;
	
	@ApiModelProperty(value = "学习时间")
	@TableField("latest_date")
    private Date latestDate;
    
	@ApiModelProperty(value = "全站点学习时间")
	@TableField("all_latest_date")
    private Date allLatestDate;
	
	@ApiModelProperty(value = "学习最长天")
	@TableField("max_study")
    private Date maxStudy;
	
	@ApiModelProperty(value = "全站点学习最长天")
	@TableField("all_max_study")
    private Date allMaxStudy;
	
	@ApiModelProperty(value = "学习最长时间")
	@TableField("max_duration")
    private Long maxDuration;
	
	@ApiModelProperty(value = "全站点学习最长时间")
	@TableField("all_max_duration")
    private Long allMaxDuration;
	
	@ApiModelProperty(value = "徽章类型 0学神徽章 1学霸徽章 2学习标兵徽章 3学弟徽章 4新生徽章")
	@TableField("type")
    private Integer type;
	
	@ApiModelProperty(value = "全站点徽章类型")
	@TableField("all_type")
    private Integer allType;
	
	@ApiModelProperty(value = "创建时间")
	@TableField(value = "create_time", fill = FieldFill.INSERT)
	private Date createTime;

	@ApiModelProperty(value = "创建人ID")
	@TableField(value = "create_by_id", fill = FieldFill.INSERT)
	private Long createById;
	
	@ApiModelProperty(value = "站点_ID")
	@TableField("site_id")
	private Long siteId;
	
	@ApiModelProperty(value = "企业_ID")
	@TableField("company_id")
	private Long companyId;
}
