package com.yizhi.statistics.application.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 学员调研明细
 * </p>
 *
 * @author hutao123
 * @since 2019-04-18
 */
@Data
@Api (tags = "StatisticsResearchLearnMetadata", description = "学员调研明细")
@TableName ("statistics_research_learn_metadata")
public class StatisticsResearchLearnMetadata extends Model<StatisticsResearchLearnMetadata> {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty (value = "自增")
    @TableId (value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty (value = "调研ID")
    @TableField ("research_id")
    private Long researchId;

    @ApiModelProperty (value = "用户ID")
    @TableField ("account_id")
    private Long accountId;

    @ApiModelProperty (value = "应参加状态，1应参加 0不应参加（用于统计：应参加人数，MAX取值）")
    @TableField ("can_state")
    private Integer canState;

    @ApiModelProperty (value = "实际参加状态，1参加 0未参加（用于统计：实参加人数，MAX取值）")
    @TableField ("join_state")
    private Integer joinState;

    @ApiModelProperty (value = "提交时间")
    @TableField ("finish_time")
    private Date finishTime;

    @ApiModelProperty (value = "调研参加时间")
    @TableField ("research_answer_create_time")
    private Date researchAnswerCreateTime;

    @ApiModelProperty (value = "记录统计时间")
    @TableField ("record_create_time")
    private Date recordCreateTime;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
