package com.yizhi.statistics.application.entity;

import java.io.Serializable;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableName;
import lombok.Data;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 学习计划中的活动
 * </p>
 *
 * @author wfd123
 * @since 2019-05-14
 */
@Data
@Api(tags = "StatisticsTrainingPlanActivity", description = "学习计划中的活动")
@TableName("statistics_training_plan_activity")
public class StatisticsTrainingPlanActivity extends Model<StatisticsTrainingPlanActivity> {

    private static final long serialVersionUID = 1L;


@ApiModelProperty(value = "主键id")
	private Long id;

@ApiModelProperty(value = "冗余培训项目id")
	@TableField("training_project_id")
	private Long trainingProjectId;

@ApiModelProperty(value = "学习计划id")
	@TableField("tp_plan_id")
	private Long tpPlanId;

@ApiModelProperty(value = "活动类型：0课程1考试2调研3直播4投票5作业6证书7外部链接")
	private Integer type;

@ApiModelProperty(value = "关联的活动的id")
	@TableField("relation_id")
	private Long relationId;

@ApiModelProperty(value = "活动名称，从活动那边取过来，不能自定义")
	private String name;

@ApiModelProperty(value = "站点id")
	@TableField("site_id")
	private Long siteId;


@ApiModelProperty(value = "企业id")
	@TableField("company_id")
	private Long companyId;


	@Override
	protected Serializable pkVal() {
		return this.id;
	}

}
