package com.yizhi.statistics.application.entity;

import java.io.Serializable;

import java.util.Date;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableName;
import lombok.Data;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 培训项目完成情况，只有计划完成才会有记录
 * </p>
 *
 * @author wfd123
 * @since 2019-05-14
 */
@Data
@Api(tags = "StatisticsTrainingStudentRecorde", description = "培训项目完成情况，只有计划完成才会有记录")
@TableName("statistics_training_student_recorde")
public class StatisticsTrainingStudentRecorde extends Model<StatisticsTrainingStudentRecorde> {

    private static final long serialVersionUID = 1L;


@ApiModelProperty(value = "主键id")
	private Long id;

@ApiModelProperty(value = "对应的培训项目id")
	@TableField("training_project_id")
	private Long trainingProjectId;

@ApiModelProperty(value = "所属站点id")
	@TableField("site_id")
	private Long siteId;

@ApiModelProperty(value = "学员id")
	@TableField("account_id")
	private Long accountId;

@ApiModelProperty(value = "完成时间")
	@TableField("finish_date")
	private Date finishDate;


	@Override
	protected Serializable pkVal() {
		return this.id;
	}

}
