package com.yizhi.statistics.application.exam.domain.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @Date 2020/9/17 10:44 上午
 * @Author lvjianhui
 **/
@Data
@ApiModel
public class UserExamByOrgVO {

    String orgName;
    String orgCode;

    @ApiModelProperty("用户名")
    String userName;

    @ApiModelProperty("姓名")
    String fullName;

    @ApiModelProperty("应参加考试数")
    Long planJoinCount = 0L;

    @ApiModelProperty("实际参加考试数")
    Long actualJoinCount = 0L;

    @ApiModelProperty("通过考试数")
    Long passCount = 0L;

    @ApiModelProperty("考试时长")
    Integer duration;

    @ApiModelProperty("未通过考试数")
    Long unPassCount = 0L;

    //组织机构代码
    @ApiModelProperty(value = "组织结构", hidden = true)
    String orgNames;



    @ApiModelProperty("通过率")
    Integer passRate = 0;

    public Long getPassRate() {
        if (passCount == null || actualJoinCount == null) return 0L;
        if (passCount == 0 || actualJoinCount == 0) return 0L;
        return (passCount * 100) / actualJoinCount;
    }

    Long accountId;
}
