package com.yizhi.statistics.application.feign;

import com.yizhi.statistics.application.entity.AccountDashboard;
import com.yizhi.statistics.application.refactor.course.CourseDashboardParam;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

@FeignClient(name = "statistics", contextId = "DashboardClient")
public interface DashboardClient {

    /**
     * 根据时间获取学习记录
     *
     * @param param
     * @return
     */
    @PostMapping("/accountDashboard/getRecords/byAccountId")
    public List<AccountDashboard> getRecords(@RequestBody CourseDashboardParam param);

    @GetMapping("/accountDashboard/asynchronous/dashboard")
    public void AsynchronousDashboard(@RequestParam("yesterday") String yesterday);

    /**
     * 专门用于跑历史数据  startDateString 直到  endDateString
     * @param endDateString
     */
    @GetMapping("/accountDashboard/diy/asynchronous/dashboard")
    public void diyAsynchronousDashboard(@RequestParam("startDateString") String startDateString,
                                         @RequestParam("endDateString") String endDateString);

}
