package com.yizhi.statistics.application.feign;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.statistics.application.album.vo.*;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;

@FeignClient(name="statistics", contextId = "ReportAlbumClient")
public interface ReportAlbumClient {

	@PostMapping("/statisticsAlbum/chart/group")
	public List<ReportStudyAlbumChartsVo> chartGroup(@RequestBody AlbumGroupParam albumGroupParam);
	
	@PostMapping("/statisticsAlbum/group")
	public Page<ReportStudyAlbumVo> albumGroup(@RequestBody AlbumGroupParam albumGroupParam);
	
	@PostMapping("/statisticsAlbum/group/excel")
	public void albumGroupExport(@RequestBody AlbumGroupParam albumGroupParam);
	
	@PostMapping("/statisticsAlbum/group/view")
	public List<ReportStudyAlbumViewVo2> albumGroupView(@RequestBody AlbumGroupParam albumGroupParam);
	
	@PostMapping("/statisticsAlbum/group/view/export1")
	public void albumGroupViewExport1(@RequestBody AlbumGroupParam albumGroupParam);
	
	@PostMapping("/statisticsAlbum/group/view/export2")
	public void albumGroupViewExport2(@RequestBody AlbumGroupParam albumGroupParam);
	
	@PostMapping("/statisticsAlbum/group/view/export3")
	public void albumGroupViewExport3(@RequestBody AlbumGroupParam albumGroupParam);
	
	@PostMapping("/statisticsAlbum/account/group")
	public Page<ReportStudyAlbumAccountVo> albumAccountGroup(@RequestBody AlbumGroupAccountParam albumGroupAccountParam);
	
	@PostMapping("/statisticsAlbum/account/group/export")
	public void albumAccountGroupExport(@RequestBody AlbumGroupAccountParam albumGroupAccountParam);
	
	@PostMapping("/statisticsAlbum/account/group/view")
	public Page<ReportStudyAlbumAccountViewVo> albumAccountGroupView(@RequestBody AlbumGroupAccountParam albumGroupAccountParam);
	
	@PostMapping("/statisticsAlbum/account/group/view/export")
	public void albumAccountGroupViewExport(@RequestBody AlbumGroupAccountParam accountParam);
}
