package com.yizhi.statistics.application.feign;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.statistics.application.entity.Report;
import com.yizhi.statistics.application.entity.ReportVisibleRange;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

@FeignClient(name="statistics", contextId = "statistics-ReportClient")
public interface ReportClient {

	@GetMapping("/statisticsReport/save")
	public void save(@RequestParam("type") Integer type);
	
	@PostMapping("/statisticsReport/update")
	public Report update(@RequestBody Report report);
	
	@GetMapping("/statisticsReport/up")
	public Boolean up(@RequestParam("reportId") Long reportId);
	
	@GetMapping("/statisticsReport/down")
	public Boolean down(@RequestParam("reportId") Long reportId);
	
	@PostMapping("/statisticsReport/authorize/insert")
	public Boolean insertReportVisibleRanges(@RequestBody List<ReportVisibleRange> reportVisibleRanges);
	
	@GetMapping("/statisticsReport/list")
	public Page<Report> list(@RequestParam("pageSize") Integer pageSize, @RequestParam("pageNo") Integer pageNo, @RequestParam("type") Integer type,
			@RequestParam("siteId") Long siteId, @RequestParam("companyId") Long companyId, @RequestParam("kwd") String kwd);
	
	@GetMapping("/statisticsReport/VisibleRange")
	public List<ReportVisibleRange> VisibleRange(@RequestParam("reportId") Long reportId);
	
	@PostMapping("/statisticsReport/relation/list")
	public List<Report> relationList(@RequestBody List<Long> ids);
	
	@GetMapping("/statisticsReport/get/id")
	public Report getById(@RequestParam("id") Long id);
}
