package com.yizhi.statistics.application.feign;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.statistics.application.course.vo.*;
import com.yizhi.statistics.application.entity.StatisticsCourse;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

@FeignClient(name="statistics", contextId = "StatisticsCourseClient")
public interface StatisticsCourseClient {
	
	@GetMapping("/test/test")
	public StatisticsCourse statisticsCourse(@RequestParam(value="id")Long id);
	
	
	/**
	 * 系统更改角色的时候，改变管理员的信息
	 * @param accountId
	 * @param siteId
	 */
	@GetMapping("/statisticsReport/update/role")
	public void statisticsUpdateRole(@RequestParam(value="accountId",required=true)Long accountId,
			                                                 @RequestParam(value="siteId",required=true)Long siteId);
	
	

	  @GetMapping("/statisticsReport/asynchronous/load/date")
	  public String AsynchronousCourse(@RequestParam(value="startDate",required=false) String startDate,
			                                                          @RequestParam(value="endDate",required=false) String endDate);


	/**
	 * 处理发版培训项目数据库 tp_plan_activity，tp_student_project_record，tp_student_plan_record 数据丢失，手动跑批
	 * @param startDate
	 * @param endDate
	 */
	@GetMapping("/statisticsReport/asynchronous/load/date/training")
	public void AsynchronousCourseTraining(@RequestParam(value="startDate",required=false) String startDate,
									 @RequestParam(value="endDate",required=false) String endDate);
	

	  /**
	   * 图形报表
	   * @param startDate
	   * @param endDate
	   * @param companyId
	   * @param orgId
	   * @param siteId
	   * @param orgIds
	   * @return
	   */
	  @GetMapping("/statisticsCourse/chart/group")
	  public List<ReportStudyCourseChartsVo> chartGroup(
			  @RequestParam("startDate")String startDate,
			  @RequestParam("endDate")String endDate,
			  @RequestParam("companyId")Long companyId,
			  @RequestParam("siteId")Long siteId,
			  @RequestParam("adminId")Long adminId,
			  @RequestParam("isAdmin")Boolean isAdmin);
	  
	  
	  
	  /**
	   * 按照课程统计
	   */
	  @PostMapping("/statisticsCourse/group")
	  public Page<ReportStudyCourseVo> courseGroup(@RequestBody CourseGroupParam courseGroupParam);
	  
	  
	  
	  /**
	   * 按照课程统计下载
	   * @param map
	   */
	  @PostMapping("/statisticsCourse/group/excel")
	  public void courseGroupExcel(@RequestBody CourseGroupParam courseGroupExportExcelVo);
	  
	  
	  
	  /**
	   * 按照课程统计详情
	   */
	  @PostMapping("/statisticsCourse/group/view")
	  public Page<ReportStudyCourseViewVo> courseGroupView(@RequestBody CourseGroupViewParam courseGroupViewParam);
	  
	  
	  
	  /**
	   * 按照课程统计详情导出Excel
	   * @param map
	   */
	  @PostMapping("/statisticsCourse/group/view/excel")
	  public void courseGroupViewExcel(@RequestBody CourseGroupViewParam courseGroupViewParam);
	  
	  
	
	  
	  /**
	   * 按照用户统计
	   */
	  @PostMapping("/statisticsCourse/account/group")
	  public Page<ReportStudyCourseAccountVo> courseAccountGroup(@RequestBody CourseAccountGroupParam courseAccountGroupParam);
	  
	  
	  /**
	   * 按照用户统计导出
	   * @param map
	   */
	  @PostMapping("/statisticsCourse/account/group/excel")
	  public void courseAccountGroupExportExcel(@RequestBody CourseAccountGroupParam courseAccountGroupParam);
	  
	  
	  
	  /**
	   * 下载用户学习明细
	   * @param map
	   */
	  @PostMapping("/statisticsCourse/account/details/export")
	  public void courseAccountDetails(@RequestBody CourseAccountGroupParam courseAccountGroupParam);
	  
	  
	  /**
	   * 按照用户统计详情
	   * @return
	   */
	  @PostMapping("/statisticsCourse/account/group/view")
	  public  Page<ReportStudyCourseAccountViewVo> courseAccountGroupView(@RequestBody CourseAccountGroupViewParam courseAccountGroupViewParam);
	  
	  
	  
	  
	  /**
	   *按照用户统计详情导出Excel
	   * @return
	   */
	  @PostMapping("/statisticsCourse/account/group/view/export")
	  public  void courseAccountGroupViewExport(@RequestBody CourseAccountGroupViewParam courseAccountGroupViewParam);
	  
	  
	  
	  
	 

	  
	  
	  /**
	   * 按照部门统计
	   * @return
	   */
	  @PostMapping("/statisticsCourse/org/group")
	  public Page<ReportStudyCourseOrgVo> courseOrgGroup(@RequestBody CourseOrgGroupParam courseOrgGroupParam);
	  
	  
	  
	  /**
	   * 按照部门统计下载
	   * @param map
	   */
	  @PostMapping("/statisticsCourse/org/group/export")
	  public void courseOrgGroupExport(@RequestBody CourseOrgGroupParam courseOrgGroupParam);

	/**
	 * 学员 学习时间记录 手动跑批
	 * @param startTime
	 * @param endTime
	 */
	@GetMapping("/statisticsReport/statisticsCourse/org/study/dashboard")
	public void courseOrgStudyDashboard(@RequestParam("startTime")String startTime,
										  @RequestParam("endTime")String endTime);

	/**
	 * 公司下用户 手动跑批
	 * @param companyId
	 */
	@GetMapping("/statisticsReport/asynchronous/load/assignsite/system")
	public void assignSiteSystemAccount(@RequestParam("companyId") Long companyId);



	@GetMapping("/statisticsReport/asynchronous/load/date/course")
	public String AsynchronousCourse(@RequestParam(value="startDate",required=false)String startDate,
									 @RequestParam(value="endDate",required=false)String endDate,
									 @RequestParam(value="companyId",required=false)Long companyId,
									 @RequestParam(value="siteId",required=false)Long siteId);

}
