package com.yizhi.statistics.application.feign;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.statistics.application.entity.StatisticsForumAccount;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.Map;

@FeignClient(name = "statistics", contextId = "StatisticsForumAccountClient")
public interface StatisticsForumAccountClient {

    /**
     * 按用户统计
     *
     * @param keyword
     * @param pageNo
     * @param PageSize
     * @return
     */
    @GetMapping("/statisticsForumAccount/getPage")
    public Page<StatisticsForumAccount> getPage(@RequestParam(value = "keyword",required = false) String keyword,
                                                @RequestParam("pageNo") Integer pageNo,
                                                @RequestParam("PageSize") Integer PageSize);

    @ApiOperation("论坛统计-按用户统计下载")
    @GetMapping("/statisticsForumAccount/download")
    public String download(@RequestBody Map map);

}
