package com.yizhi.statistics.application.feign;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.statistics.application.entity.StatisticsForum;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.Map;

@FeignClient(name="statistics", contextId = "StatisticsForumClient")
public interface StatisticsForumClient {

	/**
	 * 按帖子统计
	 * @param keyword
	 * @param pageNo
	 * @param PageSize
	 * @return
	 */
	@GetMapping("/statisticsForum/getPage")
	public Page<StatisticsForum> getPage(@RequestParam (value = "keyword",required = false)String keyword,
										 @RequestParam (value = "startDate",required = false) String startDate,
										 @RequestParam (value = "endDate",required = false) String endDate,
										 @RequestParam ("pageNo")Integer pageNo,
										 @RequestParam ("PageSize")Integer PageSize);

	/**
	 * 按帖子下载
	 *
	 * @return
	 */
	@ApiOperation("论坛统计-按帖子统计下载")
	@GetMapping("/statisticsForum/download")
	public String download(@RequestBody Map map);
}
