package com.yizhi.statistics.application.feign;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.statistics.application.request.point.StatisticsPointDetailQO;
import com.yizhi.statistics.application.request.point.StatisticsPointQO;
import com.yizhi.statistics.application.vo.point.StatisticsPointDetailVO;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * @ClassName: StatisticsPointClient
 * @author: zjl
 * @date: 2021/1/25  15:40
 */
@FeignClient(name="statistics", contextId = "StatisticsPointClient")
public interface StatisticsPointClient {

    @PostMapping("/statistics/point/detail/get")
    @ApiOperation("获取用户积分明细")
    public Page<StatisticsPointDetailVO> getStatisticsPoint(@RequestBody StatisticsPointDetailQO qo);

    @PostMapping("/statistics/point/detail/export")
    @ApiOperation("导出用户积分明细")
    public String exportStatisticsPoint(@RequestBody StatisticsPointDetailQO qo);

    @PostMapping("/statistics/point/export")
    @ApiOperation("导出所有用户积分明细")
    public String exportAllStatisticsPoint(@RequestBody StatisticsPointQO qo);

    /**
     * 同步积分明细数据
     */
    @GetMapping("/statistics/point/sync/details")
    void syncPointDetails(@RequestParam(name = "startDate",required = false) String startDate,
                                 @RequestParam(name = "endDate",required = false) String endDate ,
                                 @RequestParam(name = "companyId",required = false) Long companyId ,
                                 @RequestParam(name = "siteId",required = false) Long siteId);
}
