package com.yizhi.statistics.application.feign;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.statistics.application.request.practice.PracticeByOrgPageReq;
import com.yizhi.statistics.application.request.practice.PracticeReportByUserReq;
import com.yizhi.statistics.application.vo.practice.PracticeReportByUserListVo;
import com.yizhi.statistics.application.vo.practice.PracticeStatByOrgVo;
import com.yizhi.util.application.page.PageInfo;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

/**
 * @ClassName: StatisticsPracticeClient
 * @author: lvjh
 * @date: 2020/11/11  10:29
 */
@FeignClient(name = "statistics", contextId = "StatisticsPracticeByOrgClient",path = "/statistics/practice/org")
public interface StatisticsPracticeByOrgClient {


    /**
     * 按部门分页查询
     * @param param
     * @return
     */
    @PostMapping("/list/page")
    public PageInfo<PracticeStatByOrgVo> groupByOrgPage(@RequestBody PracticeByOrgPageReq param);

    /**
     * 按部门详情分页查询
     * @param param
     * @return
     */
    @PostMapping("/list/detail/page")
    public Page<PracticeReportByUserListVo> getDetailByOrgIdPage(@RequestBody PracticeReportByUserReq param);

    /**
     * 按部门 导出列表
     * @param param
     * @return
     */
    @PostMapping("/list/page/export")
    public String groupByOrgExport(@RequestBody PracticeByOrgPageReq param);

    /**
     *  按部门详情导出
     * @param param
     * @return
     */
    @PostMapping("/list/detail/page/export")
    public String getDetailByOrgIdPageExport(@RequestBody PracticeReportByUserReq param);

    /**
     * 按部门详情-用户导出
     * @param param
     * @return
     */
    @PostMapping("/list/user/detail/page/export")
    public String getUserDetailByOrgIdPageExport(@RequestBody PracticeReportByUserReq param);


}
