package com.yizhi.statistics.application.feign;

import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.statistics.application.request.practice.PracticeReportByUserDetailReq;
import com.yizhi.statistics.application.request.practice.PracticeReportByUserReq;
import com.yizhi.statistics.application.vo.practice.PracticeReportByUserDetailVo;
import com.yizhi.statistics.application.vo.practice.PracticeReportByUserListVo;

/**
 * 
 * @author xiaoyu
 *
 */
@FeignClient(name = "statistics", contextId = "StatisticsPracticeByUserClient")
public interface StatisticsPracticeByUserClient {
	
	/**
	 * 智能演练-报表-按用户-列表
	 * @param param
	 * @return
	 */
	@PostMapping("/statistics/practice/account/list/get")
	public Page<PracticeReportByUserListVo> list(@RequestBody PracticeReportByUserReq param);
	
	/**
	 * 智能演练-报表-按用户-列表-下载
	 * @param param
	 * @return
	 */
	@PostMapping("/statistics/practice/account/list/download")
	public String listDownload(@RequestBody PracticeReportByUserReq param);
	
	/**
	 * 智能演练-报表-按用户-详情
	 * @param param
	 * @return
	 */
	@PostMapping("/statistics/practice/account/detail/get")
	public Page<PracticeReportByUserDetailVo> detail(@RequestBody PracticeReportByUserDetailReq param);
	
	/**
	 * 智能演练-报表-按用户-详情-下载
	 * @param param
	 * @return
	 */
	@PostMapping("/statistics/practice/account/detail/download")
	public String detailDownload(@RequestBody PracticeReportByUserDetailReq param);
	
}
