package com.yizhi.statistics.application.feign;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.statistics.application.request.practice.PracticeStatByPracticeIdReq;
import com.yizhi.statistics.application.request.practice.PracticeStatByPracticeReq;
import com.yizhi.statistics.application.vo.practice.PracticeStatByPracticeVo;
import com.yizhi.statistics.application.vo.practice.PracticeStatViewByIdVo;
import com.yizhi.util.application.domain.BizResponse;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.text.ParseException;

/**
 * @ClassName: StatisticsPracticeClient
 * @author: zjl
 * @date: 2020/11/11  10:29
 */
@FeignClient(name = "statistics", contextId = "StatisticsPracticeClient")
public interface StatisticsPracticeClient {

    /**
     * 智能陪练统计-按陪练统计
     * @param req
     * @return
     */
    @PostMapping("/statistics/practice/group/list")
    public Page<PracticeStatByPracticeVo> practiceGroup(@RequestBody PracticeStatByPracticeReq req);

    /**
     * 智能陪练统计-按陪练统计-按陪练统计下载
     * @param req
     * @return
     */
    @PostMapping("/statistics/practice/group/list/download")
    public String practiceGroupDownload(@RequestBody PracticeStatByPracticeReq req);

    /**
     * 智能陪练统计-按陪练统计-详情
     * @param req
     * @return
     */
    @PostMapping("/statistics/practice/group/view/list")
    public Page<PracticeStatViewByIdVo> practiceGroupView(@RequestBody PracticeStatByPracticeIdReq req);


    /**
     * 智能陪练统计-按陪练统计-详情-下载陪练结果明细
     * @param req
     * @return
     */
    @PostMapping("/statistics/practice/group/view/list/download")
    public String practiceGroupViewDownload(@RequestBody PracticeStatByPracticeIdReq req);

    /**
     * 智能陪练统计-按陪练统计-详情-下载陪练明细
     * @param req
     * @return
     */
    @PostMapping("/statistics/practice/group/view/list/detail/download")
    public String practiceGroupViewDetailDownload(@RequestBody PracticeStatByPracticeIdReq req);
}
