package com.yizhi.statistics.application.feign;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.statistics.application.entity.StatisticsResearch;
import com.yizhi.statistics.application.vo.research.DownloadParamsVo;
import com.yizhi.statistics.application.vo.research.ResearchGroupViewVo;
import com.yizhi.statistics.application.vo.research.ResearchGroupVo;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

@FeignClient (name = "statistics", contextId = "StatisticsResearchReportClient")
public interface StatisticsResearchReportClient {
    /**
     * 异步加载统计
     *
     * @param startDate
     * @param endDate
     * @return
     */
    @GetMapping ("/statisticsReport/asynchronous/load/data/research")
    public String asynchronousResearch(@RequestParam ("startDate") String startDate, @RequestParam ("endDate") String endDate);

    @GetMapping ("/statisticsResearchLearnMetadata/group")
    Page<ResearchGroupVo> researchGroup(@RequestParam (name = "startDate", required = false) String startDate,
                                        @RequestParam (name = "endDate", required = false) String endDate,
                                        @RequestParam (name = "kwd", required = false) String kwd,
                                        @RequestParam (name = "pageSize", required = false, defaultValue = "10") Integer pageSize,
                                        @RequestParam (name = "pageNo", required = false, defaultValue = "1") Integer pageNo,
                                        @RequestParam (name = "companyId", required = true) Long companyId,
                                        @RequestParam (name = "orgIds", required = false) List<Long> orgIds,
                                        @RequestParam (name = "siteId", required = true) Long siteId);

    @GetMapping ("/statisticsResearchLearnMetadata/group/view")
    Page<ResearchGroupViewVo> researchGroupView(
            @RequestParam (name = "startDate", required = false) String startDate,
            @RequestParam (name = "endDate", required = false) String endDate,
            @RequestParam (name = "researchId", required = true) Long researchId,
            @RequestParam (name = "orgNameorOrgCode", required = false) String orgNameorOrgCode,
            @RequestParam (name = "accountName", required = false) String accountName,
            @RequestParam (name = "state", required = false) Integer state,
            @RequestParam (name = "pageSize", required = false, defaultValue = "10") Integer pageSize,
            @RequestParam (name = "pageNo", required = false, defaultValue = "1") Integer pageNo);


    @PostMapping ("/statisticsResearchLearnMetadata/accounts/Excel")
    public String reportResearchAccounts(@RequestBody DownloadParamsVo vo);

    @ApiOperation (value = "导出调研明细", notes = "导出调研明细")
    @PostMapping ("/statisticsResearchLearnMetadata/details/Excel")
    public String reportResearchDetails(@RequestBody DownloadParamsVo vo);

    @PostMapping("/statisticsResearchLearnMetadata/analyze/Excel")
    public String reportResearchanalyze(@RequestBody DownloadParamsVo vo);

    @GetMapping ("/statisticsResearch/view")
    public StatisticsResearch viewOne(@RequestParam ("id") Long id);


}


