package com.yizhi.statistics.application.feign;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.statistics.application.refactor.*;
import com.yizhi.statistics.application.training.vo.TrainingProjectGroupParam;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;

@FeignClient(name="statistics", contextId = "StatisticsTrainingClient")
public interface StatisticsTrainingClient {
	
      @PostMapping("/statisticsTraining/chart/group/new")
      public List<TrainingProjectDataChartsVO> chartGroup(@RequestBody TrainingProjectGroupParam trainingGroupParam);
    
	  @PostMapping("/statisticsTraining/group")
	  public Page<ReportStudyTrainingProjectVo> trainingGroup(@RequestBody TrainingProjectGroupParam trainingGroupParam);
	  
	  @PostMapping("/statisticsTraining/group/excel")
	  public void trainingGroupExcel(@RequestBody TrainingProjectGroupParam trainingGroupParam);
	  
	  @PostMapping("/statisticsTraining/group/view")
	  public Page<TrainingProjectDataChartsVO> trainingProjectGroupView(@RequestBody TrainingProjectGroupParam trainingGroupParam);
	
	  @PostMapping("/statisticsTraining/group/view/excel1")
	  public void trainingProjectGroupViewExcel1(@RequestBody TrainingProjectGroupParam trainingGroupParam);
	  
	  @PostMapping("/statisticsTraining/group/view/excel2")
	  public void trainingProjectGroupViewExcel2(@RequestBody TrainingProjectGroupParam trainingGroupParam);
	  
	  @PostMapping("/statisticsTraining/group/view/excel3")
	  public void trainingProjectGroupViewExcel3(@RequestBody TrainingProjectGroupParam trainingGroupParam);
	  
	  @PostMapping("/statisticsTraining/account/group")
	  public Page<ReportStudyTrainingProjectAccountVo> trainingProjectAccountGroup(@RequestBody TrainingProjectGroupParam trainingGroupParam);
	  
	  @PostMapping("/statisticsTraining/account/group/excel")
	  public void trainingProjectAccountGroupExcel(@RequestBody TrainingProjectGroupParam trainingGroupParam);
	  
	  @PostMapping("/statisticsTraining/account/group/view")
	  public Page<ReportStudyTrainingProjectAccountViewVo> trainingProjectAccountGroupView(@RequestBody TrainingProjectGroupParam trainingGroupParam);
	  
	  @PostMapping("/statisticsTraining/account/group/view/excel")
	  public void trainingProjectAccountGroupViewExcel(@RequestBody TrainingProjectGroupParam trainingGroupParam);
	  
	  @PostMapping("/statisticsTraining/org/group")
	  public Page<ReportStudyTrainingProjectOrgVo> trainingProjectOrgGroup(@RequestBody TrainingProjectGroupParam trainingGroupParam);
	  
	  @PostMapping("/statisticsTraining/org/group/excel")
	  public void trainingProjectOrgGroupExcel(@RequestBody TrainingProjectGroupParam trainingGroupParam);
}
