package com.yizhi.statistics.application.feign;

import com.yizhi.core.application.context.RequestContext;
import com.yizhi.statistics.application.vo.report.ReportDetailVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

@FeignClient(name="statistics", contextId = "StudentReportClient")
public interface StudentReportClient {

	@GetMapping("/api/report/save")
	public void save(@RequestParam("type") Integer type);
	
	@GetMapping("/api/report/get")
	public ReportDetailVO get(@RequestParam("reportId") Long reportId,@RequestParam("siteId") Long siteId,@RequestParam("companyId") Long companyId,@RequestParam("accountId") Long accountId);
	
	@GetMapping("/api/report/list")
	public List<ReportDetailVO> list();
	
	@GetMapping("/api/report/view")
	public Boolean view(@RequestParam("reportId") Long reportId);
	
	@PostMapping("/api/report/getMyReportNum")
	public Integer getMyReportNum(@RequestBody RequestContext context);
}
