package com.yizhi.statistics.application.refactor;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * @Date 2020/10/9 8:48 上午
 * @Author lvjianhui
 **/
@Data
@ApiModel
public class TrResearchAnswerQuestionResultVO {

    @ApiModelProperty(value = "答案ID，主键")
    private Long id;

    @ApiModelProperty(value = "冗余调研id")
    private Long researchId;

    @ApiModelProperty(value = "冗余answerId")
    private Long answerId;

    @ApiModelProperty(value = "答案题目_ID，外键")
    @TableField("answer_question_id")
    private Long answerQuestionId;

    @ApiModelProperty(value = "问题类型，1单选题、2多选题、3问答题、4打分题")
    private Integer questionType;

    @ApiModelProperty(value = "单选题和多选题，存放问题选中选项的ID")
    private Long optionId;

    @ApiModelProperty(value = "问答题，存放回答内容（question_type=3）")
    private String content;

    @ApiModelProperty(value = "打分题，学员给的分值")
    private Integer score;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "创建人ID")
    private Long createById;

    @ApiModelProperty(value = "创建人姓名")
    private String createByName;

    @ApiModelProperty(value = "修改时间")
    private Date updateTime;

    @ApiModelProperty(value = "修改人ID")
    private Long updateById;

    @ApiModelProperty(value = "修改人姓名")
    private String updateByName;
}
