package com.yizhi.statistics.application.refactor.sign;


import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

@Data
@Api(tags = "StatisticsSign", description = "签到统计表")
@TableName("statistics_sign_metadata")
public class StatisticsSignVO {

    @ApiModelProperty(value = "自增")
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    @ApiModelProperty(value = "签到id")
    @TableField("sign_id")
    private Long signId;

    @ApiModelProperty(value = "签到时间段id")
    @TableField("sign_time_id")
    private Long signTimeId;

    @ApiModelProperty(value = "培训项目id")
    @TableField("trainning_project_id")
    private Long trainningProjectId;


    @ApiModelProperty(value = "签到编号")
    @TableField("sign_no")
    private String signNo;

    @ApiModelProperty(value = "签到名称")
    @TableField("sign_name")
    private String signName;

    @ApiModelProperty(value = "培训项目名称")
    @TableField("trainning_project_name")
    private String trainningProjectName;

    @ApiModelProperty(value = "签到开始时间")
    @TableField("sign_start_time")
    private Date signStartTime;

    @ApiModelProperty(value = "签到结束时间")
    @TableField("sign_end_time")
    private Date signEndTime;

    @ApiModelProperty(value = "创建签到的公司Id")
    @TableField("sign_company_id")
    private Long signCompanyId;

    @ApiModelProperty(value = "创建签到的组织id")
    @TableField("sign_org_id")
    private Long signOrgId;

    @ApiModelProperty(value = "创建签到的站点id")
    @TableField("sign_site_id")
    private Long signSiteId;

    @ApiModelProperty(value = "签到创建时间")
    @TableField("sign_create_time")
    private Date signCreateTime;

    @ApiModelProperty(value = "项目创建时间")
    @TableField("project_create_time")
    private Date projectCreateTime;

    @ApiModelProperty(value = "用户id")
    @TableField("account_id")
    private Long accountId;

    @ApiModelProperty(value = "用户编号")
    @TableField("account_work_num")
    private String accountWorkNum;

    @ApiModelProperty(value = "用户名")
    @TableField("account_name")
    private String accountName;

    @ApiModelProperty(value = "用户姓名")
    @TableField("account_fullname")
    private String accountFullname;

    @ApiModelProperty(value = "用户状态")
    @TableField("account_state")
    private Integer accountState;

    @ApiModelProperty(value = "用户公司id")
    @TableField("account_company_id")
    private Long accountCompanyId;

    @ApiModelProperty(value = "用户组织id")
    @TableField("account_org_id")
    private Long accountOrgId;

    @ApiModelProperty(value = "用户站点id")
    @TableField("account_site_id")
    private Long accountSiteId;

    @ApiModelProperty(value = "签到时间")
    @TableField("sign_time")
    private Date signTime;

    @ApiModelProperty(value = "用户组织名称")
    @TableField("org_name")
    private String orgName;

    @ApiModelProperty(value = "用户所有父类组织")
    @TableField("org_parent_names")
    private String orgParentNames;

    @ApiModelProperty(value = "应签到")
    @TableField("can_state")
    private Integer canState;

    @ApiModelProperty(value = "实际签到")
    @TableField("join_state")
    private Integer joinState;

    @ApiModelProperty(value = "应签到人数")
    @TableField(exist = false)
    private Integer canStateCount;

    @ApiModelProperty(value = "实际签到人数")
    @TableField(exist = false)
    private Integer joinStateCount;

    @ApiModelProperty(value = "未签到人数")
    @TableField(exist = false)
    private Integer notSignCount;

    @ApiModelProperty(value = "签到地点")
    @TableField("address")
    private String address;

    @ApiModelProperty(value = "签到范围")
    @TableField("range")
    private String range;
}

