package com.yizhi.statistics.application.request.point;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @ClassName: StatisticsPointDetailQO
 * @author: zjl
 * @date: 2021/1/25  10:31
 */
@Data
@ApiModel("积分个人明细入参")
public class StatisticsPointDetailQO implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "用户id", required = true)
    private Long accountId;

    private Integer pageNo = 1;

    private Integer pageSize = 10;

    @ApiModelProperty(value = "开始日期", required = true)
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss" , timezone = "GMT+8")
    private Date startAt;

    @ApiModelProperty(value = "结束日期", required = true)
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss" , timezone = "GMT+8")
    private Date endAt;

    @ApiModelProperty("变动类型（10：在线课程  20：线下课程30：项目 40：考试 50：作业 60：调研 " +
            "70：原创活动 80：打卡 90：论坛 100：签到 110：外部导入 120：陪练")
    private Integer changeType;
}
