package com.yizhi.statistics.application.request.point;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @ClassName: StatisticsPointQO
 * @author: zjl
 * @date: 2021/1/25  14:09
 */
@Data
@ApiModel("积分所有明细入参")
public class StatisticsPointQO implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "部门关键字")
    private String orgKwd;

    @ApiModelProperty(value = "用户关键字")
    private String accountKwd;

    @ApiModelProperty(value = "开始日期", required = true)
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss" , timezone = "GMT+8")
    private Date startAt;

    @ApiModelProperty(value = "结束日期", required = true)
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss" , timezone = "GMT+8")
    private Date endAt;

    private Integer pageNo = 1;

    private Integer pageSize = 10;
}
