package com.yizhi.statistics.application.vo.practice;

import java.util.Date;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Builder;
import lombok.Data;
import lombok.experimental.Tolerate;

@Data
@Builder
@ApiModel(value = "PracticeReportByUserDetailVo", description = "智能演练-报表-按用户统计-详情页面结果")
public class PracticeReportByUserDetailVo {

	@ApiModelProperty(value = "用户ID")
	private Long accountId;
	
	@ApiModelProperty(value = "用户名")
	private String account;
	
	@ApiModelProperty(value = "部门ID")
	private Long departId;
	
	@ApiModelProperty(value = "部门名称")
	private String depart;
	
	@ApiModelProperty(value = "姓名")
	private String userName;
	
	@ApiModelProperty(value = "陪练名称")
	private String practiceName;
	
	@ApiModelProperty(value = "陪练模式  10:训练 20:考核")
	private Integer practiceMode;
	
	@ApiModelProperty(value = "陪练级别 10:初级 40:中级 80:高级")
	private Integer practiceLevel;
	
	@ApiModelProperty(value = "完成时间")
	private Date endAt;
	
	@ApiModelProperty(value = "得分")
	private Integer score;
	
	@ApiModelProperty(value = "考核结果 80:通过，10:未通过")
	private Integer result;
	
	@ApiModelProperty(value = "所在组织架构")
	private String orgInfo;

	@Tolerate
	public PracticeReportByUserDetailVo() {
		super();
	}
}
