package com.yizhi.statistics.application.vo.practice;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Builder;
import lombok.Data;
import lombok.experimental.Tolerate;

@Data
@Builder
@ApiModel(value = "PracticeReportByUserResultVo", description = "智能演练-报表-按用户统计-list页面结果")
public class PracticeReportByUserListVo {

	@ApiModelProperty(value = "用户ID")
	private Long accountId;
	
	@ApiModelProperty(value = "用户名")
	private String account;
	
	@ApiModelProperty(value = "部门ID")
	private Long departId;
	
	@ApiModelProperty(value = "部门名称")
	private String depart;
	
	@ApiModelProperty(value = "姓名")
	private String userName;
	
	@ApiModelProperty(value = "应参加训练数")
	private Integer practiceNumberShould;
	
	@ApiModelProperty(value = "实际参加训练数")
	private Integer practiceNumberActual;
	
	@ApiModelProperty(value = "训练次数")
	private Integer practiceCount;
	
	@ApiModelProperty(value = "应参加考核数")
	private Integer examNumberShould;
	
	@ApiModelProperty(value = "实际参加考核数")
	private Integer examNumberActual;
	
	@ApiModelProperty(value = "考核次数")
	private Integer examCount;
	
	@ApiModelProperty(value = "已通过考核数")
	private Integer examNumberPassed;
	
	@ApiModelProperty(value = "通过率，单位:%")
	private Integer passRate;
	
	@ApiModelProperty(value = "所在组织架构")
	private String orgInfo;

	@Tolerate
	public PracticeReportByUserListVo() {
		super();
	}
}
