package com.yizhi.statistics.application.vo.practice;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * @Date 2020/11/12 2:31 下午
 * @Author lvjianhui
 **/
@ApiModel
public class PracticeStatByOrgVo {

    @ApiModelProperty("部门名")
    private String orgName;

    private Long orgId;

    private String orgCode;

    @ApiModelProperty("可参加训练数")
    private Long planJoinPracticeCount = 0L;

    @ApiModelProperty("可参加训练人数")
    private Long planJoinPracticeUserCount = 0L;

    @ApiModelProperty("实际参加训练人次")
    private Long actualJoinPracticeUserCount = 0L;

    @ApiModelProperty("可划参加考核数")
    private Long planJoinExamCount = 0L;

    @ApiModelProperty("可参加考核用户数")
    private Long planJoinExamUserCount = 0L;

    @ApiModelProperty("实际参加考核人次")
    private Long actualJoinExamUserCount = 0L;

    @ApiModelProperty("通过考试数")
    private Long examPassUserCount = 0L;

    @ApiModelProperty("考试通过率")
    private Long examPassRate = 0L;

    public Long getOrgId() {
        return orgId;
    }

    public void setOrgId(Long orgId) {
        this.orgId = orgId;
    }

    public String getOrgCode() {
        return orgCode;
    }

    public void setOrgCode(String orgCode) {
        this.orgCode = orgCode;
    }

    public String getOrgName() {
        return orgName;
    }

    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    public Long getPlanJoinPracticeCount() {
        return planJoinPracticeCount;
    }

    public void setPlanJoinPracticeCount(Long planJoinPracticeCount) {
        this.planJoinPracticeCount = planJoinPracticeCount;
    }

    public Long getPlanJoinPracticeUserCount() {
        return planJoinPracticeUserCount;
    }

    public void setPlanJoinPracticeUserCount(Long planJoinPracticeUserCount) {
        this.planJoinPracticeUserCount = planJoinPracticeUserCount;
    }

    public Long getActualJoinPracticeUserCount() {
        return actualJoinPracticeUserCount;
    }

    public void setActualJoinPracticeUserCount(Long actualJoinPracticeUserCount) {
        this.actualJoinPracticeUserCount = actualJoinPracticeUserCount;
    }

    public Long getPlanJoinExamCount() {
        return planJoinExamCount;
    }

    public void setPlanJoinExamCount(Long planJoinExamCount) {
        this.planJoinExamCount = planJoinExamCount;
    }

    public Long getPlanJoinExamUserCount() {
        return planJoinExamUserCount;
    }

    public void setPlanJoinExamUserCount(Long planJoinExamUserCount) {
        this.planJoinExamUserCount = planJoinExamUserCount;
    }

    public Long getActualJoinExamUserCount() {
        return actualJoinExamUserCount;
    }

    public void setActualJoinExamUserCount(Long actualJoinExamUserCount) {
        this.actualJoinExamUserCount = actualJoinExamUserCount;
    }

    public Long getExamPassUserCount() {
        return examPassUserCount;
    }

    public void setExamPassUserCount(Long examPassUserCount) {
        this.examPassUserCount = examPassUserCount;
    }

    public Long getExamPassRate() {
        if (examPassUserCount == null || actualJoinExamUserCount == null || actualJoinExamUserCount == 0 || examPassUserCount == 0) {
            return 0L;
        }
       return (examPassUserCount * 100) / actualJoinExamUserCount;
    }

    public void setExamPassRate(Long examPassRate) {
        if (examPassUserCount == null || actualJoinExamUserCount == null || actualJoinExamUserCount == 0 || examPassUserCount == 0) {
            this.examPassRate = 0L;
            return;
        }
        this.examPassRate = (examPassUserCount * 100) / actualJoinExamUserCount;
    }
}
