package com.yizhi.statistics.application.vo.practice;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

@Data
@ApiModel(value = "PracticeStatByPracticeVo")
public class PracticeStatByPracticeVo {

    @ApiModelProperty(value = "陪练id")
    private Long practiceId;
    
    @ApiModelProperty(value = "陪练名称")
    private String name;

    @ApiModelProperty(value = "80:训练+考核 ,10:训练 20:考核")
    private Integer useType;

    @ApiModelProperty(value = "练习开始时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private Date practiceStartAt;

    @ApiModelProperty(value = "练习结束时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private Date practiceEndAt;

    @ApiModelProperty(value = "考核开始时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private Date examStartAt;

    @ApiModelProperty(value = "考核结束时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private Date examEndAt;

    @ApiModelProperty(value = "可参加人数")
    private Integer canJoinCount;

    @ApiModelProperty(value = "训练人数")
    private Integer practiceTrainingCount;

    @ApiModelProperty(value = "训练参与率")
    private String practiceTrainingRate;

    @ApiModelProperty(value = "考核人数")
    private Integer practiceTestCount;

    @ApiModelProperty(value = "考核通过人数")
    private Integer practiceTestPassCount;

    @ApiModelProperty(value = "通过率")
    private String practiceTestPassRate;

    @ApiModelProperty(value = "考核平均分")
    private String practiceTestAverage;

    @ApiModelProperty(value = "考核完成率")
    private String practiceTestDoneRate;

}
