package com.yizhi.statistics.application.commands;

import java.util.Date;

/**
 * 报表统计具体任务接口，写具体的统计逻辑
 * 
 * @author meicz
 *
 */
public interface IStatisticsMetadataTask<T> {
	
	/**
	 * 实现业务统计逻辑
	 * @param metadataObject	具体业务对象
	 * @param startDate			统计开始日期
	 * @param endDate			统计结束日期
	 * @param companId			企业ID
	 * @param siteId			站点ID
	 * @param orgId				组织ID
	 * @param accounts			应参加人员
	 */
	public void executeMetadata(Long taskId,T metadataObject, Date startDate, Date endDate, Long companId, Long siteId);
	
	/**
	 * 线程执行异常，记录异常日志信息
	 * @param metadataObject 	具体业务对象
	 * @param e 				异常
	 */
	public void exceptionLog(Long taskId,T metadataObject, Exception e);
}
