package com.yizhi.statistics.application.controller.album;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.statistics.application.album.vo.*;
import com.yizhi.statistics.application.controller.album.export.*;
import com.yizhi.statistics.application.service.IStatisticsAlbumActivityRecordService;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/statisticsAlbum")
public class AlbumController {

	private Logger logger = LoggerFactory.getLogger(AlbumController.class);
	
	@Autowired
	private IStatisticsAlbumActivityRecordService statisticsAlbumActivityRecordService;
	
	@Autowired
	private AlbumGroupExport albumGroupExport;
	
	@Autowired
	private AlbumGroupViewExport1 albumGroupViewExport1;
	
	@Autowired
	private AlbumGroupViewExport2 albumGroupViewExport2;
	
	@Autowired
	private AlbumGroupViewExport3 albumGroupViewExport3;
	
	@Autowired
	private AlbumAccountGroupExport albumAccountGroupExport;
	
	@Autowired
	private AlbumAccountGroupViewExport albumAccountGroupViewExport;
	@Autowired
	AlbumControllerAbs albumControllerAbs;
	
	@PostMapping("/chart/group")
	public List<ReportStudyAlbumChartsVo> chartGroup(@RequestBody AlbumGroupParam albumGroupParam) {
		return statisticsAlbumActivityRecordService.chartGroup(albumGroupParam.getStartDate(),albumGroupParam.getEndDate() , albumGroupParam.getCompanyId(),albumGroupParam.getSiteId() ,albumGroupParam.getAdminId() ,albumGroupParam.getIsAdmin() );
	}

	@PostMapping("/group")
	public Page<ReportStudyAlbumVo> albumGroup(@RequestBody AlbumGroupParam albumGroupParam){
		return statisticsAlbumActivityRecordService.albumGroup(albumGroupParam.getKwd(), albumGroupParam.getStartDate(), albumGroupParam.getEndDate(), albumGroupParam.getCompanyId(), albumGroupParam.getSiteId(), albumGroupParam.getPageNo(), albumGroupParam.getPageSize(), albumGroupParam.getAdminId(), albumGroupParam.getIsAdmin());
	}
	
	@PostMapping("/group/excel")
	public void albumGroupExport(@RequestBody AlbumGroupParam albumGroupParam) {
		albumGroupExport.execute(albumGroupParam, true);
	}
	
	@PostMapping("/group/view")
	public List<ReportStudyAlbumViewVo2> albumGroupView(@RequestBody AlbumGroupParam albumGroupParam){
		return statisticsAlbumActivityRecordService.albumGroupView(albumGroupParam.getAlbumId(), albumGroupParam.getStartDate(), albumGroupParam.getEndDate(), albumGroupParam.getCompanyId(), albumGroupParam.getSiteId(), albumGroupParam.getAdminId(),albumGroupParam.getIsAdmin());
	}
	
	@PostMapping("/group/view/export1")
	public void albumGroupViewExport1(@RequestBody AlbumGroupParam albumGroupParam) {
		albumGroupViewExport1.execute(albumGroupParam, true);
	}
	
	@PostMapping("/group/view/export2")
	public void albumGroupViewExport2(@RequestBody AlbumGroupParam albumGroupParam) {
		albumGroupViewExport2.execute(albumGroupParam, true);
	}
	
	@PostMapping("/group/view/export3")
	public void albumGroupViewExport3(@RequestBody AlbumGroupParam albumGroupParam) {
		albumGroupViewExport3.execute(albumGroupParam, true);
	}
	
	@PostMapping("/account/group")
	public Page<ReportStudyAlbumAccountVo> albumAccountGroup(@RequestBody AlbumGroupAccountParam albumGroupAccountParam){
		return statisticsAlbumActivityRecordService.albumAccountGroup(albumGroupAccountParam.getOrgKwd(), albumGroupAccountParam.getAccountKwd(), albumGroupAccountParam.getStartDate(), albumGroupAccountParam.getEndDate(), albumGroupAccountParam.getCompanyId(), albumGroupAccountParam.getSiteId(),albumGroupAccountParam.getPageNo() , albumGroupAccountParam.getPageSize(), albumGroupAccountParam.getAdminId(),albumGroupAccountParam.getIsAdmin());
	}
	
	@PostMapping("/account/group/export")
	public void albumAccountGroupExport(@RequestBody AlbumGroupAccountParam albumGroupAccountParam) {
		albumAccountGroupExport.execute(albumGroupAccountParam, true);
	}
	
	@PostMapping("/account/group/view")
	public Page<ReportStudyAlbumAccountViewVo> albumAccountGroupView(@RequestBody AlbumGroupAccountParam albumGroupAccountParam){
		return statisticsAlbumActivityRecordService.albumAccountGroupView(albumGroupAccountParam.getCompanyId(), albumGroupAccountParam.getAccountId(), albumGroupAccountParam.getSiteId(), albumGroupAccountParam.getAlbumKwd(), albumGroupAccountParam.getStartDate(), albumGroupAccountParam.getEndDate(), albumGroupAccountParam.getPageNo(), albumGroupAccountParam.getPageSize(), albumGroupAccountParam.getAdminId(),albumGroupAccountParam.getIsAdmin());
	}
	
	@PostMapping("/account/group/view/export")
	public void albumAccountGroupViewExport(@RequestBody AlbumGroupAccountParam accountParam) {
		albumAccountGroupViewExport.execute(accountParam, true);
	}

	@GetMapping("/manual/import/album/data")
	@ApiOperation(value = "手动导入报表专辑相关数据")
	public void albumManualImport(@RequestParam(value = "startDate",required = false) String startDate,
								  @RequestParam(value = "endDate",required = false) String endDate,
								  @RequestParam(value = "siteId",required = false) Long siteId,
								  @RequestParam(value = "companyId",required = false) Long companyId
								  ) {
		logger.info("===手动导入专辑数据入参: startDate={} ,endDate = {} ,siteId={} ,companyId={} ",startDate,endDate,siteId,companyId);

		Map<String,Object> map=new HashMap<String,Object>();

		if (StringUtils.isNotBlank(startDate)) {
			map.put("startDate", startDate);
		}
		if (StringUtils.isNotBlank(endDate)) {
			map.put("endDate", endDate);
		}
		if(companyId!=null) {
			map.put("companyId", companyId);
		}
		if(siteId!=null) {
			map.put("siteId", siteId);
		}
		albumControllerAbs.execute(map,true);
	}
}
