package com.yizhi.statistics.application.controller.course;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.statistics.application.course.export.*;
import com.yizhi.statistics.application.course.vo.*;
import com.yizhi.statistics.application.service.StatisticsCourseRecordeService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("/statisticsCourse")
public class CourseController {

			private Logger logger = LoggerFactory.getLogger(CourseController.class);
		
			@Autowired
			StatisticsCourseRecordeService statisticsCourseRecordeService;
		
			@Autowired
			CourseGroupExportExcel courseGroupExportExcel;
		
			@Autowired
			CourseGroupViewExportExcel courseGroupViewExportExcel;
		
			@Autowired
			CourseAccountGroupExportExcel courseAccountGroupExportExcel;
		
			@Autowired
			CourseAccountGroupViewExportExcel courseAccountGroupViewExportExcel;
		
			@Autowired
			CourseAccountGroupDetailsExportExcel courseAccountGroupDetailsExportExcel;
		
			@Autowired
			CourseOrgGroupExportExcel courseOrgGroupExportExcel;
		
			@GetMapping("/chart/group")
			public List<ReportStudyCourseChartsVo> chartGroup(@RequestParam("startDate") String startDate,
					@RequestParam("endDate") String endDate, @RequestParam("companyId") Long companyId,
					@RequestParam("siteId") Long siteId, @RequestParam("adminId") Long adminId,
					@RequestParam("isAdmin") Boolean isAdmin) {
				
				RequestContext requestContext = ContextHolder.get();
				
				List<ReportStudyCourseChartsVo> list = null;
				if(requestContext.getCompanyId().compareTo(1067032163482787840L) == 0){
					//江苏银行效率慢，待优化好放开查询
					list = new ArrayList<ReportStudyCourseChartsVo>();
				} else {
					list = statisticsCourseRecordeService.chartGroup(startDate, endDate, companyId, siteId, adminId, isAdmin);
				}
				
				return list;
			}
		
			@PostMapping("/group")
			public Page<ReportStudyCourseVo> courseGroup(@RequestBody CourseGroupParam courseGroupExportExcelVo) {
				System.out.println(courseGroupExportExcelVo.toStringVO());
				logger.info(courseGroupExportExcelVo.toStringVO());
				return statisticsCourseRecordeService.courseGroup(courseGroupExportExcelVo.getKwd(),
						courseGroupExportExcelVo.getStartDate(), courseGroupExportExcelVo.getEndDate(),
						courseGroupExportExcelVo.getCompanyId(), courseGroupExportExcelVo.getSiteId(),
						courseGroupExportExcelVo.getIsAdmin(), courseGroupExportExcelVo.getAdminId(),
						courseGroupExportExcelVo.getPageNo(), courseGroupExportExcelVo.getPageSize());
			}
		
			@PostMapping("/group/excel")
			public void courseGroupExcel(@RequestBody CourseGroupParam courseGroupParam) {
				courseGroupExportExcel.execute(courseGroupParam, true);
			}
		
			@PostMapping("/group/view")
			public Page<ReportStudyCourseViewVo> CourseGroupView(@RequestBody CourseGroupViewParam courseGroupViewParam) {
				return statisticsCourseRecordeService.courseGroupView(courseGroupViewParam.getOrgKwd(),
						courseGroupViewParam.getAccountKwd(), courseGroupViewParam.getStartDate(),
						courseGroupViewParam.getEndDate(), courseGroupViewParam.getCourseId(), courseGroupViewParam.getPageNo(),
						courseGroupViewParam.getPageSize(), courseGroupViewParam.getCompanyId(),
						courseGroupViewParam.getSiteId(), courseGroupViewParam.getIsAdmin(), courseGroupViewParam.getAdminId());
			}
		
			@PostMapping("/group/view/excel")
			public void CourseGroupViewExcel(@RequestBody CourseGroupViewParam courseGroupViewParam) {
				courseGroupViewExportExcel.execute(courseGroupViewParam, true);
			}
		
			@PostMapping("/account/group")
			public Page<ReportStudyCourseAccountVo> courseAccountGroup(
					@RequestBody CourseAccountGroupParam courseAccountGroupParam) {
				String accountKwdTrim = null;
				String orgKwdTrim = null;
				if (courseAccountGroupParam != null && courseAccountGroupParam.getAccountKwd() != null
						&& courseAccountGroupParam.getAccountKwd().length() > 0) {
					accountKwdTrim = courseAccountGroupParam.getAccountKwd().trim();
					if (accountKwdTrim.length() == 0) {
						accountKwdTrim = null;
					}
				}
				if (courseAccountGroupParam != null && courseAccountGroupParam.getOrgKwd() != null
						&& courseAccountGroupParam.getOrgKwd().length() > 0) {
					orgKwdTrim = courseAccountGroupParam.getOrgKwd().trim();
					if (orgKwdTrim.length() == 0) {
						orgKwdTrim = null;
					}
				}
		
				return statisticsCourseRecordeService.courseAccountGroup(orgKwdTrim, accountKwdTrim,
						courseAccountGroupParam.getStartDate(), courseAccountGroupParam.getEndDate(),
						courseAccountGroupParam.getCompanyId(), courseAccountGroupParam.getSiteId(),
						courseAccountGroupParam.getIsAdmin(), courseAccountGroupParam.getAdminId(),
						courseAccountGroupParam.getPageNo(), courseAccountGroupParam.getPageSize());
			}
		
			@PostMapping("/account/group/excel")
			public void courseAccountGroupExportExcel(@RequestBody CourseAccountGroupParam courseAccountGroupParam) {
				courseAccountGroupExportExcel.execute(courseAccountGroupParam, true);
			}
		
			@PostMapping("/account/details/export")
			public void courseAccountDetails(@RequestBody CourseAccountGroupParam courseAccountGroupParam) {
				courseAccountGroupDetailsExportExcel.execute(courseAccountGroupParam, true);
			}
		
			@PostMapping("/account/group/view")
			public Page<ReportStudyCourseAccountViewVo> courseAccountGroupView(
					@RequestBody CourseAccountGroupViewParam courseAccountGroupViewParam) {
				String kwdTrim = null;
				if (courseAccountGroupViewParam != null && courseAccountGroupViewParam.getKwd() != null
						&& courseAccountGroupViewParam.getKwd().length() > 0) {
					kwdTrim = courseAccountGroupViewParam.getKwd().trim();
					if (kwdTrim.length() == 0) {
						kwdTrim = null;
					}
				}
				return statisticsCourseRecordeService.courseAccountGroupView(courseAccountGroupViewParam.getCompanyId(),
						courseAccountGroupViewParam.getAccountId(), courseAccountGroupViewParam.getSiteId(), kwdTrim,
						courseAccountGroupViewParam.getStartDate(), courseAccountGroupViewParam.getEndDate(),
						courseAccountGroupViewParam.getPageNo(), courseAccountGroupViewParam.getPageSize());
			}
		
			@PostMapping("/account/group/view/export")
			public void courseAccountGroupViewExport(@RequestBody CourseAccountGroupViewParam courseAccountGroupViewParam) {
				courseAccountGroupViewExportExcel.execute(courseAccountGroupViewParam, true);
			}
		
			@PostMapping("/org/group")
			public Page<ReportStudyCourseOrgVo> courseOrgGroup(@RequestBody CourseOrgGroupParam courseOrgGroupParam) {
				String kwdTrim = null;
				if (courseOrgGroupParam != null && courseOrgGroupParam.getKwd() != null
						&& courseOrgGroupParam.getKwd().length() > 0) {
					kwdTrim = courseOrgGroupParam.getKwd().trim();
					if (kwdTrim.length() == 0) {
						kwdTrim = null;
					}
				}
				return statisticsCourseRecordeService.courseOrgGroup(kwdTrim, courseOrgGroupParam.getStartDate(),
						courseOrgGroupParam.getEndDate(), courseOrgGroupParam.getCompanyId(), courseOrgGroupParam.getSiteId(),
						courseOrgGroupParam.getPageNo(), courseOrgGroupParam.getPageSize(), courseOrgGroupParam.getIsAdmin(),
						courseOrgGroupParam.getAdminId());
			}
		
			@PostMapping("/org/group/export")
			public void courseOrgGroupExport(@RequestBody CourseOrgGroupParam courseOrgGroupParam) {
				courseOrgGroupExportExcel.execute(courseOrgGroupParam, true);
			}
}
