package com.yizhi.statistics.application.controller.course;

import com.yizhi.course.application.feign.CourseReportClient;
import com.yizhi.course.application.vo.ScormRecordVO;
import com.yizhi.point.application.feign.PointDetailsFeignClients;
import com.yizhi.statistics.application.course.vo.CourseAccountGroupParam;
import com.yizhi.statistics.application.mapper.StatisticsCourseRecordeMapper;
import com.yizhi.statistics.application.service.StatisticsCourseRecordeService;
import com.yizhi.system.application.constant.AuthzConstant;
import com.yizhi.system.application.feign.AuthFeignClient;
import com.yizhi.system.application.system.remote.OrganizationClient;
import com.yizhi.system.application.system.remote.ReportClient;
import com.yizhi.system.application.vo.HQAccountInManageParam;
import com.yizhi.system.application.vo.ReportAccountRespInManageVO;
import com.yizhi.system.application.vo.ReportAccountRespVO;
import com.yizhi.system.application.vo.ReportRangeAccountReqVO;
import com.yizhi.system.application.vo.domain.AuthzAccountRole;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;
import java.util.List;

@RestController
@RequestMapping("/wfd")
public class TestSystem {
	
	@Autowired
	private ReportClient reportClient;

	@Autowired 
	StatisticsCourseRecordeService statisticsCourseRecordeService;
	
	@Autowired
	OrganizationClient organizationClient;
	
	@Autowired
	StatisticsCourseRecordeMapper statisticsCourseRecordeMapper;
	
	@Autowired
	PointDetailsFeignClients pointDetailsFeignClients;
	
	@Autowired
	CourseController courseController;
	
	@GetMapping("/test")
	public void test() {
		CourseAccountGroupParam courseAccountGroupParam =new CourseAccountGroupParam();
		courseAccountGroupParam.setAdminId(1016616562352074752L);
		courseAccountGroupParam.setCompanyId(1016616562213662720L);
		courseAccountGroupParam.setSiteId(1016616562297548800L);
		courseAccountGroupParam.setStartDate("2019-04-01");
		courseAccountGroupParam.setEndDate("2019-08-22");
		courseAccountGroupParam.setTaskId(111L);
		courseAccountGroupParam.setSubmitTime(new Date());
		courseAccountGroupParam.setSerialNo("serialNo");
		courseAccountGroupParam.setTaskName("taskName");
		courseAccountGroupParam.setIsAdmin(true);
		courseAccountGroupParam.setIsAllData(false);
		courseController.courseAccountDetails(courseAccountGroupParam);

		
	}
	
	@Autowired
	private CourseReportClient courseReportClient;
	
	@GetMapping("/insert")
	public void insertIntoRe() {
		//课程得分
				List<ScormRecordVO> listTestCase=courseReportClient.getCourseGrade();
				statisticsCourseRecordeService.insertIntoCourseGrade(listTestCase);
	}

	@GetMapping("/point")
	public void point() {
		ReportRangeAccountReqVO rrarv= new ReportRangeAccountReqVO();
		rrarv.setSiteId(1016273921840132096L);
		List<ReportAccountRespVO> listSystem = reportClient.getRangeAccounts(rrarv);
	}
	
	
	@Autowired
	private AuthFeignClient authFeignClient;
	
	@GetMapping("/role")
	public void rle() {
		List<AuthzAccountRole> listAllAdmin=authFeignClient.getAllAdmin();
		for (AuthzAccountRole authzAccountRole : listAllAdmin) {
			//循环插入
			Long adminId=authzAccountRole.getAccountId();
			if(adminId==819668989460607L) {
				Long siteId=authzAccountRole.getSiteId();
				HQAccountInManageParam hp=new HQAccountInManageParam();
				hp.setAccountId(adminId);
				hp.setSiteId(siteId);
				for (int i = 0; i < 10; i++) {
					if(i==0) {
						hp.setModuleType(AuthzConstant.moduleType.statistics_course);
					}
					else if(i==1) {
						hp.setModuleType(AuthzConstant.moduleType.statistics_exam);
					}
					else if(i==2) {
						hp.setModuleType(AuthzConstant.moduleType.statistics_research);
					}
					else if(i==6) {
						hp.setModuleType(AuthzConstant.moduleType.statistics_sign);
					}
					else if(i==7) {//培训项目
						hp.setModuleType(AuthzConstant.moduleType.trainingProject);
					}
					else {
						continue;
					}
					try {
						ReportAccountRespInManageVO rarmv=reportClient.getRangeAccountsInManage(hp);
						System.out.println(rarmv.getIsAdmin());
						System.out.println(hp.getModuleType());
					} catch (Exception e) {
					}
				}
			}
		}
	}
	

	@GetMapping("/test2")
	public void test2() {
		HQAccountInManageParam hp=new HQAccountInManageParam();
		hp.setAccountId(1113697151665422336L);
		hp.setSiteId(1125286914944638976L);
		hp.setModuleType(AuthzConstant.moduleType.trainingProject);
		ReportAccountRespInManageVO rarmv=reportClient.getRangeAccountsInManage(hp);
		System.out.println(rarmv);
	}
}
