package com.yizhi.statistics.application.controller.course;

import cn.hutool.core.date.DateUtil;
import com.yizhi.core.application.cache.RedisCache;
import com.yizhi.statistics.application.controller.album.AlbumControllerAbs;
import com.yizhi.statistics.application.controller.dashboard.AccountDashboardAbs;
import com.yizhi.statistics.application.controller.dashboard.AccountDashboardAbsCopy;
import com.yizhi.statistics.application.controller.exam.ExamControllerAbs;
import com.yizhi.statistics.application.controller.forum.StatisticsForumAbs;
import com.yizhi.statistics.application.controller.forum.StatisticsForumAccountAbs;
import com.yizhi.statistics.application.controller.report.ReportControllerAbs;
import com.yizhi.statistics.application.controller.report.StudentReportControllerAbs;
import com.yizhi.statistics.application.controller.research.ResearchControllerAbs;
import com.yizhi.statistics.application.controller.sign.SignControllerAbs;
import com.yizhi.statistics.application.controller.training.TrainingControllerAbs;
import com.yizhi.statistics.application.mapper.StatisticsAccountRoleMapper;
import com.yizhi.statistics.application.service.IStatisticsActivityPointService;
import com.yizhi.statistics.application.service.StatisticsCourseVisibleRangeService;
import com.yizhi.statistics.application.system.DealAssignSiteSystemAbs;
import com.yizhi.statistics.application.system.DealRoleAbs;
import com.yizhi.statistics.application.system.DealSystemAbs;
import com.yizhi.statistics.application.util.JedisUtil;
import com.yizhi.statistics.application.util.WorkUtil;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
@RestController
@RequestMapping("/statisticsReport")
public class WorkController {

	private Logger logger = LoggerFactory.getLogger(WorkController.class);
	@Autowired
	private CourseControllerAbs courseControllerAbs;

	@Autowired
	private ExamControllerAbs examControllerAbs;

	@Autowired
	private ResearchControllerAbs researchControllerAbs;

	@Autowired
	private SignControllerAbs signControllerAbs;

	@Autowired
	private WorkUtil workUtil;

    @Autowired
    private DealRoleAbs dealRoleAbs;

    @Autowired
    private DealSystemAbs dealSystemAbs;
    
    @Autowired
    private TrainingControllerAbs trainingControllerAbs;
    
    @Autowired
    private IStatisticsActivityPointService statisticsActivityPointService;
    
    @Autowired
    private JedisUtil jedisUtil;
    
	@Autowired
	StatisticsAccountRoleMapper roleMapper;
	
	@Autowired
	private ReportControllerAbs reportControllerAbs;
	
    @Autowired
	private StudentReportControllerAbs studentReportControllerAbs;
	@Autowired
	private StatisticsForumAccountAbs statisticsForumAccountAbs;
	@Autowired
	private StatisticsForumAbs statisticsForumAbs;
    
    @Autowired
    private AlbumControllerAbs albumControllerAbs;
    @Autowired
	private AccountDashboardAbs accountDashboardAbs;

    @Autowired
	private DealAssignSiteSystemAbs dealAssignSiteSystemAbs;

    @Autowired
	private AccountDashboardAbsCopy accountDashboardAbsCopy;

    private SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
	private SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

    @Autowired
    private RedisCache redisCache;
    
    @Autowired
    private StatisticsCourseVisibleRangeService statisticsCourseVisibleRangeService;
    
    @GetMapping("/update/role")
	public void statisticsUpdateRole(@RequestParam(value="accountId",required=true)Long accountId,
			                                                 @RequestParam(value="siteId",required=true)Long siteId) {
    	
    }
    


	/**
	 * 所有报表服务
	 * @param startDate
	 * @param endDate
	 * @throws IOException 
	 * @throws ClassNotFoundException 
	 */
    //@Scheduled(cron = "0 0 1 * * ? *")
	@GetMapping("/asynchronous/load/date")
	public String courseController(@RequestParam(value="startDate",required=false)String startDate,
			@RequestParam(value="endDate",required=false)String endDate,
			@RequestParam(value="companyId",required=false)Long companyId,
			@RequestParam(value="siteId",required=false)Long siteId,
			@RequestParam(value="delete",required=false)Integer delete) throws ClassNotFoundException, IOException {
		Date curDate=new Date();
    	String curDateString=simpleDateFormat.format(curDate);
    	String key="statisticsTree:statistics:job:running:"+curDateString;
    	Boolean isSetSuccess=jedisUtil.lock(key);
    	//人工可以手动跑，当遇到人工的时候，把redis锁解除就好。
    	if(delete!=null) {
    		isSetSuccess=true;
    	}
    	//分布式会多次跑，因此redis设置
    	if(isSetSuccess) {
		    Map<String,Object> map=new HashMap<String,Object>();

		    String[] strNow = curDateString.split("-");
		    Integer year = Integer.parseInt(strNow[0]);
		    Integer month = Integer.parseInt(strNow[1]);
		    Integer day = Integer.parseInt(strNow[2]);

		    if (StringUtils.isNotBlank(startDate)) {
	            map.put("startDate", startDate);
	        }
	        if (StringUtils.isNotBlank(endDate)) {
	            map.put("endDate", endDate);
	        }
	        if(companyId!=null) {
	        	map.put("companId", companyId);
	        }
	        if(siteId!=null) {
	        	map.put("siteId", siteId);
	        }
	        
	        //删除statistics_course_visible_range表所有数据，重新跑
	        statisticsCourseVisibleRangeService.deleteAllStatisticsCourseVisibleRange();
	       // 
	        //role要用到
	        map.put("insertBatch", "insertBatch");
	        //insertBatch 代表晚上跑报表批量更新
	        dealRoleAbs.execute(map, true);

	        dealSystemAbs.execute(map, true);

		    courseControllerAbs.execute(map,true);

	        examControllerAbs.execute(map,true);

	        researchControllerAbs.execute(map, true);
	        
	        trainingControllerAbs.execute(map, true);

	        signControllerAbs.execute(map,true);
	        
	        albumControllerAbs.execute(map, true);

	        statisticsForumAccountAbs.execute(map,true);
	        statisticsForumAbs.execute(map,true);
 			map.put("yesterday", format.format(DateUtil.yesterday()));
 			accountDashboardAbs.execute(map,true);
    	}
    	else {	
    	}
	        return "success--all--waiting---";
	}



	
	@GetMapping("/asynchronous/load/date/role/update")
	public void updateRole(@RequestParam(name="accountId",required=true)Long accountId) {
		//先删除这个站点的管理员
		Map<String, Object> map=new HashMap<String,Object>();
		map.put("accountId", accountId);
		map.put("updateRole", "updateRole");
		map.put("adminId", accountId);
	}
	
	
	
	
	/**
	 * -----------------------------------------------------下边全部是手工跑的-------------------------------------
	 * @param type
	 */

	//单个跑systeme和role的信息
	@GetMapping("/asynchronous/load/date/system/and/role")
	public void dealSystemAndRole(@RequestParam(name="type",required=true)Integer type) {
		Map<String,Object> map=new HashMap<String,Object>();
		//role用到
		map.put("insertBatch", "insertBatch");
		
		if(type==1) {
			  /**
	         * 跑管理员数据
	         */
			
			dealRoleAbs.execute(map, true);
		}
		if(type==2) {
			/**
	         * 跑system的信息
	         */
			dealSystemAbs.execute(map, true);
		}
		//给内存放可参加人数
		if(type==3) {
			workUtil.setAskJoinNumByWorkIdAndNotAdminBySql();
		}
		if(type==5) {
			/**
			 * 两个全跑
			 */
			dealRoleAbs.execute(map, true);
			dealSystemAbs.execute(map, true);
		}
		if(type==6) {
			//单独跑积分
			statisticsActivityPointService.dealBatchPointStatistics();
		}
		if(type==7) {
			//删除当天跑数据的标识
			Date curDate=new Date();
        	String curDateString=simpleDateFormat.format(curDate);
        	jedisUtil.dealLock(curDateString);
		}

	}





	/**
	 * ------------------------------------------------------------------------------华丽的分割线----------------------------------------------------------------
	 */


	/**
	 * 课程报表定时异步任务
	 * @param startDate
	 * @param endDate
	 */
    @GetMapping("/asynchronous/load/date/course")
    public String AsynchronousCourse(@RequestParam(value="startDate",required=false)String startDate,
    		@RequestParam(value="endDate",required=false)String endDate,
    		@RequestParam(value="companyId",required=false)Long companyId,
			@RequestParam(value="siteId",required=false)Long siteId) {
        Map<String, Object> map = new HashMap<String, Object>();
        if (StringUtils.isNotBlank(startDate)) {
            map.put("startDate", startDate);
        }
        if (StringUtils.isNotBlank(endDate)) {
            map.put("endDate", endDate);
        }
        if(companyId!=null) {
        	map.put("companyId", companyId);
        }
        if(siteId!=null) {
        	map.put("siteId", siteId);
        }
        courseControllerAbs.execute(map,true);
        return "success--course--waiting---";
    }


    /**
     * 考试报表定时异步任务
     *
     * @param startDate
     * @param endDate
     */
    @GetMapping("/asynchronous/load/date/exam")
    public String AsynchronousExam(String startDate, String endDate) {
        Map<String, Object> map = new HashMap<String, Object>();
        if (StringUtils.isNotBlank(startDate)) {
            map.put("startDate", startDate);
        }
        if (StringUtils.isNotBlank(endDate)) {
            map.put("endDate", endDate);
        }
        examControllerAbs.execute(map);
        return "success--exam--waiting---";
    }



    /**
     * 调研报表定时异步任务
     * @param startDate
     * @param endDate
     * @return
     */
    @GetMapping ("/asynchronous/load/data/research")
    public String asynchronousResearch(@RequestParam (value="startDate",required=false) String startDate, @RequestParam (value="endDate",required=false) String endDate) {
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("startDate", startDate);
        map.put("endDate", endDate);
        researchControllerAbs.execute(map, true);
        return "success--research--waiting---";
    }

	/**
	 * 签到报表定时异步任务
	 *
	 * @param startDate
	 * @param endDate
	 */
	@GetMapping("/asynchronous/load/date/sign")
	public void AsynchronousSign(String startDate, String endDate) {
		Map<String, Object> map = new HashMap<String, Object>();
		if (StringUtils.isNotBlank(startDate)) {
			map.put("startDate", startDate);
		}
		if (StringUtils.isNotBlank(endDate)) {
			map.put("endDate", endDate);
		}
		signControllerAbs.execute(map);
	}
	
	
	@GetMapping("/asynchronous/load/date/training")
	public void AsynchronousTraining(@RequestParam(value="startDate",required=false)String startDate,@RequestParam(value="endDate",required=false)String endDate) {
		Map<String, Object> map = new HashMap<String, Object>();
		if (StringUtils.isNotBlank(startDate)) {
			map.put("startDate", startDate);
		}
		if (StringUtils.isNotBlank(endDate)) {
			map.put("endDate", endDate);
		}
		trainingControllerAbs.execute(map);
	}

	@GetMapping("/asynchronous/load/date/forum")
	public void AsynchronousForum() {
		Map<String, Object> map = new HashMap<String, Object>();
		statisticsForumAbs.execute(map,true);
		statisticsForumAccountAbs.execute(map,true);
	}

	@GetMapping("/asynchronous/load/date/album")
	public void AsynchronousAlbum(@RequestParam(value="startDate",required=false)String startDate,
    		@RequestParam(value="endDate",required=false)String endDate,
    		@RequestParam(value="companyId",required=false)Long companyId,
			@RequestParam(value="siteId",required=false)Long siteId) {
		Map<String, Object> map = new HashMap<String, Object>();
        if (StringUtils.isNotBlank(startDate)) {
            map.put("startDate", startDate);
        }
        if (StringUtils.isNotBlank(endDate)) {
            map.put("endDate", endDate);
        }
        if(companyId!=null) {
        	map.put("companyId", companyId);
        }
        if(siteId!=null) {
        	map.put("siteId", siteId);
        }
		albumControllerAbs.execute(map, true);
	}

	@GetMapping("/asynchronous/load/date/report")
	public void AsynchronousReport(@RequestParam(value="type",required=false)Integer type) {
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("type", type);
        reportControllerAbs.execute(map, true);
	}

	@GetMapping("/asynchronous/load/date/studentReport")
	public void AsynchronousStudentReport() {
		Map<String, Object> map = new HashMap<String, Object>();
		studentReportControllerAbs.execute(map, true);

    }
	@GetMapping("/asynchronous/dashboard")
	public void AsynchronousDashboard() {
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("yesterday", format.format(DateUtil.yesterday()));
		accountDashboardAbs.execute(map, true);
	}

	/**
	 * 学员 学习时长记录 手动跑批
	 * @param startTime
	 * @param endTime
	 */
	@GetMapping("/statisticsCourse/org/study/dashboard")
	public void courseOrgStudyDashboard(@RequestParam("startTime") String startTime,
										@RequestParam("endTime") String endTime){
		Map<String,Object> map = new HashMap<>();
		map.put("startday",startTime);
		map.put("endday",endTime);
		accountDashboardAbsCopy.execute(map,true);
	}

	/**
	 * 公司下用户 手动跑批
	 * @param companyId
	 */
	@GetMapping("/asynchronous/load/assignsite/system")
	public void assignSiteSystemAccount(@RequestParam("companyId") Long companyId){
		Map<String,Object> map = new HashMap<>();
		map.put("companyId",companyId);
		dealAssignSiteSystemAbs.execute(map,true);
	}
}
