package com.yizhi.statistics.application.controller.dashboard;


import com.yizhi.course.application.vo.CourseDashboardParam;
import com.yizhi.statistics.application.entity.AccountDashboard;
import com.yizhi.statistics.application.service.IAccountDashboardService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author taoge123
 * @since 2020-04-07
 */
@RestController
@RequestMapping("/accountDashboard")
public class AccountDashboardController {
    @Autowired
    private IAccountDashboardService accountDashboardService;
    @Autowired
    private AccountDashboardAbs accountDashboardAbs;
    @Autowired
    private DiyTimeAccountDashboardAbs diyTimeAccountDashboardAbs;
    private final SimpleDateFormat sim = new SimpleDateFormat("yyyy-MM-dd");

    /**
     * 根据时间获取学习记录
     *
     * @param param
     * @return
     */
    @PostMapping("/getRecords/byAccountId")
    public List<AccountDashboard> getRecords(@RequestBody CourseDashboardParam param) {
        return accountDashboardService.getRecords(param);
    }

    @GetMapping("/asynchronous/dashboard")
    public void AsynchronousDashboard(@RequestParam("yesterday") String yesterday) {
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("yesterday", yesterday);
        accountDashboardAbs.execute(map, true);
    }

    /**
     * 专门用于跑历史数据  startDateString 直到  endDateString
     * @param endDateString
     */
    @GetMapping("/diy/asynchronous/dashboard")
    public void diyAsynchronousDashboard(@RequestParam("startDateString") String startDateString,
                                         @RequestParam("endDateString") String endDateString) {
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("startDateString", startDateString);
        map.put("endDateString", endDateString);
        diyTimeAccountDashboardAbs.execute(map, true);
    }

}

