package com.yizhi.statistics.application.controller.forum;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.statistics.application.controller.forum.export.AccountForumDownload;
import com.yizhi.statistics.application.entity.StatisticsForumAccount;
import com.yizhi.statistics.application.feign.StatisticsForumAccountClient;
import com.yizhi.statistics.application.service.IStatisticsForumAccountService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author taoge123
 * @since 2020-02-13
 */
@RestController
@RequestMapping("/statisticsForumAccount/")
public class StatisticsForumAccountController implements StatisticsForumAccountClient {

    @Autowired
    private IStatisticsForumAccountService statisticsForumAccountService;
    @Autowired
    private AccountForumDownload accountForumDownload;

    @Override
    @GetMapping("/getPage")
    public Page<StatisticsForumAccount> getPage(@RequestParam(value = "keyword", required = false) String keyword,
                                                @RequestParam("pageNo") Integer pageNo,
                                                @RequestParam("PageSize") Integer pageSize) {
        return statisticsForumAccountService.getPage(keyword, ContextHolder.get().getSiteId(), pageNo, pageSize);
    }

    /**
     * 按帖子下载
     *
     * @return
     */
    @Override
    @ApiOperation("论坛统计-按用户统计下载")
    @GetMapping("/download")
    public String download(@RequestBody Map map) {

        accountForumDownload.execute(map, true);
        return "ok";
    }
}

