package com.yizhi.statistics.application.controller.forum;


import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.statistics.application.controller.forum.export.ForumDownload;
import com.yizhi.statistics.application.entity.StatisticsForum;
import com.yizhi.statistics.application.feign.StatisticsForumClient;
import com.yizhi.statistics.application.service.IStatisticsForumService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author taoge123
 * @since 2020-02-13
 */
@RestController
@RequestMapping("/statisticsForum")
public class StatisticsForumController implements StatisticsForumClient {

    @Autowired
    private IStatisticsForumService statisticsForumService;
    @Autowired
    private ForumDownload forumDownload;

    /**
     * 按帖子统计
     *
     * @param keyword
     * @param pageNo
     * @param pageSize
     * @return
     */
    @GetMapping("/getPage")
    public Page<StatisticsForum> getPage(@RequestParam(value = "keyword",required = false) String keyword,
                                         @RequestParam (value = "startDate",required = false) String startDate,
                                         @RequestParam (value = "endDate",required = false) String endDate,
                                         @RequestParam("pageNo") Integer pageNo,
                                         @RequestParam("PageSize") Integer pageSize) {

        return statisticsForumService.getPage(keyword, startDate, endDate, ContextHolder.get().getSiteId(),pageNo, pageSize);
    }

    /**
     * 按帖子下载
     *
     * @return
     */
    @Override
    @ApiOperation("论坛统计-按帖子统计下载")
    @GetMapping("/download")
    public String download(@RequestBody Map map) {

        forumDownload.execute(map,true);
        return "ok";
    }
}

