package com.yizhi.statistics.application.controller.point;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.statistics.application.controller.point.export.PointExport;
import com.yizhi.statistics.application.controller.point.export.PointPersonalExport;
import com.yizhi.statistics.application.request.point.StatisticsPointDetailQO;
import com.yizhi.statistics.application.request.point.StatisticsPointQO;
import com.yizhi.statistics.application.service.PointLogService;
import com.yizhi.statistics.application.vo.point.StatisticsPointDetailVO;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.Map;

/**
 * @ClassName: PointController
 * @author: zjl
 * @date: 2021/1/25  9:54
 */
@RestController
@RequestMapping("/statistics/point")
public class PointController {

    @Autowired
    private PointLogService pointLogService;

    @Autowired
    private PointPersonalExport pointPersonalExport;

    @Autowired
    private PointExport pointExport;
    @Autowired
    PointDetailsSyncAbs pointDetailsSyncAbs;



    @PostMapping("/detail/get")
    @ApiOperation("获取用户积分明细")
    public Page<StatisticsPointDetailVO> getStatisticsPoint(@RequestBody StatisticsPointDetailQO qo) {
        RequestContext context = ContextHolder.get();
        return pointLogService.getStatisticsPoint(qo, context);
    }


    @PostMapping("/detail/export")
    @ApiOperation("导出用户积分明细")
    public String exportStatisticsPoint(@RequestBody StatisticsPointDetailQO qo) {
        RequestContext context = ContextHolder.get();
        Map<String, Object> map = new HashMap<String, Object>(64);
        Long taskId = System.currentTimeMillis();
        String serialNo = "POINT-ACCOUNT-GROUP-EXPORT-" + taskId.toString();
        String taskName = "导出个人积分明细-" + taskId.toString();
        map.put("taskId", taskId);
        map.put("taskName", taskName);
        map.put("serialNo", serialNo);
        map.put("context", context);
        map.put("qo", qo);
        map.put("context", context);
        pointPersonalExport.execute(map, true);
        return serialNo;
    }

    @PostMapping("/export")
    @ApiOperation("导出所有用户积分明细")
    public String exportAllStatisticsPoint(@RequestBody StatisticsPointQO qo) {
        RequestContext context = ContextHolder.get();
        Map<String, Object> map = new HashMap<String, Object>(64);
        Long taskId = System.currentTimeMillis();
        String serialNo = "POINT-All-ACCOUNT-GROUP-EXPORT-" + taskId.toString();
        String taskName = "导出积分明细-" + taskId.toString();
        map.put("taskId", taskId);
        map.put("taskName", taskName);
        map.put("serialNo", serialNo);
        map.put("context", context);
        map.put("qo", qo);
        pointExport.execute(map, true);
        return serialNo;
    }

    /**
     * 同步积分明细数据
     */
    @GetMapping("/sync/details")
    public void syncPointDetails(@RequestParam(name = "startDate",required = false) String startDate,
                                 @RequestParam(name = "endDate",required = false) String endDate ,
                                 @RequestParam(name = "companyId",required = false) Long companyId ,
                                 @RequestParam(name = "siteId",required = false) Long siteId){


        Map<String,Object> paramMap = new HashMap<>();
        paramMap.put("startDate",startDate);
        paramMap.put("endDate",endDate);
        paramMap.put("companyId",companyId);
        paramMap.put("siteId",siteId);
        paramMap.put("context", ContextHolder.get());
        pointDetailsSyncAbs.execute(paramMap,true);
    }
}
