package com.yizhi.statistics.application.controller.practice;


import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.statistics.application.controller.practice.export.ExportPracticeByUser;
import com.yizhi.statistics.application.controller.practice.export.ExportPracticeByUserDetail;
import com.yizhi.statistics.application.request.practice.PracticeReportByUserDetailReq;
import com.yizhi.statistics.application.request.practice.PracticeReportByUserReq;
import com.yizhi.statistics.application.service.IPracticeChatLogService;
import com.yizhi.statistics.application.util.ParamUtil;
import com.yizhi.statistics.application.vo.practice.PracticeReportByUserDetailVo;
import com.yizhi.statistics.application.vo.practice.PracticeReportByUserListVo;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * <p>
 * 陪练项目-按用户统计 前端控制器
 * </p>
 */
@Api(tags = "智能演练-报表-按用户")
@RestController
@RequestMapping("/statistics/practice/account")
public class PracticeByAccountController {

	@Autowired
	private IPracticeChatLogService chatLogService;
	
	@Autowired
	private ExportPracticeByUser listExporter;
	
	@Autowired
	private ExportPracticeByUserDetail detailExporter;
	
	
	@ApiOperation(value = "列表")
	@PostMapping("/list/get")
	public Page<PracticeReportByUserListVo> list(@RequestBody PracticeReportByUserReq param) {
		ParamUtil.setDate(param);

		return chatLogService.reportByUserListPage(param, param.getContext());
	}
	
	@ApiOperation(value = "列表页-下载")
	@PostMapping("/list/download")
	public String listDownload(@RequestBody PracticeReportByUserReq param) {
		RequestContext requestContext = param.getContext();
		ParamUtil.setDate(param);
        Date date = new Date();
        Long taskId = date.getTime();
        String serialNo = "CHAT-PRACTICE-EXPORT-BY-USER" + taskId.toString();
        String taskName = "智能陪练统计-按用户统计下载" + taskId.toString();

        Map<String, Object> map = new HashMap<>();
        map.put("taskId", taskId);
        map.put("serialNo", serialNo);
        map.put("taskName", taskName);
        map.put("context", requestContext);
        map.put("param", param);
        listExporter.execute(map,true);
        return serialNo;
	}
	
	@ApiOperation(value = "详情")
	@PostMapping("/detail/get")
	public Page<PracticeReportByUserDetailVo> detail(@RequestBody PracticeReportByUserDetailReq param) {
		ParamUtil.setDetailDate(param);

		return chatLogService.reportByUserDetailPage(param, param.getContext());
	}
	
	@ApiOperation(value = "详情页-下载")
	@PostMapping("/detail/download")
	public String detailDownload(@RequestBody PracticeReportByUserDetailReq param) {
		RequestContext requestContext = param.getContext();
		ParamUtil.setDetailDate(param);
        Date date = new Date();
        Long taskId = date.getTime();
        String serialNo = "CHAT-PRACTICE-EXPORT-DETAIL-BY-USER" + taskId.toString();
        String taskName = "按用户统计—查看—下载陪练结果" + taskId.toString();

        Map<String, Object> map = new HashMap<>();
        map.put("taskId", taskId);
        map.put("serialNo", serialNo);
        map.put("taskName", taskName);
        map.put("context", requestContext);
        map.put("param", param);
        detailExporter.execute(map,true);
        return serialNo;
	}
	 
}

