package com.yizhi.statistics.application.controller.practice;


import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.statistics.application.controller.practice.export.ExportPracticeByOrgListDetailExport;
import com.yizhi.statistics.application.controller.practice.export.ExportPracticeByOrgListExport;
import com.yizhi.statistics.application.controller.practice.export.ExportPracticeByOrgListUserDetailExport;
import com.yizhi.statistics.application.request.practice.PracticeByOrgPageReq;
import com.yizhi.statistics.application.request.practice.PracticeReportByUserReq;
import com.yizhi.statistics.application.service.IPracticeChatLogService;
import com.yizhi.statistics.application.service.PracticeByOrgService;
import com.yizhi.statistics.application.util.ParamUtil;
import com.yizhi.statistics.application.vo.practice.PracticeReportByUserListVo;
import com.yizhi.statistics.application.vo.practice.PracticeStatByOrgVo;
import com.yizhi.util.application.page.PageInfo;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 * 陪练项目-按部门统计 前端控制器
 * </p>
 */
@RestController
@RequestMapping("/statistics/practice/org")
public class PracticeByOrgController {

    @Autowired
    private PracticeByOrgService practiceByOrgService;

    @Autowired
    private IPracticeChatLogService iPracticeChatLogService;
    @Autowired
    private ExportPracticeByOrgListExport exportPracticeByOrgListExport;
    @Autowired
    private ExportPracticeByOrgListDetailExport exportPracticeByOrgListDetailExport;
    @Autowired
    private ExportPracticeByOrgListUserDetailExport exportPracticeByOrgListUserDetailExport;

    @PostMapping("/list/page")
    @ApiOperation("陪练按部门统计")
    public PageInfo<PracticeStatByOrgVo> getPageList(@RequestBody PracticeByOrgPageReq body) {
        PageInfo<PracticeStatByOrgVo> page = practiceByOrgService.getLogByOrg(body, body.getRequestContext());
        return page;
    }

    @PostMapping("/list/page/export")
    @ApiOperation("按部门统计-下载结果数据")
    public String groupByOrgExport(@RequestBody PracticeByOrgPageReq body) {

        RequestContext requestContext = body.getRequestContext();
        Date date = new Date();
        Long taskId = date.getTime();
        String serialNo = "CHAT-PRACTICE-EXPORT-BY-ORG-" + taskId.toString();
        String taskName = "智能陪练统计-按部门统计下载" + taskId.toString();

        Map<String, Object> map = new HashMap<>();
        map.put("taskId", taskId);
        map.put("serialNo", serialNo);
        map.put("taskName", taskName);
        map.put("context", requestContext);
        map.put("param", body);
        exportPracticeByOrgListExport.execute(map, true);
        return serialNo;
    }

    @PostMapping("/list/detail/page")
    @ApiOperation("部门陪练统计")
    public Page<PracticeReportByUserListVo> getDetailByOrgIdPage(@RequestBody PracticeReportByUserReq param) {
    	ParamUtil.setDate(param);
        return iPracticeChatLogService.reportByUserListPage(param, param.getContext());
    }

    @PostMapping("/list/detail/page/export")
    @ApiOperation("下载部门陪练结果")
    public String getDetailByOrgIdPageExport(@RequestBody PracticeReportByUserReq param) {
    	ParamUtil.setDate(param);
        RequestContext requestContext = param.getContext();
        Date date = new Date();
        Long taskId = date.getTime();
        String serialNo = "CHAT-PRACTICE-EXPORT-BY-ORG-VIEW-" + taskId.toString();
        String taskName = "按部门统计-查看-下载部门陪练结果" + taskId.toString();

        Map<String, Object> map = new HashMap<>();
        map.put("taskId", taskId);
        map.put("serialNo", serialNo);
        map.put("taskName", taskName);
        map.put("context", requestContext);
        map.put("param", param);
        exportPracticeByOrgListDetailExport.execute(map,true);
        return serialNo;
    }

    @PostMapping("/list/user/detail/page/export")
    @ApiOperation("下载部门用户陪练明细")
    public String getUserDetailByOrgIdPageExport(@RequestBody PracticeReportByUserReq param) {
//    	ParamUtil.setDate(param);
        RequestContext requestContext = param.getContext();
        Date date = new Date();
        Long taskId = date.getTime();
        String serialNo = "CHAT-PRACTICE-EXPORT-BY-ORG-USER-DETAIL-" + taskId.toString();
        String taskName = "按部门统计-查看-下载部门用户陪练明细" + taskId.toString();
        Map<String, Object> map = new HashMap<>();
        map.put("taskId", taskId);
        map.put("serialNo", serialNo);
        map.put("taskName", taskName);
        map.put("context", requestContext);
        map.put("param", param);
        exportPracticeByOrgListUserDetailExport.execute(map,true);
        return serialNo;
    }

}

