package com.yizhi.statistics.application.controller.practice;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.statistics.application.controller.practice.export.ExportPracticeByPrac;
import com.yizhi.statistics.application.controller.practice.export.ExportPracticeByPracView;
import com.yizhi.statistics.application.controller.practice.export.ExportPracticeByPracViewDetail;
import com.yizhi.statistics.application.request.practice.PracticeStatByPracticeIdReq;
import com.yizhi.statistics.application.request.practice.PracticeStatByPracticeReq;
import com.yizhi.statistics.application.service.IPracticeChatLogService;
import com.yizhi.statistics.application.vo.practice.PracticeStatByPracticeVo;
import com.yizhi.statistics.application.vo.practice.PracticeStatViewByIdVo;

/**
 * <p>
 * 陪练项目-按陪练统计 前端控制器
 * </p>
 */
@RestController
@RequestMapping("/statistics/practice")
public class PracticeByPracController{

    @Autowired
    private IPracticeChatLogService chatLogService;

    @Autowired
    ExportPracticeByPrac exportPracticeByPrac;

    @Autowired
    ExportPracticeByPracView exportPracticeByPracView;

    @Autowired
    ExportPracticeByPracViewDetail exportPracticeByPracViewDetail;
    @Autowired
    IdGenerator idGenerator;
    /**
     * 智能陪练统计-按陪练统计列表
     */
    @PostMapping("/group/list")
    public Page<PracticeStatByPracticeVo> practiceGroup(@RequestBody PracticeStatByPracticeReq req){
        RequestContext context = req.getContext();

        return chatLogService.practiceGroup(context, req);
    }

    /**
     * 智能陪练统计-按陪练统计-下载
     */
    @PostMapping("/group/list/download")
    public String practiceGroupDownload(@RequestBody PracticeStatByPracticeReq req) {

        RequestContext context = req.getContext();
        Map<String, Object> map = new HashMap<String, Object>(64);
        Long taskId = idGenerator.generate();
        String serialNo = "PRACTICE-GROUP-DOWNLOAD-" + taskId.toString();
        String taskName = "智能陪练统计-按陪练统计下载" + taskId.toString();
        map.put("req", req);
        map.put("taskName", taskName);
        map.put("serialNo", serialNo);
        map.put("context", context);
        map.put("taskId",taskId);
        exportPracticeByPrac.execute(map, true);
        return serialNo;
    }


    /**
     * 智能陪练统计-按陪练统计-查看-统计结果列表
     */
    @PostMapping("/group/view/list")
    public Page<PracticeStatViewByIdVo> practiceGroupView(@RequestBody PracticeStatByPracticeIdReq req){
        RequestContext context = req.getContext();

        return chatLogService.practiceGroupView(req,context);
    }

    /**
     * 智能陪练统计-按陪练统计-查看-陪练统计结果下载
     * @param req
     * @return
     */
    @PostMapping("/group/view/list/download")
    public String practiceGroupViewDownload(@RequestBody PracticeStatByPracticeIdReq req) {
        RequestContext context = req.getContext();
        Map<String, Object> map = new HashMap<String, Object>(64);
        Long taskId = idGenerator.generate();
        String serialNo = "PRACTICE-GROUP-VIEW-DOWNLOAD-" + taskId.toString();
        String taskName = "按陪练统计—查看—下载陪练结果明细-" + taskId.toString();
        map.put("req", req);
        map.put("taskName", taskName);
        map.put("serialNo", serialNo);
        map.put("context", context);
        map.put("taskId",taskId);
        exportPracticeByPracView.execute(map, true);
        return serialNo;
    }

    /**
     * 智能陪练统计-按陪练统计-查看-陪练统计结果明细下载
     */
    @PostMapping("/group/view/list/detail/download")
    public String practiceGroupViewDetailDownload(@RequestBody PracticeStatByPracticeIdReq req) {
        RequestContext context = req.getContext();
        Map<String, Object> map = new HashMap<String, Object>(64);
        Long taskId = idGenerator.generate();
        String serialNo = "PRACTICE-GROUP-VIEW-DETAIL-DOWNLOAD-" + taskId.toString();
        String taskName = "按陪练统计—查看—下载陪练明细" + taskId.toString();
        map.put("req", req);
        map.put("taskName", taskName);
        map.put("serialNo", serialNo);
        map.put("context", context);
        map.put("taskId",taskId);
        exportPracticeByPracViewDetail.execute(map, true);
        return serialNo;
    }


}
