package com.yizhi.statistics.application.controller.practice;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.yizhi.statistics.application.service.IPracticeConfigService;
import com.yizhi.util.application.domain.BizResponse;

import lombok.extern.slf4j.Slf4j;

@RestController
@RequestMapping("/practice")
@Slf4j
public class PracticeWorkController {

    @Autowired
    IPracticeConfigService practiceConfigService;

    @GetMapping(path = "/xxl-job/sync/data")
    public BizResponse<Object> syncPracticeData(@RequestParam(value="startDate",required=false)String startDate,
                                 @RequestParam(value="endDate",required=false)String endDate) {
        log.info("PracticeWorkController - syncPracticeData :{}|{}",startDate, endDate);
        practiceConfigService.syncData(startDate, endDate);
        return BizResponse.ok();
    }
}

