package com.yizhi.statistics.application.controller.report;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.yizhi.core.application.cache.RedisCache;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.statistics.application.entity.Report;
import com.yizhi.statistics.application.entity.ReportDetail;
import com.yizhi.statistics.application.entity.ReportVisibleRange;
import com.yizhi.statistics.application.service.IReportDetailService;
import com.yizhi.statistics.application.service.IReportService;
import com.yizhi.statistics.application.service.IReportVisibleRangleService;
import com.yizhi.statistics.application.vo.report.ReportDetailVO;
import com.yizhi.system.application.system.remote.AccountClient;
import com.yizhi.system.application.system.remote.SiteClient;
import com.yizhi.system.application.vo.AccountVO;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;

import java.util.*;

@RestController
@RequestMapping("/api/report")
public class StudentReportController {

	@Autowired
	private StudentReportControllerAbs studentReportControllerAbs;
	
	@Autowired
	private IReportDetailService reportDetailService;
	
	@Autowired
	private IReportVisibleRangleService reportVisibleRangleService;
	
	@Autowired
	private IReportService reportService;
	
	@Autowired
	private AccountClient accountClient;
	
	@Autowired
	private SiteClient siteClient;
	
    @Autowired
    private RedisCache redisCache;
    
	@GetMapping("/save")
	public void save() {
		Map<String,Object> map = new HashMap<String, Object>();
		studentReportControllerAbs.execute(map, true);
	}
	
	@GetMapping("/get")
	public ReportDetailVO get(@RequestParam("reportId") Long reportId,@RequestParam("siteId") Long siteId,@RequestParam("companyId") Long companyId,@RequestParam("accountId") Long accountId) {
		ReportDetailVO vo = new ReportDetailVO();
		List<Long> accountIds = new ArrayList<Long>();
		Boolean defaultSite = siteClient.isDefaultSite(siteId);
		ReportDetail detail = new ReportDetail();
		detail.setAccountId(accountId);
		detail.setSiteId(siteId);
		detail.setCompanyId(companyId);
		detail.setReportId(reportId);
		EntityWrapper<ReportDetail> wrapper = new EntityWrapper<ReportDetail>(detail);
		ReportDetail one = reportDetailService.selectOne(wrapper);
		if (!StringUtils.isEmpty(one)) {
			Report report = reportService.selectById(one.getReportId());
			if (report.getState().equals(1)) {
				if (report.getVisibleRange().equals(2)) {
					ReportVisibleRange range = new ReportVisibleRange();
					range.setReportId(one.getReportId());
					EntityWrapper<ReportVisibleRange> wrapper1 = new EntityWrapper<ReportVisibleRange>(range);
					List<ReportVisibleRange> visibleRanges = reportVisibleRangleService.selectList(wrapper1);
					for(ReportVisibleRange visibleRange:visibleRanges) {
						if (2 == visibleRange.getType()) {
							accountIds.add(visibleRange.getRelationId());
						} else {
							List<AccountVO> accountVOs = accountClient.findByOrgId(visibleRange.getRelationId(), companyId);
							if (CollectionUtils.isNotEmpty(accountVOs)) {
								for (AccountVO accountVO : accountVOs) {
									accountIds.add(accountVO.getId());
								}
							}
						}
					}
						//显示已上架且在用户可见范围内的报告
						if (accountIds.contains(accountId)) {
							vo=this.dealData(one, defaultSite, report.getDataRange());						
						}else {
							vo.setState(1);
							}
					}else {
						vo=this.dealData(one, defaultSite, report.getDataRange());					}
			}
		}else {
			vo.setState(1);
		}
		return vo;	
	}
	
	@GetMapping("/list")
	public List<ReportDetailVO> list(){
		RequestContext context = ContextHolder.get();
		Long siteId = context.getSiteId();
		Long companyId = context.getCompanyId();
		Long accountId = context.getAccountId();
		List<ReportDetailVO> list = new ArrayList<ReportDetailVO>();
		Boolean defaultSite = siteClient.isDefaultSite(siteId);
		ReportDetail detail = new ReportDetail();
		detail.setAccountId(accountId);
		detail.setSiteId(siteId);
		detail.setCompanyId(companyId);
		EntityWrapper<ReportDetail> wrapper = new EntityWrapper<ReportDetail>(detail);
		wrapper.orderBy("create_time", false);
		List<ReportDetail> details = reportDetailService.selectList(wrapper);
		if (CollectionUtils.isNotEmpty(details)) {
			for(ReportDetail one:details) {
				List<Long> accountIds = new ArrayList<Long>();
				Report report = reportService.selectById(one.getReportId());
				//判断可见范围
				if (report.getState().equals(1)) {
					if (report.getVisibleRange().equals(2)) {
						ReportVisibleRange range = new ReportVisibleRange();
						range.setReportId(one.getReportId());
						EntityWrapper<ReportVisibleRange> wrapper1 = new EntityWrapper<ReportVisibleRange>(range);
						List<ReportVisibleRange> visibleRanges = reportVisibleRangleService.selectList(wrapper1);
						for(ReportVisibleRange visibleRange:visibleRanges) {
							if (2 == visibleRange.getType()) {
								accountIds.add(visibleRange.getRelationId());
							} else {
								List<AccountVO> accountVOs = accountClient.findByOrgId(visibleRange.getRelationId(), companyId);
								if (CollectionUtils.isNotEmpty(accountVOs)) {
									for (AccountVO accountVO : accountVOs) {
										accountIds.add(accountVO.getId());
									}
								}
							}
						}
							//显示已上架且在用户可见范围内的报告
							if (accountIds.contains(accountId)) {
								list.add(this.dealDataV2(one, defaultSite, report));
							}
						}else {
							list.add(this.dealDataV2(one, defaultSite, report));
						}
					}
				}
			}	
		return list;		
	}
	
	@GetMapping("/view")
	public Boolean view(@RequestParam("reportId") Long reportId) {
		RequestContext context = ContextHolder.get();
		Long siteId = context.getSiteId();
		Long accountId = context.getAccountId();
		boolean b =false;
			    ReportDetail detail = new ReportDetail();
			    detail.setReportId(reportId);
			    detail.setAccountId(accountId);
			    detail.setSiteId(siteId);
			    EntityWrapper<ReportDetail> wrapper = new EntityWrapper<ReportDetail>(detail);
			    ReportDetail one = reportDetailService.selectOne(wrapper);
			    if (!StringUtils.isEmpty(one)&&one.getState().equals(0)) {
					one.setState(1);
					reportDetailService.updateById(one);
					Report report = reportService.selectById(reportId);
					Long num = report.getNum();
					report.setNum(num+1);
					b = reportService.updateById(report);
				}
		return b;
	}
	
	@PostMapping("/getMyReportNum")
	public Integer getMyReportNum(@RequestBody RequestContext context) {
		return reportService.getMyReportNum(context);
	}
	
	/**
	 * 组装数据
	 * @param one
	 * @param defaultSite
	 * @param dataRange
	 * @return
	 */
	public ReportDetailVO dealData(ReportDetail one,Boolean defaultSite,Integer dataRange) {
		Date date = new Date();
		long userDuration = (long) Math.ceil(((double)(date.getTime()-one.getRegisterTime().getTime())/(60*60*24*1000)));
		ReportDetailVO vo = new ReportDetailVO();
		vo.setReportId(one.getReportId());
		vo.setReportName(one.getReportName());
		vo.setReportType(one.getReportType());
		vo.setAccountId(one.getAccountId());
		vo.setState(one.getState());
		vo.setRegisterTime(one.getRegisterTime());
		vo.setUserDuration(userDuration);
		vo.setSiteName(one.getSiteName());
		if (defaultSite&&dataRange.equals(2)) {
			vo.setProportion(one.getAllProportion());
			vo.setSignNum(one.getAllSignNum());
			vo.setStudyDuration((long) Math.round((double)one.getAllStudyDuration()/3600));
			vo.setFinishNum(one.getAllFinishNum());
			vo.setPoint(one.getAllPoint());
			vo.setFirstCertificate((one.getAllFirstCertificate().getTime()>0)?one.getAllFirstCertificate():null);
			vo.setLatestDate((one.getAllLatestDate().getHours()>21||one.getAllLatestDate().getHours()<6)?one.getAllLatestDate():null);
			vo.setMaxDuration(((long) Math.round((double)one.getAllMaxDuration()/3600)>1)?(long) Math.round((double)one.getAllMaxDuration()/3600):null);
			vo.setMaxStudy(((long) Math.round((double)one.getAllMaxDuration()/3600)>1)&&(one.getAllMaxStudy().getTime()>0)?one.getAllMaxStudy():null);
			vo.setType(one.getAllType());
		}else {
			vo.setProportion(one.getProportion());
			vo.setSignNum(one.getSignNum());
			vo.setStudyDuration((long) Math.round((double)one.getStudyDuration()/3600));
			vo.setFinishNum(one.getFinishNum());
			vo.setPoint(one.getPoint());
			vo.setFirstCertificate((one.getFirstCertificate().getTime()>0)?one.getFirstCertificate():null);
			vo.setLatestDate((one.getLatestDate().getHours()>21||one.getLatestDate().getHours()<6)?one.getLatestDate():null);
			vo.setMaxDuration(((long) Math.round((double)one.getMaxDuration()/3600)>1)?(long) Math.round((double)one.getMaxDuration()/3600):null);
			vo.setMaxStudy(((long) Math.round((double)one.getMaxDuration()/3600)>1)&&(one.getMaxStudy().getTime()>0)?one.getMaxStudy():null);
			vo.setType(one.getType());
		}
		return vo;
	}

	/**
	 * dealData()方法的 版本2
	 * 报告的列表展示使用
	 * 修改 列表显示时间为报告统计结束时间+1；
		只修改LatestDate的值；因为前端列表展示是用这个值；
	 	其余多余统计字段去掉
	 */
	public ReportDetailVO dealDataV2(ReportDetail one,Boolean defaultSite,Report report) {
		Date date = new Date();
		long userDuration = (long) Math.ceil(((double)(date.getTime()-one.getRegisterTime().getTime())/(60*60*24*1000)));
		ReportDetailVO vo = new ReportDetailVO();
		vo.setReportId(one.getReportId());
		vo.setReportName(one.getReportName());
		vo.setReportType(one.getReportType());
		vo.setAccountId(one.getAccountId());
		vo.setState(one.getState());
		vo.setRegisterTime(one.getRegisterTime());
		vo.setUserDuration(userDuration);
		vo.setSiteName(one.getSiteName());
		//获取报告统计结束的时间 + 1  即：xxx年xx月1号
		Date endTime = report.getEndTime();
		Calendar calendar = Calendar.getInstance();
		calendar.setTime(endTime);
		calendar.add(Calendar.DAY_OF_MONTH,1);
		Date endTimeNextDay = calendar.getTime();
		vo.setLatestDate(endTimeNextDay);
		return vo;
	}
}
