package com.yizhi.statistics.application.controller.research;


import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.statistics.application.export.research.DownloadResearch;
import com.yizhi.statistics.application.export.research.DownloadResearchAnalyze;
import com.yizhi.statistics.application.export.research.DownloadResearchDetails;
import com.yizhi.statistics.application.service.StatisticsResearchLearnMetadataService;
import com.yizhi.statistics.application.vo.research.DownloadParamsVo;
import com.yizhi.statistics.application.vo.research.ResearchGroupViewVo;
import com.yizhi.statistics.application.vo.research.ResearchGroupVo;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 * 学员调研明细 前端控制器
 * </p>
 *
 * @author hutao123
 * @since 2019-04-18
 */
@RestController
@RequestMapping ("/statisticsResearchLearnMetadata")
public class StatisticsResearchLearnMetadataComtroller {
    @Autowired
    private ResearchControllerAbs researchControllerAbs;

    @Autowired
    private StatisticsResearchLearnMetadataService learnMetadataService;

    @Autowired
    private DownloadResearch downloadResearch;

    @Autowired
    private DownloadResearchDetails downloadResearchDetails;

    @Autowired
    private DownloadResearchAnalyze downloadResearchAnalyze;

    private static final Logger LOGGER = LoggerFactory.getLogger(StatisticsResearchLearnMetadataComtroller.class);




    @ApiOperation (value = "调研统计", notes = "调研统计", response = ResearchGroupVo.class)
    @GetMapping ("/group")
    public Page<ResearchGroupVo> researchGroup(@RequestParam (name = "startDate", required = false) String startDate,
                                               @RequestParam (name = "endDate", required = false) String endDate,
                                               @RequestParam (name = "kwd", required = false) String kwd,
                                               @RequestParam (name = "pageSize", required = false, defaultValue = "10") Integer pageSize,
                                               @RequestParam (name = "pageNo", required = false, defaultValue = "1") Integer pageNo,
                                               @RequestParam (name = "companyId", required = true) Long companyId,
                                               @RequestParam (name = "orgIds", required = false) List<Long> orgIds,
                                               @RequestParam (name = "siteId", required = true) Long siteId) {
        return learnMetadataService.researchGroup(startDate, endDate, kwd, pageSize, pageNo, companyId, orgIds, siteId);
    }

    @ApiOperation (value = "调研参与人员的统计", notes = "调研参与人员的统计", response = ResearchGroupViewVo.class)
    @GetMapping ("/group/view")
    public Page<ResearchGroupViewVo> researchGroupView(
            @RequestParam (name = "startDate", required = false) String startDate,
            @RequestParam (name = "endDate", required = false) String endDate,
            @RequestParam (name = "researchId", required = true) Long researchId,
            @RequestParam (name = "orgNameorOrgCode", required = false) String orgNameorOrgCode,
            @RequestParam (name = "accountName", required = false) String accountName,
            @RequestParam (name = "state", required = false) Integer state,
            @RequestParam (name = "pageSize", required = false, defaultValue = "10") Integer pageSize,
            @RequestParam (name = "pageNo", required = false, defaultValue = "1") Integer pageNo) {
        return learnMetadataService.selectResearchView(researchId, startDate, endDate, orgNameorOrgCode, accountName, state, pageNo, pageSize);

    }


    @ApiOperation (value = "导出调研参与人员统计", notes = "导出调研参与人员统计")
    @PostMapping ("/accounts/Excel")
    public String reportResearchAccounts(@RequestBody DownloadParamsVo vo) {
        try {
            downloadResearch.execute(vo, true);
            return "任务名称：" + vo.getTaskName() + ",任务序号:" + vo.getSerialNo();
        } catch (Exception e) {
            LOGGER.error("", e);
            return null;
        }

    }

    @ApiOperation (value = "导出调研明细", notes = "导出调研明细")
    @PostMapping ("/details/Excel")
    public String reportResearchDetails(@RequestBody DownloadParamsVo vo) {

        try {
            downloadResearchDetails.execute(vo, true);
            return "任务名称：" + vo.getTaskName() + ",任务序号:" + vo.getSerialNo();
        } catch (Exception e) {
            LOGGER.error("", e);
            return null;
        }
    }

    @ApiOperation (value = "导出调研分析统计", notes = "导出调研分析统计")
    @PostMapping ("/analyze/Excel")
    public String reportResearchanalyze(@RequestBody DownloadParamsVo vo) {

        try {
            downloadResearchAnalyze.execute(vo, true);
            return "任务名称：" + vo.getTaskName() + ",任务序号:" + vo.getSerialNo();
        } catch (Exception e) {
            LOGGER.error("", e);
            return null;
        }
    }

}

