package com.yizhi.statistics.application.controller.training;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.statistics.application.controller.training.export.*;
import com.yizhi.statistics.application.service.IStatisticsTrainingService;
import com.yizhi.statistics.application.training.vo.TrainingProjectGroupParam;
import com.yizhi.training.application.vo.manage.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("/statisticsTraining")
public class TrainingController {

	 private Logger logger = LoggerFactory.getLogger(TrainingController.class);
	 
	 @Autowired
	 IStatisticsTrainingService statisticsTrainingProjectService;
	 
	 @Autowired
     TrainingProjectGroupExport trainingProjectGroupExport;
	 
	 
	 @Autowired
     TrainingProjectAccountGroupExport trainingProjectAccountGroupExport;
	 
	 @Autowired
     TrainingProjectAccountGroupViewExport trainingProjectAccountGroupViewExport;
	 
	 @Autowired
     TrainingProjectGroupViewExport1 trainingProjectGroupViewExport1;
	 
	 @Autowired
     TrainingProjectGroupViewExport2 trainingProjectGroupViewExport2;
	 
	 @Autowired
	 TrainingProjectGroupViewExport3 trainingProjectGroupViewExport3;
	 
	 @Autowired
	 TrainingProjectOrgGroupExport trainingProjectOrgGroupExport;
	 
	 
	 @PostMapping("/chart/group/new")
	 public List<TrainingProjectDataChartsVo> chartGroup(@RequestBody  TrainingProjectGroupParam tpgm){
		 RequestContext requestContext = ContextHolder.get();
		 List<TrainingProjectDataChartsVo> list = null;
		 if(requestContext.getCompanyId().compareTo(1125598212636950528L) == 0 || 
				 requestContext.getCompanyId().compareTo(1067032399575969792L) == 0 || 
				 requestContext.getCompanyId().compareTo(1107544603169693696L) == 0){
			//天津农商、申万宏源、复旦管院效率慢，待优化好放开查询
			 list = new ArrayList<TrainingProjectDataChartsVo>();
		 } else {
			 list = statisticsTrainingProjectService.chartGroup(tpgm.getCompanyId(), tpgm.getSiteId(), tpgm.getAdminId(), tpgm.getIsAdmin(), tpgm.getStartDate(), tpgm.getEndDate());
		 }
		 return list;
	 }

        	 
	    @PostMapping(value="/group")
		public Page<ReportStudyTrainingProjectVo> trainingProjectGroup(@RequestBody TrainingProjectGroupParam tpgm){
			return statisticsTrainingProjectService.trainingProjectGroup(tpgm.getKwd(), tpgm.getStartDate(), tpgm.getEndDate(), tpgm.getCompanyId(), tpgm.getSiteId(),tpgm.getAdminId(),tpgm.getIsAdmin(), tpgm.getPageNo(), tpgm.getPageSize());
	    }
	    
	    @PostMapping(value="/group/excel")
		public void trainingProjectGroupExcel(@RequestBody TrainingProjectGroupParam tpgm){
	    	trainingProjectGroupExport.execute(tpgm, true);
	    }
	 
	 
		
		@PostMapping(value="/group/view")
		public Page<TrainingProjectDataChartsVo>  trainingProjectGroupView(@RequestBody TrainingProjectGroupParam tpgm){
			return statisticsTrainingProjectService.trainingProjectGroupView(tpgm.getCompanyId(),tpgm.getSiteId(),tpgm.getAdminId(),tpgm.getIsAdmin(),tpgm.getProjectId(),tpgm.getPageNo(),tpgm.getPageSize());
	    }
		
		@PostMapping(value="/group/view/excel1")
		public void  trainingProjectGroupViewExcel(@RequestBody TrainingProjectGroupParam tpgm){
			trainingProjectGroupViewExport1.execute(tpgm, true);
	    }
		
		 @PostMapping("/group/view/excel2")
		  public void trainingProjectGroupViewExcel2(@RequestBody TrainingProjectGroupParam trainingGroupParam) {
			 trainingProjectGroupViewExport2.execute(trainingGroupParam, true);
		 }
		  
		  @PostMapping("/group/view/excel3")
		  public void trainingProjectGroupViewExcel3(@RequestBody TrainingProjectGroupParam trainingGroupParam) {
			  trainingProjectGroupViewExport3.execute(trainingGroupParam, true);
		  }
		
		
		@PostMapping("/account/group")
		public Page<ReportStudyTrainingProjectAccountVo> trainingProjectAccountGroup(@RequestBody TrainingProjectGroupParam tpgm){
			return statisticsTrainingProjectService.trainingProjectAccountGroup(tpgm.getCompanyId(),tpgm.getSiteId(),tpgm.getAdminId(),tpgm.getIsAdmin(),tpgm.getOrgKwd(),tpgm.getAccountKwd(),tpgm.getPageNo(),tpgm.getPageSize(),tpgm.getStartDate(),tpgm.getEndDate());
		}
		
		@PostMapping("/account/group/excel")
		public void trainingProjectAccountGroupExcel(@RequestBody TrainingProjectGroupParam trainingGroupParam){
			trainingProjectAccountGroupExport.execute(trainingGroupParam, true);
		}
		
		  @PostMapping("/account/group/view")
		  public Page<ReportStudyTrainingProjectAccountViewVo> trainingProjectAccountGroupView(@RequestBody TrainingProjectGroupParam trainingGroupParam){
			  return statisticsTrainingProjectService.trainingProjectAccountGroupView(trainingGroupParam.getCompanyId(),trainingGroupParam.getSiteId(),trainingGroupParam.getPageNo(),trainingGroupParam.getPageSize(),trainingGroupParam.getAccountId(),trainingGroupParam.getProjectName(),1);
		  }
		  
		  @PostMapping("/account/group/view/excel")
		  public void trainingProjectAccountGroupViewExcel(@RequestBody TrainingProjectGroupParam trainingGroupParam){
			  trainingProjectAccountGroupViewExport.execute(trainingGroupParam, true);
		  }
		  
		  @PostMapping("/org/group")
		  public Page<ReportStudyTrainingProjectOrgVo> trainingProjectOrgGroup(@RequestBody TrainingProjectGroupParam trainingGroupParam){
			  return statisticsTrainingProjectService.trainingProjectOrgGroup(trainingGroupParam.getCompanyId(), trainingGroupParam.getSiteId(), trainingGroupParam.getAdminId(), trainingGroupParam.getIsAdmin(), trainingGroupParam.getKwd(), trainingGroupParam.getPageNo(), trainingGroupParam.getPageSize(),trainingGroupParam.getStartDate(),trainingGroupParam.getEndDate());
		  }
	 
		  @PostMapping("/org/group/excel")
		  public void trainingProjectOrgGroupExcel(@RequestBody TrainingProjectGroupParam trainingGroupParam){
			  trainingProjectOrgGroupExport.execute(trainingGroupParam, true);
		  }
}
