
package com.yizhi.statistics.application.course.export;

import com.baomidou.mybatisplus.toolkit.CollectionUtils;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.core.application.context.TaskContext;
import com.yizhi.core.application.file.constant.FileConstant;
import com.yizhi.core.application.file.task.AbstractDefaultTask;
import com.yizhi.core.application.file.util.OssUpload;
import com.yizhi.statistics.application.course.vo.CourseAccountGroupParam;
import com.yizhi.statistics.application.course.vo.ReportStudyCourseAccountDetailsVo;
import com.yizhi.statistics.application.mapper.StatisticsAccountMapper;
import com.yizhi.statistics.application.service.IStatisticsAccountRoleService;
import com.yizhi.statistics.application.service.StatisticsCourseRecordeService;
import com.yizhi.statistics.application.util.ExcelUtil;
import org.apache.poi.xssf.streaming.SXSSFRow;
import org.apache.poi.xssf.streaming.SXSSFSheet;
import org.apache.poi.xssf.streaming.SXSSFWorkbook;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.io.File;
import java.io.FileOutputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;



/**
 * 按照用户统计---（后边的按钮）---导出excel-----这个暂且不用
 * @author wangfeida
 *
 */

@Component
public class CourseAccountGroupDetailsExportExcel2 extends AbstractDefaultTask<String, CourseAccountGroupParam> {

	private static final Logger logger = LoggerFactory.getLogger(CourseAccountGroupDetailsExportExcel2.class);


	@Autowired
	private StatisticsCourseRecordeService statisticsCourseRecordeService;

	@Autowired
	private IdGenerator idGenerator;

	@Autowired
	private StatisticsAccountMapper statisticsAccountMapper;

	@Autowired
	ExcelUtil excelUtil;

	@Autowired
	private IStatisticsAccountRoleService statisticsAccountRoleService;

	@Override
	protected String execute(CourseAccountGroupParam courseAccountGroupParam) {
		// TODO Auto-generated method stub
		SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		String upLoadUrl = null;
		Long accountId =courseAccountGroupParam.getAdminId();
		Long companyId =courseAccountGroupParam.getCompanyId();

		Long siteId =courseAccountGroupParam.getSiteId();
		String startDate =courseAccountGroupParam.getStartDate();
		String endDate = courseAccountGroupParam.getEndDate();
		String orgKwd = courseAccountGroupParam.getOrgKwd();
		String accountKwd = courseAccountGroupParam.getAccountKwd();
		Long taskId=courseAccountGroupParam.getTaskId();
		Date submitTime=courseAccountGroupParam.getSubmitTime();
		String serialNo=courseAccountGroupParam.getSerialNo();
		String taskName=courseAccountGroupParam.getTaskName();
		Boolean isAdmin=courseAccountGroupParam.getIsAdmin();
		Long adminId=courseAccountGroupParam.getAdminId();
		Boolean isAllDate=courseAccountGroupParam.getIsAllData();
		String sheetName="课程学习明细";
		String headerName="课程学习明细";



		TaskContext taskContext = new TaskContext(taskId,serialNo, taskName,accountId, submitTime, siteId, companyId);// 任务id 任务编号 任务名字      操作人id   操作时间
		working(taskContext);

		List<Long> accountIds=null;
		//验证下管辖区是否是全平台的
		boolean isAdmin1;
		if (!isAdmin) {
			isAdmin1 = statisticsAccountRoleService.getIsAdmin(0, siteId, adminId);
		} else {
			isAdmin1 = isAdmin;
		}
		if(isAdmin1) {
			accountIds=statisticsAccountMapper.accountIdsByCompanyIdAndSiteId(companyId, siteId,orgKwd,accountKwd);
		}
		else {
			accountIds=statisticsAccountMapper.accountIdsByCompanyIdAndSiteIdNotAdmin(companyId, siteId, adminId,orgKwd,accountKwd);
		}

		//当前sheet的数据量,不带表头
		int curSheetNum=3;
		boolean isNeedCreateExcel=true;
		SXSSFSheet sheet=null;
		int excelNum=1;
		Integer studentIdIndex=0;


		if(CollectionUtils.isNotEmpty(accountIds)) {
			List<ReportStudyCourseAccountDetailsVo> listByOneAccountDate=null;
			for (int i = 0; i < accountIds.size(); i++) {
				Long studentId=accountIds.get(i);
				listByOneAccountDate=null;//statisticsCourseRecordeService.listReportStudyCourseAccountDetailsVo(companyId, siteId, startDate, endDate, studentId,isAllDate);
				if(CollectionUtils.isNotEmpty(listByOneAccountDate)) {
					if(isNeedCreateExcel) {
						 sheetName=sheetName+excelNum;
						 headerName=headerName+excelNum;
						 sheet=createExcel(sheetName, headerName, startDate, endDate);
					}
					SXSSFRow row=null;
					 ReportStudyCourseAccountDetailsVo rscv=null;
					 for (int j = 0; j < listByOneAccountDate.size(); j++) {
						 row = sheet.createRow(curSheetNum+j );
						 rscv=listByOneAccountDate.get(j);
						 writeDate(row, rscv, df);
					}
					 curSheetNum=curSheetNum+listByOneAccountDate.size();
					 isNeedCreateExcel=curSheetNum>100*10000?true:false;
				}
			}
		}
		else {
			//创建一个新的excel
			 sheetName=sheetName+excelNum;
			 headerName=headerName+excelNum;
			 sheet=createExcel(sheetName, headerName, startDate, endDate);
		}


		try {
			SXSSFWorkbook  wb = new SXSSFWorkbook();



			String fileName = "按个人统计---下载学习明细数据_" +idGenerator.generate() + ".xlsx";
			String requestPath = FileConstant.SAVE_PATH;
			//String requestPath = "F:\\home";
			String requestPathSuffix=requestPath+File.separator+idGenerator.generate();
			File fileDir = new File(requestPathSuffix);
			if (!fileDir.exists()) {
				fileDir.mkdir();
			}
			String path = requestPathSuffix +File.separator+ fileName;
			FileOutputStream os = null;
			File file = null;
			File fileDic=null;
			try {
				os = new FileOutputStream(path);
				wb.write(os);
				// 阿里云返回url
				upLoadUrl = OssUpload.upload(path, fileName);
				file = new File(path);
				fileDic=new File(requestPathSuffix);
				success(taskContext, "成功", upLoadUrl);
			} catch (Exception e1) {
				e1.printStackTrace();
				fail(taskContext, "写入过程中发生错误");
				logger.error("上传过程中发生错误，请查看日志");
			} finally {
				if (os != null) {
					os.close();
				}
				if (wb != null) {
					wb.close();
				}
				if (file != null) {
					file.delete();
				}
				if(fileDic!=null) {
					fileDic.delete();
				}
			}

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			fail(taskContext, "按个人统计---下载学习明细数据导出过程中发生错误，请查看日志");
			logger.error("按个人统计---下载学习明细数据导出过程中发生错误，请查看日志");
		}
		return upLoadUrl;
	}

	private List<ReportStudyCourseAccountDetailsVo> processNotAllData(List<ReportStudyCourseAccountDetailsVo> list) {
		if (CollectionUtils.isEmpty(list)) {
			return list;
		}
		List<ReportStudyCourseAccountDetailsVo> tmp = new ArrayList<>();
		for (ReportStudyCourseAccountDetailsVo vo : list) {
			if (vo.getStudyNum() != 0) {
				tmp.add(vo);
			}
		}
		return tmp;
	}


	@SuppressWarnings("unused")
	private SXSSFSheet createExcel(String sheetName,String headerName,String startDate,String endDate) {
		SXSSFWorkbook wb = new SXSSFWorkbook();
		String[] str= {"用户名","姓名","工号","课程编码","课程名称","总学习时长(HH:mm:ss)","学习开始时间","最后一次学习时间","首次完成时间","学习次数","学习状态","课程得分","用户当前状态","所在部门"};
		SXSSFSheet sheet=excelUtil.createExcel(str, wb, sheetName, headerName, startDate, endDate);
		return sheet;
	}

	@SuppressWarnings("unused")
	private void writeDate(SXSSFRow row,ReportStudyCourseAccountDetailsVo rscv,SimpleDateFormat df) {
		row.createCell(0).setCellValue(rscv.getAccountName());
		row.createCell(1).setCellValue(rscv.getAccountFullName());
		row.createCell(2).setCellValue(rscv.getWorkNum());
		row.createCell(3).setCellValue(rscv.getCourseCode());
		row.createCell(4).setCellValue(rscv.getCourseName());
		row.createCell(5).setCellValue(rscv.getTotalDuration());
		if(rscv.getStartTime()!=null) {
			row.createCell(6).setCellValue(df.format(rscv.getStartTime()));
		}
		if(rscv!=null&&rscv.getLastTime()!=null) {
			row.createCell(7).setCellValue(df.format(rscv.getLastTime()));
		}
		else {
			row.createCell(7).setCellValue("");
		}
		if(rscv!=null&&rscv.getFilstFinishTime()!=null) {
			row.createCell(8).setCellValue(df.format(rscv.getFilstFinishTime()));
		}
		else {
			row.createCell(8).setCellValue("");
		}
		row.createCell(9).setCellValue(rscv.getStudyNum());
		row.createCell(10).setCellValue(rscv.getStudystate());
		if(rscv.getLearnScore()!=null) {
			row.createCell(11).setCellValue(rscv.getLearnScore()+"");
		}
		else {
			row.createCell(11).setCellValue("");
		}
        row.createCell(12).setCellValue(rscv.getAccountState());
		row.createCell(13).setCellValue(rscv.getOrgName());
	}
}
