package com.yizhi.statistics.application.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * @ClassName: PracticeStatViewByIdDto
 * @author: zjl
 * @date: 2020/11/10  17:05
 */
@Data
@ApiModel(value = "PracticeStatViewByIdDto")
public class PracticeStatViewByIdDto {
    @ApiModelProperty("用户id")
    private Long accountId;

    @ApiModelProperty("用户名")
    private String accountName;

    @ApiModelProperty("所在部门")
    private String orgName;

    @ApiModelProperty("所在组织架构")
    private String orgNames;

    @ApiModelProperty("姓名")
    private String fullName;

    @ApiModelProperty("训练次数")
    private Integer trainingCount;

    @ApiModelProperty("考核次数")
    private Integer testCount;

    @ApiModelProperty("首次考核时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private Date firstTestDate;

    @ApiModelProperty("考核最高分")
    private Integer highestScore;

    @ApiModelProperty("考核结果 80:通过，10:未通过")
    private Integer passResultInt;

    @ApiModelProperty("获得积分")
    private Integer point;

}
