package com.yizhi.statistics.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * <p>
 *
 * </p>
 *
 * @author dingxiaowei123
 * @since 2019-04-16
 */
@Data
@ApiModel(value = "StatisticsExamRecorde", description = "")
@TableName("statistics_exam_recorde")
public class StatisticsExamRecorde {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "自增")
	@TableId(value="id")
	private Long id;

    @ApiModelProperty(value = "考试ID")
	@TableField("exam_id")
	private Long examId;

    @ApiModelProperty(value = "用户ID")
	@TableField("account_id")
	private Long accountId;

    @ApiModelProperty(value = "应参加状态，1应参加 0不应参加（用于统计：应参加人数，MAX取值）")
	@TableField("can_state")
	private Integer canState;

    @ApiModelProperty(value = "实际参加状态，1参加 0未参加（用于统计：实参加人数，MAX取值）")
	@TableField("join_state")
	private Integer joinState;

    @ApiModelProperty(value = "考试次数，（当天多次考试的合计数量，SUM取值）")
	@TableField("exam_count")
	private Integer examCount;

    @ApiModelProperty(value = "最早交卷时间，（当天多次考试取最早交卷）")
	@TableField("first_finish_time")
	private Date firstFinishTime;

    @ApiModelProperty(value = "最晚交卷时间，（当天多次考试取最晚交卷）")
	@TableField("last_finish_time")
	private Date lastFinishTime;

    @ApiModelProperty(value = "考试时长")
    @TableField("duration")
    private Integer sumDuration;

    @ApiModelProperty(value = "考试分数（当天多次考试取最高的）")
	private BigDecimal score;

    @ApiModelProperty(value = "考试结果，（当天多次考试只要通过一次视全部通过，1通过 0未通过 -1未参加。用于统计：通过人数，MAX取值）")
	@TableField("exam_state")
	private Integer examState;

    @ApiModelProperty(value = "学员答卷创建时间（多次考试取最早的一次）")
	@TableField("account_answer_create_time")
	private Date accountAnswerCreateTime;

    @ApiModelProperty(value = "记录统计时间")
	@TableField("record_create_time")
	private Date recordCreateTime;

    @ApiModelProperty(value = "获取积分")
	@TableField("point")
	private Integer point;

	@ApiModelProperty(value = "企业id")
	@TableField("company_id")
	private Long companyId;

	@ApiModelProperty(value = "站点id")
	@TableField("site_id")
	private Long siteId;

	@ApiModelProperty(value = "组织id")
	@TableField("org_id")
	private Long orgId;


}
