package com.yizhi.statistics.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 签到明细
 * </p>
 *
 * @author dingxiaowei123
 * @since 2019-04-22
 */
@Data
@ApiModel(value = "StatisticsSignRecorde", description = "签到明细")
@TableName("statistics_sign_recorde")
public class StatisticsSignRecorde {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "自增")
	@TableId(value="id", type= IdType.AUTO)
	private Long id;

    @ApiModelProperty(value = "签到ID")
	@TableField("sign_id")
	private Long signId;

    @ApiModelProperty(value = "签到时段ID")
	@TableField("sign_time_id")
	private Long signTimeId;

    @ApiModelProperty(value = "用户ID")
	@TableField("account_id")
	private Long accountId;

    @ApiModelProperty(value = "签到时间")
	@TableField("sign_time")
	private Date signTime;

    @ApiModelProperty(value = "应参加状态，1应参加 0不应参加（用于统计：应参加人数，MAX取值）")
	@TableField("can_state")
	private Integer canState;

    @ApiModelProperty(value = "实际参加状态，1参加 0未参加（用于统计：实参加人数，MAX取值）")
	@TableField("join_state")
	private Integer joinState;

    @ApiModelProperty(value = "培训项目ID")
	@TableField("trainning_project_id")
	private Long trainningProjectId;

    @ApiModelProperty(value = "记录创建时间")
	@TableField("record_create_time")
	private Date recordCreateTime;

    @ApiModelProperty(value = "某个签到时间段的开始时间")
	@TableField("sign_start_time")
	private Date signStartTime;

    @ApiModelProperty(value = "某个签到时间段的结束时间")
	@TableField("sign_end_time")
	private Date signEndTime;

    @ApiModelProperty(value = "记录更新时间")
	@TableField("record_update_time")
	private Date recordUpdateTime;



}
