package com.yizhi.statistics.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.statistics.application.domain.StatisticsPointDto;
import com.yizhi.statistics.application.entity.PointLog;
import com.yizhi.statistics.application.vo.point.StatisticsPointVO;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;

/**
 * <p>
 * 积分明细 Mapper 接口
 * </p>
 *
 * @author hutao123
 * @since 2021-01-25
 */
public interface PointLogMapper extends BaseMapper<PointLog> {



    /**
     * 获取所有用户积分明细
     * @param companyId
     * @param siteId
     * @param accountKwd
     * @param orgKwd
     * @param startAt
     * @param endAt
     * @param voPage
     * @return
     */
    List<StatisticsPointDto> getAllStatisticsPointList(@Param("companyId") Long companyId,
                                                       @Param("siteId") Long siteId,
                                                       @Param("accountKwd") String accountKwd,
                                                       @Param("orgKwd") String orgKwd,
                                                       @Param("startAt") Date startAt,
                                                       @Param("endAt") Date endAt,
                                                       Page<StatisticsPointVO> voPage);

    /**
     * 查询明细表
     * @param pointDetailId 明细id
     */
    PointLog selectLogByDetailId(@Param("pointDetailId") Long pointDetailId);
}
