package com.yizhi.statistics.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.yizhi.statistics.application.entity.PracticeVisible;
import com.yizhi.system.application.vo.practice.AccountOrgVo;
import org.apache.ibatis.annotations.Param;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author hutao123
 * @since 2020-11-10
 */
public interface PracticeVisibleMapper extends BaseMapper<PracticeVisible> {

    /**
     * 通过陪练id获取陪练可见部门
     *
     * @param practiceId
     * @return
     */
    List<Long> getOrgIdsByPracticeById(Long practiceId);

    /**
     * 通过陪练id获取陪练可见用户
     *
     * @param practiceId
     * @return
     */
    List<Long> getAccountIdsByPracticeById(Long practiceId);

//    void physicalDeletedVisible(@Param("deletedOrgIds") List<Long> deletedOrgIds, @Param("deletedAccountIds") List<Long> deletedAccountIds, @Param("practiceId") Long practiceId);

    void physicalDeletedByOrg(@Param("deletedOrgIds") List<Long> deletedOrgIds, @Param("practiceId") Long practiceId,@Param("visibleType") Integer visibleType);

    void physicalDeletedByAccount(@Param("deletedAccountIds")List<Long> deletedAccountIds, @Param("practiceId") Long practiceId,@Param("visibleType") Integer visibleType);

    /**
     * 获取可参加陪练的人数
     * @param practiceId 陪练id
     */
    //List<PracticeVisible> getCanAccPracticeVisible(@Param("practiceId") Long practiceId,@Param("accountIds") List<Long> accountIds);

    Long getCanAccPracticeVisible( @RequestParam("practiceId") Long practiceId, @RequestParam("accountIds") List<Long> accountIds, @RequestParam("orgIds") List<Long> orgIds, @RequestParam("isAdmin") boolean isAdmin);
}
