package com.yizhi.statistics.application.mapper;

import com.yizhi.statistics.application.course.vo.ReportStudyCourseVo;
import com.yizhi.statistics.application.entity.StatisticsCourse;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.baomidou.mybatisplus.plugins.Page;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author yinyuyan123
 * @since 2019-03-20
 */
public interface StatisticsCourseMapper extends BaseMapper<StatisticsCourse> {

	
	List<StatisticsCourse> listStatisticsCourseBySiteId(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("kwd")String kwd,Page<StatisticsCourse> page);
	

	//按照课程统计。找到十门课程。
	List<Long> courseGroupLimitCourseIdsIsAdmin(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("kwd")String kwd,Page<Long> page);
	//超级管理员有用
	List<ReportStudyCourseVo> listStatisticsCourseIsAdmin(@Param("startDate")String startDate,@Param("endDate")String endDate,@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("isAdmin")Boolean isAdmin,@Param("ids")List<Long> ids);
	//普通管理员有用
	List<ReportStudyCourseVo> listStatisticsCourseNotAdmin(@Param("startDate")String startDate,@Param("endDate")String endDate,@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("isAdmin")Boolean isAdmin,@Param("ids")List<Long> ids,@Param("adminId")Long adminId);
	
}
