package com.yizhi.statistics.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.course.application.vo.StatisticsCourseRecorde;
import com.yizhi.statistics.application.course.vo.*;
import com.yizhi.statistics.application.entity.StatisticsAccount;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author yinyuyan123
 * @since 2019-03-20
 */
public interface StatisticsCourseRecordeMapper extends BaseMapper<StatisticsCourseRecorde> {
	
	Date selectMaxDate();
	
	
	List<ReportStudyCourseChartsVo> chartGroup(@Param("startDate") String startDate, @Param("endDate") String endDate,@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("adminId")Long adminId,@Param("isAdmin")Boolean isAdmin);
	
	
	/**
	 * 全平台，站点管理员
	 * @param startDate
	 * @param endDate
	 * @param courseId
	 * @return
	 */
	ReportStudyCourseVo courseGroup1(@Param("startDate") String startDate, @Param("endDate") String endDate,@Param("courseId")Long courseId,@Param("siteId")Long siteId);
	
	/**
	 * 全平台，管辖区
	 * @param startDate
	 * @param endDate
	 * @param courseId
	 * @return
	 */
	ReportStudyCourseVo courseGroup2(@Param("startDate") String startDate, @Param("endDate") String endDate,@Param("courseId")Long courseId,@Param("adminId") Long adminId);
	
	/**
	 * 指定范围，站点管理员
	 * @param startDate
	 * @param endDate
	 * @param courseId
	 * @param adminId
	 * @return
	 */
	ReportStudyCourseVo courseGroup3(@Param("startDate") String startDate, @Param("endDate") String endDate,@Param("courseId")Long courseId);
	
	
	
/**
 * 指定范围，管辖区
 * @param startDate
 * @param endDate
 * @param courseId
 * @param adminId
 * @return
 */
	ReportStudyCourseVo courseGroup4(@Param("startDate") String startDate, @Param("endDate") String endDate,@Param("courseId")Long courseId,@Param("adminId") Long adminId);



	
	

	List<ReportStudyCourseViewVo> courseGroupView(@Param("startDate") String startDate, @Param("endDate") String endDate,@Param("courseId") Long courseId,@Param("companyId") Long companyId,@Param("siteId") Long siteId, @Param("accoundIds")List<Long> accoundIds);
	
	

	List<ReportStudyCourseAccountVo> courseAccountGroup(@Param("startDate") String startDate, @Param("endDate") String endDate,@Param("companyId") Long companyId,@Param("siteId") Long siteId,@Param("accountIds")List<Long> accountIds);
	Integer courseAccountGroupTotal(@Param("orgKwd")String orgKwd, @Param("accountKwd")String accountKwd, @Param("companyId") Long companyId,@Param("siteId") Long siteId,@Param("isAdmin")Boolean isAdmin,@Param("startPage")Integer startPage,@Param("pageSize")Integer pageSize);

	
	
	List<ReportStudyCourseAccountViewVo> courseAccountGroupView(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("accountId")Long accountId,@Param("startDate") String startDate, @Param("endDate") String endDate,@Param("courseIds") List<Long> courseIds);
	
	List<Long> courseOrgIdsLimit(@Param("kwd")String kwd,@Param("companyId")Long companyId, @Param("siteId")Long siteId,Page<Long> pageOrgLimit);
	
	List<ReportStudyCourseOrgVo> courseOrgGroup(@Param("companyId")Long companyId, @Param("siteId")Long siteId, @Param("startDate") String startDate, @Param("endDate") String endDate,@Param("adminId")Long adminId,@Param("courseOrgIds")List<Long> courseOrgIds);
	
	
	Integer courseOrgGroupTotalIsAdmin(@Param("companyId")Long companyId, @Param("siteId")Long siteId,@Param("adminId")Long adminId);
	
	
	List<Long> courseIdsLimit(@Param("companyId")Long companyId, @Param("siteId")Long siteId, @Param("kwd")String kwd,@Param("accountId")Long accountId,Page<Long> pageCourseIds);
	

	List<ReportStudyCourseAccountDetailsVo> listReportStudyCourseAccountDetailsVo(@Param("companyId")Long companyId, @Param("siteId")Long siteId, @Param("startDate") String startDate, @Param("endDate") String endDate,@Param("accountIdLimitPageSize")List<Long> accountIdLimitPageSize);
	
	List<ReportStudyCourseAccountDetailsVo> listReportStudyCourseAccountDetailsVoReactRecorde(@Param("companyId")Long companyId, @Param("siteId")Long siteId, @Param("startDate") String startDate, @Param("endDate") String endDate,@Param("accountIdLimitPageSize")List<Long> accountIdLimitPageSize);
	
	void selectIntoRecorde(@Param("startDateString") String startDateString, @Param("endDateString") String endDateString);
	
	void updateRecordeOrgId();
	
	
	List<StatisticsAccount> listRecordeOrgIdIsNull();
	void updateOrgIdRecordeById(@Param("id")Long id,@Param("orgId")Long orgId);
	void updateBatchRecordeOrgId(@Param("list")List<StatisticsAccount> list);
	void testProcedure();
	void test2();
	//通过存储过程更新记录的orgId
	void updateOrgIdRecordeByProcedure();
	
	List<ReportStudyCourseViewVo> courseGroupViewExport(@Param("startDate") String startDate, @Param("endDate") String endDate,
			@Param("courseId") Long courseId,@Param("companyId") Long companyId,@Param("siteId") Long siteId, @Param("adminId") Long adminId,
			@Param("adminType")Boolean adminType, @Param("allData")Boolean allData, @Param("orgKwd")String orgKwd, @Param("accountKwd")String accountKwd, Page<ReportStudyCourseViewVo> page);
	
	List<ReportStudyCourseAccountDetailsVo> listReportStudyCourseAccountDetailsVoReactRecordeExport(@Param("companyId")Long companyId, 
			@Param("siteId")Long siteId, @Param("startDate") String startDate, @Param("endDate") String endDate,
			@Param("courseIds") List<Long> courseIds, @Param("adminId") Long adminId,
			@Param("adminType")Boolean adminType, @Param("allData")Boolean allData, 
			@Param("orgKwd")String orgKwd, @Param("accountKwd")String accountKwd);
}
