package com.yizhi.statistics.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.yizhi.statistics.application.course.vo.ReportStudyCourseVo;
import com.yizhi.statistics.application.course.vo.WorkScope;
import com.yizhi.statistics.application.entity.StatisticsCourseVisibleRange;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.Date;
import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author yinyuyan123
 * @since 2019-03-20
 */
public interface StatisticsCourseVisibleRangeMapper extends BaseMapper<StatisticsCourseVisibleRange> {
	
	Integer getScopeBycourseId(@Param("courseId")Long courseId);
	
	/**
	 * 只查询到业务为指定范围的各个业务的可参加人数
	 * @param ids
	 * @return
	 */
	List<ReportStudyCourseVo> getJoinNumByWorkIds(@Param("ids")List<Long> ids,@Param("type")Integer type);
	
	/**
	 * 根据业务信息，查询到各个业务的可见范围
	 * @param ids
	 * @param type
	 * @return
	 */
	List<WorkScope>  getListWorkScope(@Param("ids")List<Long> ids,@Param("type")Integer type);
	
	
	/**
	 * 管辖区和业务指定范围共存
	 * @param ids
	 * @return
	 */
	List<ReportStudyCourseVo> getJoinNumByWorkIdsAndAdminId(@Param("ids")List<Long> ids,@Param("type")Integer type,@Param("adminId")Long adminId);
	
	
	List<WorkScope> listWorkScope();
	

	
	@Select("SELECT DISTINCT(course_id) FROM `statistics_course_visible_range` WHERE is_virtual!=1")
	List<Long> workIds();
	
	
	//业务是指定范围，当前身份是站点管理员的可参加人数
	List<StatisticsCourseVisibleRange> getAdminIdsAndWorkIdsAskNum(@Param("ids")List<Long> ids);
	//业务是指定范围，当前身份是普通管理员的可参加人数
	Long getAskNumByAdminidAndWorkId(@Param("courseId")Long courseId,@Param("type")Integer type,@Param("siteId")Long siteId,@Param("adminId")Long adminId); 
	

	
	
	@Select("SELECT DISTINCT(course_id) FROM `statistics_course_visible_range`")
	List<Long> getAllworkIds();

	/**
	 * 删除所有数据
	 */
	void deleteAllStatisticsCourseVisibleRange();

    Long getOrgVisibleCountByDate(@Param("companyId") Long companyId,
								  @Param("siteId") Long siteId,
								  @Param("orgId") Long orgId,
								  @Param("startAt") Date startAt,
								  @Param("endAt") Date endAt);

	Long getUserVisibleCountByDate(@Param("companyId") Long companyId,
								   @Param("siteId") Long siteId,
								   @Param("startAt") Date startAt,
								   @Param("endAt") Date endAt,
								   @Param("userId") Long userId);

	Long getSiteVisibleCountByDate(@Param("companyId") Long companyId,
								   @Param("siteId") Long siteId,
								   @Param("startAt") Date startAt,
								   @Param("endAt") Date endAt);
}
