package com.yizhi.statistics.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.exam.application.vo.report.*;
import com.yizhi.statistics.application.domain.ExamDto;
import com.yizhi.statistics.application.domain.ExamPassCountGroupOrgDto;
import com.yizhi.statistics.application.domain.OrgCountDto;
import com.yizhi.statistics.application.domain.StatisticsExam;
import com.yizhi.statistics.application.exam.domain.vo.UserExamByOrgVO;
import com.yizhi.statistics.application.exam.domain.vo.UserExamDetailOrgVO;
import com.yizhi.statistics.application.refactor.exam.ExamCountByUserVO;
import com.yizhi.statistics.application.refactor.exam.StatisticsExamVO;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;

/**
 * @author dingxiaowei
 * @date 2019/4/16
 */
public interface StatisticsExamMapper extends BaseMapper<StatisticsExam> {

    List<OrgCountDto> getExamCountByOrgNoAcount(
            @Param("companyId") Long companyId,
            @Param("siteId") Long siteId,
            @Param("startAt") Date startAt,
            @Param("endAt") Date endAt
    );

    Long getRoleJoinExamCount(
            @Param("companyId") Long companyId,
            @Param("siteId") Long siteId,
            @Param("orgId") Long orgId,
            @Param("adminId") Long adminId,
            @Param("startAt") Date startAt,
            @Param("endAt") Date endAt
    );

    List<ExamDto> getUserCanJoinExam (
            @Param("companyId") Long companyId,
            @Param("siteId") Long siteId,
            @Param("orgId") Long orgId,
            @Param("userId") Long userId,
            @Param("startAt") Date startAt,
            @Param("endAt") Date endAt
    );

    List<OrgCountDto> getAccountcVisibleExamCountByOrg(
            @Param("companyId") Long companyId,
            @Param("siteId") Long siteId,
            @Param("startAt") Date startAt,
            @Param("endAt") Date endAt
    );

    Long getExamCountBySitNoAcount(
            @Param("companyId") Long companyId,
            @Param("siteId") Long siteId,
            @Param("startAt") Date startAt,
            @Param("endAt") Date endAt
    );

    List<UserExamByOrgVO> getUserExam(
            @Param("companyId") Long companyId,
            @Param("siteId") Long siteId,
            @Param("orgId") Long orgId,
            @Param("list") List<Long> list,
            @Param("startAt") Date startAt,
            @Param("endAt") Date endAt);

    List<UserExamByOrgVO> getExamDuration(
            @Param("companyId") Long companyId,
            @Param("siteId") Long siteId,
            @Param("orgId") Long orgId,
            @Param("list") List<Long> list,
            @Param("startAt") Date startAt,
            @Param("endAt") Date endAt);

    List<UserExamByOrgVO> getUserPassExamCount(
            @Param("companyId") Long companyId,
            @Param("siteId") Long siteId,
            @Param("orgId") Long orgId,
            @Param("list") List<Long> list,
            @Param("startAt") Date startAt,
            @Param("endAt") Date endAt);

    List<UserExamDetailOrgVO> getExamUserDetail(@Param("companyId") Long companyId,
                                                @Param("siteId") Long siteId,
                                                @Param("orgId") Long orgId,
                                                @Param("startAt") Date startAt,
                                                @Param("endAt") Date endAt,
                                                @Param("list") List<Long> list);

    List<UserExamDetailOrgVO>  getUserDetail(@Param("companyId") Long companyId,
                                             @Param("siteId") Long siteId,
                                             @Param("orgId") Long orgId,
                                             @Param("userName")  String userName,
                                             @Param("admin") Boolean admin,
                                             @Param("accountId") Long accountId,
                                             @Param("startAt") Date startAt,
                                             @Param("endAt") Date endAt);

    Long getExamCountBySiteAndDate(
            @Param("companyId") Long companyId,
            @Param("siteId") Long siteId,
            @Param("startAt") Date startAt,
            @Param("endAt") Date endAt,
            @Param("orgLike") String orgLike);

    List<ExamPassCountGroupOrgDto> getPassExamCountGroupByOrg(
            @Param("companyId") Long companyId,
            @Param("siteId") Long siteId,
            @Param("startAt") Date startAt,
            @Param("endAt") Date endAt,
            @Param("examRersult") Integer examRersult);

    List<ExamPassCountGroupOrgDto> getPassExamCountGroupByOrgNoAdmin(
            @Param("companyId") Long companyId,
            @Param("siteId") Long siteId,
            @Param("startAt") Date startAt,
            @Param("endAt") Date endAt,
            @Param("adminId") Long adminId,
            @Param("examRersult") Integer examRersult);

    //旧方法

    /**
     * 旧方法
     *
     * @param param
     * @param page
     * @return
     */
//    List<ReportExamVO> getExamGroup(@Param("param") ReportExamParam param, Page<ReportExamVO> page);

    /**
     * 超级管理员按考试统计
     *
     * @param param
     * @param idList
     * @return
     */
    List<com.yizhi.statistics.application.refactor.exam.ReportExamVO> getExamGroupAdmin(@Param("param") ReportExamParam param, @Param("idList") List<Long> idList);

    /**
     * 超级管理员按考试统计记录产品总数
     *
     * @param companyId
     * @param siteId
     * @return
     */
    List<Long> getExamGroupCount(@Param("companyId") Long companyId, @Param("siteId") Long siteId,
                                 @Param("examNameLike") String examNameLike, @Param("startTime") String startTime, @Param("endTime") String endTime, Page<Long> page);

    /**
     * 一般管理员按考试统计
     *
     * @param param
     * @param idList
     * @return
     */
    List<com.yizhi.statistics.application.refactor.exam.ReportExamVO> getExamGroupNoAdmin(@Param("param") ReportExamParam param, @Param("idList") List<Long> idList);

//    /**
//     * 旧方法
//     *
//     * @param vo
//     * @param isAllVisible
//     * @param page
//     * @return
//     */
//    List<ReportExamAccountsViewVo> getExamAndAccountGroup(@Param("vo") ExamCountByUserVO vo,
//                                                          @Param("isAllVisible") boolean isAllVisible,
//                                                          Page<ReportExamAccountsViewVo> page);

    /**
     * 超级管理员按考试查看
     *
     * @param vo
     * @param page
     * @return
     */
    List<com.yizhi.statistics.application.refactor.exam.ReportExamAccountsViewVo> getExamAndAccountGroupAdmin(@Param("vo") com.yizhi.statistics.application.refactor.exam.ExamCountByUserVO vo, @Param("isAllVisible") boolean isAllVisible, Page<com.yizhi.statistics.application.refactor.exam.ReportExamAccountsViewVo> page);

    /**
     * 一般管理员按考试查看
     *
     * @param vo
     * @param page
     * @return
     */
    List<com.yizhi.statistics.application.refactor.exam.ReportExamAccountsViewVo> getExamAndAccountGroupNoAdmin(@Param("vo") com.yizhi.statistics.application.refactor.exam.ExamCountByUserVO vo, @Param("isAllVisible") boolean isAllVisible, Page<com.yizhi.statistics.application.refactor.exam.ReportExamAccountsViewVo> page);

    /**
     * 按用户统计
     *
     * @param vo
     * @param page
     * @return
     */
    List<com.yizhi.statistics.application.refactor.exam.ReportExamAccountVO> getAccountGroup(@Param("vo") com.yizhi.statistics.application.refactor.exam.ExamCountByUserVO vo, @Param("accountIds") List<Long> accountIds,
                                                                                             @Param("examIds") List<Long> examIds);

    /**
     * 按用户统计查看
     *
     * @param companyId
     * @param siteId
     * @param accountId
     * @param examNameLike
     * @param page
     * @return
     */
    List<com.yizhi.statistics.application.refactor.exam.ReportExamAccountViewVo> getAccountGroupView(@Param("companyId") Long companyId,
                                                                                                     @Param("siteId") Long siteId,
                                                                                                     @Param("accountId") Long accountId,
                                                                                                     @Param("examNameLike") String examNameLike,
                                                                                                     @Param("startTime") String startTime,
                                                                                                     @Param("endTime") String endTime,
                                                                                                     Page<com.yizhi.statistics.application.refactor.exam.ReportExamAccountViewVo> page);

    /**
     * 获取所有全平台可见的考试数
     *
     * @param companyId
     * @param siteId
     * @return
     */
    Integer getAllVibleNum(@Param("companyId") Long companyId, @Param("siteId") Long siteId, @Param("startTime") String startTime, @Param("endTime") String endTime);


    Integer getOrgAccountNum(@Param("examId") Long examId, @Param("companyId") Long companyId, @Param("siteId") Long siteId);

    List<Long> getAccountIds(@Param("vo") ExamCountByUserVO vo, Page<Long> accountPage);

    List<Long> getExamIds(@Param("companyId") Long companyId, @Param("siteId") Long siteId,
                          @Param("startTime") String startTime, @Param("endTime") String endTime);

    StatisticsExamVO getExam(@Param("examId") Long examId);


}
