package com.yizhi.statistics.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.statistics.application.entity.StatisticsTraining;
import com.yizhi.statistics.application.training.vo.TrainingProjectAccountRecords;
import com.yizhi.training.application.vo.manage.*;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;


/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author wfd123
 * @since 2019-05-13
 */
public interface StatisticsTrainingMapper extends BaseMapper<StatisticsTraining> {
	
	List<TrainingProjectDataChartsVo> chartGroup(@Param("companyId")Long companyId, @Param("siteId")Long siteId, @Param("adminId")Long adminId, @Param("isAdmin")Boolean isAdmin, @Param("startDate")String startDate, @Param("endDate")String endDate);
	
	List<Long> trainingGroupLimit(@Param("startDate")String startDate,@Param("endDate")String endDate,@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("kwd")String kwd,Page<Long> pageLimit);

	
	
	List<TrainingProjectDataChartsVo> trainingGroupView(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("adminId")Long adminId,@Param("isAdmin")Boolean isAdmin,@Param("tpId")Long tpId,Page<TrainingProjectDataChartsVo> page);
	
	List<Long> accountIdsLimit(@Param("orgKwd")String orgKwd,@Param("accountKwd")String accountKwd,@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("adminId")Long adminId,@Param("isAdmin")Boolean isAdmin,Page<Long> pageAccountIds);
	
	List<ReportStudyTrainingProjectAccountVo> trainingProjectAccountGroup(@Param("companyId")Long companyId, @Param("siteId")Long siteId, @Param("accountIds")List<Long> accountIds, @Param("startDate")String startDate, @Param("endDate")String endDate);
	
	List<Long> trainingProjectIdsAccountGroupView(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("accountId")Long accountId,@Param("projectName")String projectName,Page<Long> pageLimitTpIds);
	
	List<ReportStudyTrainingProjectAccountViewVo> trainingProjectAccountGroupView(@Param("companyId")Long companyId, @Param("siteId")Long siteId, @Param("accountId")Long accountId, @Param("tpIds")List<Long> tpIds);
	
	List<ReportStudyTrainingProjectAccountViewVo> trainingProjectAccountGroupViewExport(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("accountId")Long accountId,@Param("tpIds")List<Long> tpIds);
	
	List<TrainingProjectGroupViewExportVO1> export1(@Param("companyId")Long companyId, @Param("siteId")Long siteId, @Param("adminId")Long adminId, @Param("tpId")Long tpId, @Param("isAdmin")Boolean isAdmin);
	List<TrainingProjectGroupViewExportVO2> export2(@Param("companyId")Long companyId, @Param("siteId")Long siteId, @Param("adminId")Long adminId, @Param("tpId")Long tpId, @Param("isAdmin")Boolean isAdmin);
	List<TrainingProjectGroupViewExportVO3> export3(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("adminId")Long adminId,@Param("tpId")Long tpId,@Param("isAdmin")Boolean isAdmin);
	
	List<ReportStudyTrainingProjectOrgVo> orgIdsLimit(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("adminId")Long adminId,@Param("isAdmin")Boolean isAdmin,@Param("kwd")String kwd,Page<Long> pageLimit);

	/**
	 * 查询项目活动中课程学习时长
	 * @param courseId
	 * @return
	 */
	Integer selectTrainingCourseLearningTime(@Param("courseId") Long courseId);
	
	
	/**
	 * 获取人员信息
	 * @param companyId
	 * @param siteId
	 * @param adminId
	 * @param tpId
	 * @return
	 */
	List<TrainingProjectAccountRecords> getTrainingAccounts(@Param("companyId") Long companyId,
			@Param("siteId") Long siteId, @Param("adminType") boolean adminType, @Param("adminId") Long adminId, @Param("tpId") Long tpId);

	/**
	 * 获取活动
	 * @param companyId
	 * @param siteId
	 * @param tpId
	 * @return
	 */
	List<TrainingProjectAccountRecords> getTrainingPlanActivitys(@Param("companyId") Long companyId,
			@Param("siteId") Long siteId, @Param("tpId") Long tpId);

	/**
	 * 获取活动学习记录，废弃
	 * @param relationId
	 * @return
	 */
	@Deprecated
	List<TrainingProjectAccountRecords> getTrainingRelations(@Param("relationId") Long relationId);
	
	/**
	 * 获取全平台可见的培训项目数
	 */
	Integer getTpCount(@Param("companyId") Long companyId,
			@Param("siteId") Long siteId);
	
	/**
	 * 优化项目统计
	 */
	List<TrainingProjectDataChartsVo> chartGroupNew(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("startDate")String startDate,@Param("endDate")String endDate);
	
	List<TrainingProjectDataChartsVo> chartGroupNewTotalIn(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("adminId")Long adminId,@Param("isAdmin")Boolean isAdmin,@Param("startDate")String startDate,@Param("endDate")String endDate);
	
	List<TrainingProjectDataChartsVo> chartGroupNewTotalFinish(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("adminId")Long adminId,@Param("isAdmin")Boolean isAdmin,@Param("startDate")String startDate,@Param("endDate")String endDate);
	
	List<ReportStudyTrainingProjectAccountVo> trainingProjectAccountGroupNew(@Param("accountIds")List<Long> accountIds);
	List<ReportStudyTrainingProjectAccountVo> trainingProjectAccountGroupNewTotalAsk(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("accountIds")List<Long> accountIds,@Param("startDate")String startDate,@Param("endDate")String endDate);
	List<ReportStudyTrainingProjectAccountVo> trainingProjectAccountGroupNewTotalIn(@Param("companyId")Long companyId,@Param("siteId")Long siteId,
			@Param("accountIds")List<Long> accountIds, @Param("startDate")String startDate, @Param("endDate")String endDate, 
			@Param("isAdmin")Boolean isAdmin, @Param("adminId")Long adminId);
	List<ReportStudyTrainingProjectAccountVo> trainingProjectAccountGroupNewTotalFinish(@Param("companyId")Long companyId,@Param("siteId")Long siteId,
			@Param("accountIds")List<Long> accountIds, @Param("startDate")String startDate, @Param("endDate")String endDate, 
			@Param("isAdmin")Boolean isAdmin, @Param("adminId")Long adminId);
	
	List<ReportStudyTrainingProjectOrgVo> orgIdsLimitNew(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("adminId")Long adminId,@Param("isAdmin")Boolean isAdmin,@Param("kwd")String kwd,Page<Long> pageLimit);
	List<ReportStudyTrainingProjectOrgVo> trainingProjectOrgGroupNewTotalAsk(@Param("companyId")Long companyId,@Param("siteId")Long siteId, @Param("orgIds")List<Long> orgIds);
	List<ReportStudyTrainingProjectOrgVo> trainingProjectOrgGroupNewTotalIn(@Param("companyId")Long companyId,@Param("siteId")Long siteId, @Param("orgIds")List<Long> orgIds, @Param("startDate")String startDate,@Param("endDate")String endDate);
	List<ReportStudyTrainingProjectOrgVo> trainingProjectOrgGroupNewTotalFinish(@Param("companyId")Long companyId,@Param("siteId")Long siteId, @Param("orgIds")List<Long> orgIds, @Param("startDate")String startDate,@Param("endDate")String endDate);
	
	/**
	 * 获取活动学习记录
	 * @param relationId
	 * @return
	 */
	List<TrainingProjectAccountRecords> getTrainingRelationsNew(@Param("relationId") Long relationId,@Param("startAt") Date startAt,@Param("endAt") Date endAt);
}
