package com.yizhi.statistics.application.mapper;


import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.yizhi.statistics.application.entity.StatisticsActivityPoint;
import com.yizhi.statistics.application.entity.StatisticsTrainingStudentActivityRecord;
import com.yizhi.training.application.vo.manage.ReportStudyTrainingProjectOrgVo;
import com.yizhi.training.application.vo.manage.ReportStudyTrainingProjectVo;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;

/**
 * <p>
 * 学员完成活动记录（这里无论有没有被设置成别的活动的开启条件，都记录） Mapper 接口
 * </p>
 *
 * @author wfd123
 * @since 2019-05-13
 */
public interface StatisticsTrainingStudentActivityRecordMapper extends BaseMapper<StatisticsTrainingStudentActivityRecord> {

	
	Date selectMaxDate();
	
	void deleteLimitTime(@Param("startDate") String startDate, @Param("endDate") String endDate);
	
	
	List<ReportStudyTrainingProjectVo> trainingProjectGroup(@Param("companyId")Long companyId, @Param("siteId")Long siteId, @Param("adminId")Long adminId, @Param("isAdmin")Boolean isAdmin, @Param("trainingProjectIds")List<Long> trainingProjectIds);
	
	ReportStudyTrainingProjectVo trainingProjectGroupByTpId(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("adminId")Long adminId,@Param("isAdmin")Boolean isAdmin,@Param("tpId")Long tpId);
	
	List<ReportStudyTrainingProjectVo> trainingProjectGroupBySQLZhige(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("adminId")Long adminId,@Param("isAdmin")Boolean isAdmin,@Param("trainingProjectIds")List<Long> trainingProjectIds);
	
	List<ReportStudyTrainingProjectVo> trainingProjectGroupBySQL(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("adminId")Long adminId,@Param("isAdmin")Boolean isAdmin,@Param("trainingProjectIds")List<Long> trainingProjectIds,@Param("startDate")String startDate,@Param("endDate")String endDate);
	
	List<ReportStudyTrainingProjectOrgVo> trainingProjectOrgGroupNew(@Param("companyId")Long companyId, @Param("siteId")Long siteId, @Param("adminId")Long adminId, @Param("orgIds")List<Long> orgIds, @Param("isAdmin")Boolean isAdmin, @Param("startDate") String startDate, @Param("endDate") String endDate);
	
    List<StatisticsActivityPoint> listStatisticsActivityPoint();
    
    List<ReportStudyTrainingProjectOrgVo> trainingProjectOrgGroupAll(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("orgIds")List<Long> orgIds,@Param("startDate") String startDate, @Param("endDate") String endDate);
    
    
    /**
     * 优化报表统计
     */
    List<Long> getTrainings();

    Long getTrainingById(@Param("trainingProjecId") Long trainingProjecId);
    
    //删除实际参加人数表
    void deleteTrainingActivitys();

    void deleteTrainingActivitysById(@Param("trainingProjecId") Long trainingProjecId);
    
    //添加实际参加人数表
    void addTrainingActivitys(@Param("trainingProjects")List<Long> trainingProjects);
    
  //删除实际参加人数表
    void deleteTrainingProjectActivitys();   
    
    //添加实际参加人数表
    void addTrainingProjectActivitys(@Param("trainingProjects")List<Long> trainingProjects);
    
    //
    List<ReportStudyTrainingProjectVo> trainingProjectGroupBySQLNew(@Param("companyId")Long companyId,@Param("siteId")Long siteId,
    		@Param("trainingProjectIds")List<Long> trainingProjectIds);
    
    List<ReportStudyTrainingProjectVo> trainingProjectGroupBySQLNewTotalIn(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("adminId")Long adminId,@Param("isAdmin")Boolean isAdmin,@Param("trainingProjectIds")List<Long> trainingProjectIds,@Param("startDate")String startDate,@Param("endDate")String endDate);
    
    List<ReportStudyTrainingProjectVo> trainingProjectGroupBySQLNewTotalFinish(@Param("companyId")Long companyId,@Param("siteId")Long siteId,@Param("adminId")Long adminId,@Param("isAdmin")Boolean isAdmin,@Param("trainingProjectIds")List<Long> trainingProjectIds,@Param("startDate")String startDate,@Param("endDate")String endDate);
    
}
