package com.yizhi.statistics.application.service;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.IService;
import com.yizhi.statistics.application.entity.StatisticsTraining;
import com.yizhi.statistics.application.training.vo.TrainingProjectAccountRecords;
import com.yizhi.training.application.vo.domain.TrainingProjectVo;
import com.yizhi.training.application.vo.manage.*;

import java.util.Date;
import java.util.List;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author wfd123
 * @since 2019-05-13
 */
public interface IStatisticsTrainingService extends IService<StatisticsTraining> {
	
	StatisticsTraining getStatisticsTrainingByTpId(Long tpId);
	
	void dealStatisticsTraining(TrainingProjectVo tp);
	
	List<TrainingProjectDataChartsVo> chartGroup(Long companyId,Long siteId,Long adminId,Boolean isAdmin,String startDate,String endDate);
	
	Page<ReportStudyTrainingProjectVo> trainingProjectGroup(String kwd, String startDate, String endDate, Long companyId, Long siteId, Long adminId, Boolean isAdmin, Integer pageNo, Integer pageSize);

	Page<TrainingProjectDataChartsVo> trainingProjectGroupView(Long companyId, Long siteId, Long adminId, Boolean isAdmin, Long tpId, Integer pageNo, Integer pageSize);
	
	//单个培训项目查看第一个下载
	List<TrainingProjectGroupViewExportVO1> export1(Long companyId, Long siteId, Long adminId, Boolean isAdmin, Long tpId);
	//单个培训项目查看第二个下载
	List<TrainingProjectGroupViewExportVO2> export2(Long companyId, Long siteId, Long adminId, Boolean isAdmin, Long tpId);
	//单个培训项目查看第三个下载
	List<TrainingProjectGroupViewExportVO3> export3(Long companyId, Long siteId, Long adminId, Boolean isAdmin, Long tpId);
	
	Page<ReportStudyTrainingProjectAccountVo> trainingProjectAccountGroup(Long companyId,Long siteId,Long adminId,Boolean isAdmin,String orgKwd,String accountKwd,Integer pageNo,Integer pageSize,String startDate,String endDate);
	
	Page<ReportStudyTrainingProjectAccountViewVo> trainingProjectAccountGroupView(Long companyId,Long siteId,Integer pageNo,Integer pageSize,Long accountId,String projectName,Integer type);
	
	Page<ReportStudyTrainingProjectOrgVo> trainingProjectOrgGroup(Long companyId,Long siteId,Long adminId,Boolean isAdmin,String kwd,Integer pageNo,Integer pageSize,String startDate,String endDate);

	/**
	 * 查询项目活动中课程学时长
	 * @param coureId
	 * @return
	 */
	Integer findTrainingCourseLearningTime(Long coureId);
	
	
	/**
	 * 获取人员信息
	 * @param companyId
	 * @param siteId
	 * @param adminId
	 * @param tpId
	 * @return
	 */
	List<TrainingProjectAccountRecords> getTrainingAccounts(Long companyId,
			Long siteId, boolean adminType, Long adminId, Long tpId);

	/**
	 * 获取活动
	 * @param companyId
	 * @param siteId
	 * @param tpId
	 * @return
	 */
	List<TrainingProjectAccountRecords> getTrainingPlanActivitys(Long companyId,
			Long siteId, Long tpId);

	/**
	 * 获取活动学习记录，废弃
	 * @param relationId
	 * @return
	 */
	@Deprecated
	List<TrainingProjectAccountRecords> getTrainingRelations(Long relationId);
	
	/**
	 * 获取活动学习记录
	 * @param relationId
	 * @return
	 */
	List<TrainingProjectAccountRecords> getTrainingRelationsNew(Long relationId, Date startAt, Date endAt);
}