package com.yizhi.statistics.application.service;

import com.baomidou.mybatisplus.service.IService;
import com.yizhi.statistics.application.domain.ExamGroupOrgDto;
import com.yizhi.statistics.application.domain.OrgCountDto;
import com.yizhi.statistics.application.entity.StatisticsAccount;
import com.yizhi.statistics.application.exam.domain.po.UserExamGroupPO;
import com.yizhi.statistics.application.vo.practice.PracticeStatByOrgVo;
import com.yizhi.statistics.application.vo.report.AccountVO;
import com.yizhi.system.application.vo.ReportAccountRespVO;

import java.util.Date;
import java.util.List;

/**
 * @author wangfeida
 */
public interface StatisticsAccountService extends IService<StatisticsAccount> {

    Long getOrgCount(Long companyId, Long siteId,String orgNameLike);

    Long getManageOrgCount(Long companyId, Long siteId,String orgNameLike,List<Long> orgIds);

    Boolean insertToStatisticsAccount(String relationId, List<ReportAccountRespVO> list, Long siteId, Long companyId);

    List<StatisticsAccount> getStatisticsAccountBySiteId(Long siteId);

    StatisticsAccount getStatisticsAccountByAccountId(Long accountId);

    void deleteStatisticsAccount(Long siteId);

    List<AccountVO> getAccountIdsBySiteId(Long siteId);

    List<OrgCountDto> getUserCountByOrgIdAndSiteIdAndCompanyId(Long companyId, Long siteId);

    List<ExamGroupOrgDto> getOrgByCompanyAndSiteId(Long companyId, Long siteId, Long pageIndex, Long pageSize,String orgName);

    List<OrgCountDto> getUserCountByOrgIdAndSiteIdAndCompanyIdNoAdmin(Long companyId, Long siteId, Long adminId);

    List<OrgCountDto> getRoleOrgCount( Long siteId, Long adminId);

    List<AccountVO> getUserIdByNameLike(UserExamGroupPO po);

    Long getUserCountByNameLike(UserExamGroupPO po);

    List<Long> getUserByManager(Long adminId, Long SiteId, Long orgId);

    AccountVO getOrgInfoByOrgId(Long companyId,Long siteId,Long orgId);

    Long getVisibleAccountByNoAdmin(
            Long companyId, Long siteId, Long orgId, Long adminId, Date startAt , Date endAt);

    List<StatisticsAccount> getAccountByIds(List<Long> ids, Long companyId);

    Long getUserCount(List<Long> manageOrgIds, Long companyId);

    List<StatisticsAccount> getAccountByOrgId(Long companyId, Long visibleOrgId);

    List<PracticeStatByOrgVo> getOrgByCompanyAndSiteIdNoadmin(Long companyId, Long siteId, Long pageIndex, Long pageSize, String orgNameLike, List<Long> manageOrgIds);

    Long getOrgCountByPractice(Long companyId, Long siteId, String orgNameLike, List<Long> manageOrgIds);
}
