package com.yizhi.statistics.application.service;

import com.baomidou.mybatisplus.service.IService;
import com.yizhi.course.application.vo.CourseAccountReport;
import com.yizhi.statistics.application.entity.StatisticsCourseVisibleRange;

import java.util.Date;
import java.util.List;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author yinyuyan123
 * @since 2019-03-20
 */
public interface StatisticsCourseVisibleRangeService extends IService<StatisticsCourseVisibleRange> {

    /**
     * 获取时间段内对部门所有用户可见的活动的数量
     *
     * @param companyId
     * @param siteId    //	 * @param orgId  目前对该表的该字段的业务逻辑不是很清楚  所以先不采用该字段查询。。。2020-09-20
     * @param startAt
     * @param endAt
     * @return
     */
    Long getUserCanJoinExamCountByDate(Long companyId,
                                       Long siteId,
                                       Long orgId,
                                       Date startAt,
                                       Date endAt,
                                       Long userId);


    /**
     * 根据业务id，查可见范围对应关系
     *
     * @param courseId
     * @return
     */
    List<StatisticsCourseVisibleRange> getStatisticsCourseVisibleRangeByCourseIdAndIsVirtual(Long workId, Integer type, Integer newScope);


    /**
     * 修改可见范围  1 平台用户 2 指定范围
     *
     * @param newScope  新传进来的可见范围
     * @param oldScope  原来我们的报表系统的可见范围
     * @param courseId  业务关系
     * @param siteId    业务所在的站点
     * @param virtualId 业务的可见范围，如果新更改为全平台传站点id，如果新更改为指定范围，传虚拟站点
     * @return
     */
    Boolean updateVisibleRange(Integer newScope, Integer oldScope, Long courseId, Date curDate, String cachKey);


    //插入可见范围
    List<StatisticsCourseVisibleRange> insertVisibleRange(Long companyId, Long courseId, Integer scope, Integer type, Date curDate, Long siteId, CourseAccountReport orgIdsAndAccountIds);


    StatisticsCourseVisibleRange getgetStatisticsCourseVisibleRange(Long courseId);

    /**
     * 删除所有数据
     */
    void deleteAllStatisticsCourseVisibleRange();
}
