package com.yizhi.statistics.application.service;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.IService;
import com.yizhi.statistics.application.domain.StatisticsExam;
import com.yizhi.statistics.application.exam.domain.po.ExamGroupPO;
import com.yizhi.statistics.application.exam.domain.po.UserExamGroupPO;
import com.yizhi.statistics.application.exam.domain.vo.ExamGroupOrgVO;
import com.yizhi.statistics.application.exam.domain.vo.UserExamByOrgVO;
import com.yizhi.statistics.application.exam.domain.vo.UserExamDetailOrgVO;
import com.yizhi.statistics.application.refactor.exam.ExamCountByUserVO;
import com.yizhi.statistics.application.refactor.exam.ReportExamAccountVO;
import com.yizhi.statistics.application.refactor.exam.ReportExamAccountViewVo;
import com.yizhi.statistics.application.refactor.exam.StatisticsExamVO;

import java.util.List;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author ding
 * @since 2019-04-17
 */
public interface StatisticsExamService extends IService<StatisticsExam> {

    Page<com.yizhi.statistics.application.refactor.exam.ReportExamVO> getExamGroup(com.yizhi.statistics.application.refactor.exam.ReportExamParam reportExamParam);

    Page<com.yizhi.statistics.application.refactor.exam.ReportExamAccountsViewVo> getExamAndAccountGroup(com.yizhi.statistics.application.refactor.exam.ExamCountByUserVO vo);

    Page<ReportExamAccountVO> getAccountGroup(ExamCountByUserVO vo);

    Page<ReportExamAccountViewVo> getAccountGroupView(Long companyId, Long siteId, Long accountId, String startTime, String endTime, String examNameLike, Integer pageNo, Integer pageSize);

    StatisticsExamVO getExam(Long examId);

    Page<ExamGroupOrgVO> getExamGroupByOrg(ExamGroupPO po);

    Page<UserExamByOrgVO> getUserExam(UserExamGroupPO po);

    List<UserExamDetailOrgVO> getExamUserDetail(UserExamGroupPO po);
}
