package com.yizhi.statistics.application.service.impl;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.course.application.vo.CourseDashboardParam;
import com.yizhi.statistics.application.entity.AccountDashboard;
import com.yizhi.statistics.application.mapper.AccountDashboardMapper;
import com.yizhi.statistics.application.service.IAccountDashboardService;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author taoge123
 * @since 2020-04-07
 */
@Service
public class AccountDashboardServiceImpl extends ServiceImpl<AccountDashboardMapper, AccountDashboard> implements IAccountDashboardService {


    @Override
    public Boolean deleteAllData(Date startDate, Date endDate) {
        AccountDashboard accountDashboard = new AccountDashboard();
        EntityWrapper<AccountDashboard> w = new EntityWrapper<>(accountDashboard);
        w.between("study_record_time",startDate,endDate);
        return this.delete(w);
    }

    @Override
    public List<AccountDashboard> getRecords(CourseDashboardParam param) {
        RequestContext context = ContextHolder.get();
        AccountDashboard accountDashboard = new AccountDashboard();
        accountDashboard.setSiteId(context.getSiteId());
        accountDashboard.setAccountId(context.getAccountId());
        EntityWrapper<AccountDashboard> w = new EntityWrapper<>(accountDashboard);
        w.between("study_record_time",param.getStartDate(),param.getEndDate());
        w.groupBy("study_record_time");
        w.orderBy("",true);
        List<AccountDashboard> accountDashboards = this.baseMapper.selectList(w);
        return accountDashboards;
    }

}
