package com.yizhi.statistics.application.service.impl;

import java.text.SimpleDateFormat;
import java.util.Date;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.core.application.cache.RedisCache;
import com.yizhi.practice.application.feign.PracticeConfigClient;
import com.yizhi.statistics.application.controller.practice.PracticeAbs;
import com.yizhi.statistics.application.controller.practice.PracticeChatLogAbs;
import com.yizhi.statistics.application.controller.practice.PracticeTaskParam;
import com.yizhi.statistics.application.controller.practice.PracticeVisibleAbs;
import com.yizhi.statistics.application.entity.PracticeConfig;
import com.yizhi.statistics.application.mapper.PracticeConfigMapper;
import com.yizhi.statistics.application.service.IPracticeConfigService;

/**
 * <p>
 * 陪练配置 服务实现类
 * </p>
 */
@Service
public class PracticeConfigServiceImpl extends ServiceImpl<PracticeConfigMapper, PracticeConfig> implements IPracticeConfigService {

    private static int expireTimeSecond = 3600 * 2;

    @Autowired
    PracticeConfigClient practiceConfigClient;
    @Autowired
    private PracticeAbs practiceAbs;
    @Autowired
    private PracticeChatLogAbs chatLogAbs;
    @Autowired
    private PracticeVisibleAbs visibleAbs;
    @Autowired
    private RedisCache redisCache;


    @Override
    public void syncData(String startOfDate, String endOfDate) {

        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date nowDate = new Date();
        String currentTime = simpleDateFormat.format(nowDate);
        String redisKey = "statisticsTree:statistics:practice:job:running:"+currentTime+"_lock_statistics";
        String redisValue = "practice-copy-job";
        boolean result = redisCache.setIfAbsent(redisKey,redisValue);
        if (result){
            redisCache.expire(redisKey,expireTimeSecond);
            PracticeTaskParam taskParam = new PracticeTaskParam();
            taskParam.setStartDate(startOfDate);
            taskParam.setEndDate(endOfDate);
            practiceAbs.execute(taskParam,true);
            visibleAbs.execute(taskParam,true);
            chatLogAbs.execute(taskParam,true);
        }
        return;
    }
}
