package com.yizhi.statistics.application.service.impl;

import java.math.BigDecimal;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.statistics.application.entity.ReportDetail;
import com.yizhi.statistics.application.mapper.ReportDetailMapper;
import com.yizhi.statistics.application.service.IReportDetailService;
import com.yizhi.statistics.application.vo.report.AccountVO;
import com.yizhi.statistics.application.vo.report.ReportParm;
import com.yizhi.statistics.application.vo.report.StudyDurationVO;

@Service
public class ReportDetailServiceImpl extends ServiceImpl<ReportDetailMapper, ReportDetail> implements IReportDetailService {

	@Override
	public Map<Long, StudyDurationVO> studyDuration(List<Long> siteIds,String startDate,String endDate,List<AccountVO> accounts) {
		Map<Long,StudyDurationVO> map = new HashMap<Long, StudyDurationVO>();
		Map<Long, Integer> finishMap = new HashMap<Long, Integer>();
		Map<Long, Integer> proportionMap = new HashMap<Long, Integer>();
		Map<Long, Long> totalDurationMap = new HashMap<Long, Long>();
		Map<Long, Date> lateDateMap = new HashMap<Long, Date>();
		Map<Long, Date> maxDateMap = new HashMap<Long, Date>();
		Map<Long, Long> maxDurationMap = new HashMap<Long, Long>();
		List<StudyDurationVO> countFinished = this.baseMapper.countFinished( siteIds, startDate, endDate);
		List<StudyDurationVO> proportion = this.baseMapper.proportion( siteIds, startDate, endDate);
		List<StudyDurationVO> totalDuration = this.baseMapper.totalDuration( siteIds, startDate, endDate);
		List<StudyDurationVO> studyDuration = this.baseMapper.studyDuration( siteIds, startDate, endDate);
		List<StudyDurationVO> lateDate = this.baseMapper.lateDate(siteIds, startDate, endDate);
				for(StudyDurationVO vo1:countFinished) {
					finishMap.put(vo1.getAccountId(), vo1.getFinish());
				}
				for(StudyDurationVO vo1:proportion) {
					proportionMap.put(vo1.getAccountId(), vo1.getProportion());
				}
				for(StudyDurationVO vo1:totalDuration) {
					totalDurationMap.put(vo1.getAccountId(), vo1.getTotalDuration());
				}
				for(StudyDurationVO vo1:lateDate) {
					lateDateMap.put(vo1.getAccountId(), vo1.getLateDate());
				}
				for(StudyDurationVO vo1:studyDuration) {
					maxDateMap.put(vo1.getAccountId(), vo1.getMaxDate());
					maxDurationMap.put(vo1.getAccountId(), vo1.getMaxDuration());
				}
				for(AccountVO account:accounts) {
					StudyDurationVO vo = new StudyDurationVO();
					Long accountId = account.getAccountId();
					BigDecimal res = new BigDecimal(0);
					if (Integer.valueOf(accounts.size())!=null&&proportionMap.get(accountId)!=null) {
						Integer dividend=(Integer.valueOf(accounts.size())-proportionMap.get(accountId));
						Integer divisor = accounts.size();
				        BigDecimal dividendN = new BigDecimal(dividend.toString());
				        BigDecimal divisorN = new BigDecimal(divisor.toString());
				        BigDecimal a = dividendN.multiply(new BigDecimal("100"));
				        res = a.divide(divisorN, 2, BigDecimal.ROUND_HALF_UP);
					}
					vo.setAccountId(accountId);
					vo.setFinish(null!=finishMap.get(accountId)?finishMap.get(accountId):0);
					vo.setProportion(null!=proportionMap.get(accountId)?res.intValue():0);
					vo.setTotalDuration(null!=totalDurationMap.get(accountId)?totalDurationMap.get(accountId):0l);
					vo.setMaxDate(null!=maxDateMap.get(accountId)?maxDateMap.get(accountId):null);
					vo.setMaxDuration(null!=maxDurationMap.get(accountId)?maxDurationMap.get(accountId):0l);
					vo.setLateDate(null!=lateDateMap.get(accountId)?lateDateMap.get(accountId):null);
					map.put(accountId, vo);
				}
		return map;
	}

	@Override
	public Long getCount(Long reportId, Long siteId) {
		// TODO Auto-generated method stub
		return this.baseMapper.getCount(reportId, siteId);
	}
}
