package com.yizhi.statistics.application.service.impl;

import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.statistics.application.domain.OrgCountDto;
import com.yizhi.statistics.application.entity.StatisticsAccountRole;
import com.yizhi.statistics.application.mapper.StatisticsAccountRoleMapper;
import com.yizhi.statistics.application.service.IStatisticsAccountRoleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author wfd123
 * @since 2019-04-18
 */
@Service
public class StatisticsAccountRoleServiceImpl extends ServiceImpl<StatisticsAccountRoleMapper, StatisticsAccountRole> implements IStatisticsAccountRoleService {


    @Autowired
    private StatisticsAccountRoleMapper statisticsAccountRoleMapper;

    @Override
    public Boolean deleteRoleByAdminId(Long adminId, List<Long> accountDeleteIds) {
        // TODO Auto-generated method stub
        return statisticsAccountRoleMapper.deleteRoleByAdminId(adminId, accountDeleteIds);
    }

    @Override
    public void deleteRole(Long accountId) {
        // TODO Auto-generated method stub
        statisticsAccountRoleMapper.deleteAdmin(accountId);
    }

    @Override
    public boolean getIsAdmin(Integer type, Long siteId, Long adminId) {

        Integer isAdmin = statisticsAccountRoleMapper.getIsAdmin(type, siteId, adminId);
        if (isAdmin != null && isAdmin == 1) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public List<OrgCountDto> getAccountByAdminId(Long adminId,Long siteId) {
        return statisticsAccountRoleMapper.getAccountIdByAdminId(adminId,siteId);
    }


}

