package com.yizhi.statistics.application.service.impl;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.point.application.feign.PointDetailsFeignClients;
import com.yizhi.point.application.feign.PointUserFeignClients;
import com.yizhi.point.application.vo.domain.PointDetailsVo;
import com.yizhi.statistics.application.entity.StatisticsActivityPoint;
import com.yizhi.statistics.application.mapper.StatisticsActivityPointMapper;
import com.yizhi.statistics.application.mapper.StatisticsTrainingStudentActivityRecordMapper;
import com.yizhi.statistics.application.service.IStatisticsActivityPointService;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author wfd123
 * @since 2019-06-05
 */
@Service
public class StatisticsActivityPointServiceImpl extends ServiceImpl<StatisticsActivityPointMapper, StatisticsActivityPoint> implements IStatisticsActivityPointService {

	@Autowired
	
	StatisticsTrainingStudentActivityRecordMapper statisticsTrainingStudentActivityRecordMapper;
	
	 @Autowired
	 private PointUserFeignClients pointUserFeignClients;
	 
	 @Autowired
	 private IdGenerator idGenerator;
	 
	 @Autowired
	private PointDetailsFeignClients pointDetailsFeignClients;
	
	@Override
	public void dealBatchPoint() {
		// TODO Auto-generated method stub
		Long t1=System.currentTimeMillis();
		 List<StatisticsActivityPoint> listActivityNoPoint=statisticsTrainingStudentActivityRecordMapper.listStatisticsActivityPoint();
		 Long t2=System.currentTimeMillis();
		 System.out.println("筛选活动集合消耗时间(ms):"+(t2-t1));
		 if(CollectionUtils.isNotEmpty(listActivityNoPoint)) {
			 StatisticsActivityPoint statisticsActivityNoPoint=null;
			 Integer listSize=listActivityNoPoint.size();
			 for (int i = 0; i < listActivityNoPoint.size(); i++) {
				
				 statisticsActivityNoPoint=listActivityNoPoint.get(i);
				 Long t3=System.currentTimeMillis();
				 Long companyId=statisticsActivityNoPoint.getCompanyId();
				 Long siteId=statisticsActivityNoPoint.getSiteId();
				 Long activityId=statisticsActivityNoPoint.getActivityId();
				 Integer type=statisticsActivityNoPoint.getType();
				 Long accountId=statisticsActivityNoPoint.getAccountId();
				 List<PointDetailsVo> listPoint=null;
				 if(type==0) {
					 listPoint=pointUserFeignClients.getReportPoints(activityId, accountId, companyId, siteId, false);
				 }
				 else {
					 listPoint=pointUserFeignClients.getCourseReportPoints(activityId, accountId, false);
				 }
				 PointDetailsVo pointDetails=null;
				 StatisticsActivityPoint statisticsActivityPoint=null;
				 if(CollectionUtils.isNotEmpty(listPoint)) {
					 pointDetails=listPoint.get(0);
					 statisticsActivityPoint=new StatisticsActivityPoint();
					 statisticsActivityPoint.setId(idGenerator.generate());
					 statisticsActivityPoint.setActivityId(pointDetails.getLearnSourceId());
					 statisticsActivityPoint.setAccountId(pointDetails.getAccountId());
					 statisticsActivityPoint.setPoint(pointDetails.getPoint());
					 statisticsActivityPoint.setType(type);
					 statisticsActivityPoint.setCompanyId(companyId);
					 statisticsActivityPoint.setSiteId(siteId);
					 this.insert(statisticsActivityPoint);
				 }
				Long t4=System.currentTimeMillis();
				System.out.println("总数量:"+listSize+"。正在处理第几个:"+i+"......处理每个活动消耗时间(ms):"+(t4-t3));
			}
		 }
		 Long t5=System.currentTimeMillis();
		 System.out.println("总消耗时间(ms):"+(t5-t2));
	}

	@Override
	public void dealBatchPointStatistics() {
		// TODO Auto-generated method stub	
		this.delete(new EntityWrapper<StatisticsActivityPoint>(new StatisticsActivityPoint()));
		List<PointDetailsVo> list=pointDetailsFeignClients.statisticsPoint();
		List<StatisticsActivityPoint> listInsertDate=new ArrayList<StatisticsActivityPoint>();
		if(CollectionUtils.isNotEmpty(list)) {
			StatisticsActivityPoint statisticsActivityPoint=null;
			for (PointDetailsVo pointDetails : list) {
				statisticsActivityPoint=new StatisticsActivityPoint();
				statisticsActivityPoint.setId(idGenerator.generate());
				statisticsActivityPoint.setActivityId(pointDetails.getCourseId());
				statisticsActivityPoint.setAccountId(pointDetails.getAccountId());
				statisticsActivityPoint.setPoint(pointDetails.getPoint());
				statisticsActivityPoint.setType(Integer.valueOf(pointDetails.getLearnType()));
				statisticsActivityPoint.setCompanyId(pointDetails.getCompanyId());
				statisticsActivityPoint.setSiteId(pointDetails.getSiteId());
				listInsertDate.add(statisticsActivityPoint);
			}
		}
		if(CollectionUtils.isNotEmpty(listInsertDate)) {
			this.insertBatch(listInsertDate);
		}
	}
}
