package com.yizhi.statistics.application.service.impl;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.album.application.vo.AlThemeVo;
import com.yizhi.album.application.vo.AlbumVo;
import com.yizhi.album.application.vo.domain.AlThemeActivity;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.statistics.application.entity.StatisticsAlbumActivity;
import com.yizhi.statistics.application.mapper.StatisticsAlbumActivityMapper;
import com.yizhi.statistics.application.service.IStatisticsAlbumActivityService;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class StatisticsAlbumActivityServiceImpl extends ServiceImpl<StatisticsAlbumActivityMapper, StatisticsAlbumActivity> implements IStatisticsAlbumActivityService {

	@Autowired
	private IdGenerator idGenerator;
	
	@Override
	public void dealStatisticsAlbumActivity(AlbumVo albumVo) {
		// TODO Auto-generated method stub
		StatisticsAlbumActivity activity = new StatisticsAlbumActivity();
		activity.setAlbumId(albumVo.getId());
		this.delete(new EntityWrapper<StatisticsAlbumActivity>(activity));
		//先删除后更新专辑关联课程
		if (CollectionUtils.isNotEmpty(albumVo.getList())) {
			List<StatisticsAlbumActivity> list2 = new ArrayList<StatisticsAlbumActivity>();
			StatisticsAlbumActivity insertActivity = null;
			for(AlThemeVo theme:albumVo.getList()) {
				if (CollectionUtils.isNotEmpty(theme.getActivities())) {
					for(AlThemeActivity aThemeActivity:theme.getActivities()) {
						insertActivity = new StatisticsAlbumActivity();
						insertActivity.setId(idGenerator.generate());
						insertActivity.setAlbumId(albumVo.getId());
						insertActivity.setAlbumName(albumVo.getName());
						insertActivity.setName(aThemeActivity.getName());
						insertActivity.setRelationId(aThemeActivity.getRelationId());
						insertActivity.setThemeId(aThemeActivity.getThemeId());
						insertActivity.setThemeName(aThemeActivity.getThemeName());
						insertActivity.setSiteId(aThemeActivity.getSiteId());
						insertActivity.setAlbumCreateTime(aThemeActivity.getCreateTime());
						insertActivity.setUnlock(aThemeActivity.getUnlock());
						insertActivity.setUnlockTime(aThemeActivity.getUnlockTime());
						insertActivity.setSiteId(aThemeActivity.getSiteId());
						insertActivity.setCompanyId(aThemeActivity.getCompanyId());
						list2.add(insertActivity);
					}
				}
			}
			this.insertBatch(list2);
		}
	}
}
