package com.yizhi.statistics.application.service.impl;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.album.application.vo.AlbumVo;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.statistics.application.entity.StatisticsAlbum;
import com.yizhi.statistics.application.mapper.StatisticsAlbumMapper;
import com.yizhi.statistics.application.service.IStatisticsAlbumService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class StatisticsAlbumServiceImpl extends ServiceImpl<StatisticsAlbumMapper, StatisticsAlbum> implements IStatisticsAlbumService  {

	@Autowired
	IdGenerator idGenerator;
	
	@Override
	public void dealStatisticsAlbum(AlbumVo album) {
		Long albumId=album.getId();
		StatisticsAlbum stWrapper=new StatisticsAlbum();
		stWrapper.setAlbumId(albumId);
		EntityWrapper<StatisticsAlbum> wrapper=new EntityWrapper<StatisticsAlbum>(stWrapper);
		stWrapper=this.selectOne(wrapper);
		if(stWrapper==null) {
			StatisticsAlbum sa=new StatisticsAlbum();
			sa.setId(idGenerator.generate());
			sa.setAlbumId(albumId);
			sa.setAlbumName(album.getName());
			sa.setAlbumState(album.getShelves());
			sa.setScope(album.getScope());
			sa.setAlbumCreateTime(album.getCreateTime());
			sa.setCompanyId(album.getCompanyId());
			sa.setSiteId(album.getSiteId());
			sa.setOrgId(album.getOrgId());
			sa.setDuration(album.getDuration());
			sa.setCommentCount(album.getCommentCount());
			sa.setSubscribeCount(album.getSubscribeCount());
			sa.setLockNum(album.getLockNum());
			sa.setOvered(album.getOvered());
			this.insert(sa);
		}
		else {
			StatisticsAlbum sa=new StatisticsAlbum();
			sa.setId(stWrapper.getId());//根据id进行区分
			sa.setAlbumId(albumId);
			sa.setAlbumName(album.getName());
			sa.setAlbumState(album.getShelves());
			sa.setScope(album.getScope());
			sa.setAlbumCreateTime(album.getCreateTime());
			sa.setCompanyId(album.getCompanyId());
			sa.setSiteId(album.getSiteId());
			sa.setOrgId(album.getOrgId());
			sa.setDuration(album.getDuration());
			sa.setCommentCount(album.getCommentCount());
			sa.setSubscribeCount(album.getSubscribeCount());
			sa.setLockNum(album.getLockNum());
			sa.setOvered(album.getOvered());
			this.updateById(sa);
		}
	}

}
