package com.yizhi.statistics.application.service.impl;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.course.application.vo.ScormRecordVO;
import com.yizhi.course.application.vo.StatisticsCourseRecorde;
import com.yizhi.statistics.application.course.vo.*;
import com.yizhi.statistics.application.entity.StatisticsCourseGrade;
import com.yizhi.statistics.application.mapper.StatisticsAccountMapper;
import com.yizhi.statistics.application.mapper.StatisticsCourseGradeMapper;
import com.yizhi.statistics.application.mapper.StatisticsCourseMapper;
import com.yizhi.statistics.application.mapper.StatisticsCourseRecordeMapper;
import com.yizhi.statistics.application.service.IStatisticsAccountRoleService;
import com.yizhi.statistics.application.service.StatisticsCourseRecordeService;
import com.yizhi.statistics.application.util.CourseUtil;
import com.yizhi.statistics.application.util.JedisUtil;
import org.apache.commons.collections.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author yinyuyan123
 * @since 2019-03-20
 */
@Service
public class StatisticsCourseRecordeServiceImpl extends ServiceImpl<StatisticsCourseRecordeMapper, StatisticsCourseRecorde> implements StatisticsCourseRecordeService {


    @Autowired
    private StatisticsCourseRecordeMapper statisticsCourseRecordeMapper;


    @Autowired
    private JedisUtil jedisUtil;

    @Autowired
    private CourseUtil courseUtil;

    @Autowired
    private StatisticsCourseMapper statisticsCourseMapper;

    @Autowired
    private StatisticsAccountMapper statisticsAccountMapper;


    @Autowired
    private IdGenerator idGenerator;

    @Autowired
    private StatisticsCourseGradeMapper statisticsCourseGradeMapper;

    @Autowired
    private IStatisticsAccountRoleService statisticsAccountRoleService;

    private final StatisticsCourseRecorde scr = new StatisticsCourseRecorde();

    private Logger logger = LoggerFactory.getLogger(StatisticsCourseRecordeServiceImpl.class);

    @Override
    public Boolean deleateStatisticsCourseRecorde(Date startDate, Date endDate, Long courseId) {
        // TODO Auto-generated method stub
        EntityWrapper<StatisticsCourseRecorde> wrapper = null;

        new EntityWrapper<StatisticsCourseRecorde>(scr);
        if (courseId != null) {
            scr.setCourseId(courseId);
            wrapper = new EntityWrapper<StatisticsCourseRecorde>(scr);
        } else {
            wrapper = new EntityWrapper<StatisticsCourseRecorde>(scr);
        }
        wrapper.ge("recorde_time", startDate);//大于等于
        wrapper.le("recorde_time", endDate);//小于等于
        return this.delete(wrapper);
    }


    @Override
    public List<ReportStudyCourseChartsVo> chartGroup(String startDate, String endDate, Long companyId, Long siteId,
                                                      Long adminId, Boolean isAdmin) {
        // TODO Auto-generated method stub
        List<ReportStudyCourseChartsVo> list = statisticsCourseRecordeMapper.chartGroup(startDate, endDate, companyId, siteId, adminId, isAdmin);//图形报表先不修改
        List<ReportStudyCourseChartsVo> listAllRecord = new ArrayList<ReportStudyCourseChartsVo>();
        Date startDate1, endDate1;
        ReportStudyCourseChartsVo rsccvUpdate = null;
        int num = 0;
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        try {
            startDate1 = dateFormat.parse(startDate);
            endDate1 = dateFormat.parse(endDate);
            num = (int) ((endDate1.getTime() - startDate1.getTime()) / (1000 * 3600 * 24));
            Date updateDate = startDate1;
            String updateDateValue = dateFormat.format(updateDate);
            Boolean isTrue = false;
            int j = 0;
            for (int i = 0; i <= num; i++) {
                if (list != null && list.size() > 0) {
                    if (j < list.size()) {
                        ReportStudyCourseChartsVo rsccv = list.get(j);
                        if (rsccv.getValue().equals(updateDateValue)) {
                            j = j + 1;
                            listAllRecord.add(rsccv);
                            isTrue = true;
                        } else {
                            isTrue = false;
                        }
                    }
                }
                if (!isTrue) {
                    rsccvUpdate = new ReportStudyCourseChartsVo();
                    rsccvUpdate.setValue(updateDateValue);
                    rsccvUpdate.setTotalCourse(0);
                    rsccvUpdate.setTotalAccount(0);
                    rsccvUpdate.setTotalCount(0);
                    listAllRecord.add(rsccvUpdate);

                }
                Calendar c = Calendar.getInstance();
                c.setTime(updateDate);
                c.add(Calendar.DAY_OF_MONTH, 1); // 利用Calendar 实现 Date日期+1天
                updateDate = c.getTime();
                updateDateValue = dateFormat.format(updateDate);
                isTrue = false;
            }

        } catch (ParseException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return listAllRecord;
    }


    @Override
    public Page<ReportStudyCourseVo> courseGroup(String kwd, String startDate, String endDate, Long companyId, Long siteId, Boolean isAdmin, Long adminId, Integer pageNo, Integer pageSize) {
        // TODO Auto-generated method stub
        String kwdTrim = null;
        if (kwd != null && kwd.length() > 0) {
            kwdTrim = kwd.trim();
            if (kwdTrim.length() == 0) {
                kwdTrim = null;
            }
        }
        //先拿出来十个ids
        Page<Long> pageIds = new Page<Long>(pageNo, pageSize);
        List<Long> courseIds = statisticsCourseMapper.courseGroupLimitCourseIdsIsAdmin(companyId, siteId, kwdTrim, pageIds);
        List<ReportStudyCourseVo> listStatisticsCourse = null;
        if (CollectionUtils.isNotEmpty(courseIds)) {

            //验证下管辖区是否是全平台的
            boolean isAdmin1;
            if (!isAdmin) {
                isAdmin1 = statisticsAccountRoleService.getIsAdmin(0, siteId, adminId);
            } else {
                isAdmin1 = isAdmin;
            }

            if (isAdmin1) {
                listStatisticsCourse = statisticsCourseMapper.listStatisticsCourseIsAdmin(startDate, endDate, companyId, siteId, isAdmin, courseIds);
            } else {
                listStatisticsCourse = statisticsCourseMapper.listStatisticsCourseNotAdmin(startDate, endDate, companyId, siteId, isAdmin, courseIds, adminId);
            }
            if (CollectionUtils.isNotEmpty(listStatisticsCourse)) {
                for (ReportStudyCourseVo reportStudyCourseVo : listStatisticsCourse) {
                    Long courseId = reportStudyCourseVo.getCourseId();
                    Integer askNum = jedisUtil.getAskNumByAdminIdAndWorkId(adminId, siteId, isAdmin, courseId);
                    //可参加人数
                    reportStudyCourseVo.setTotalAskAccount(askNum);
                }
            }
        }
        Page<ReportStudyCourseVo> page = new Page<ReportStudyCourseVo>(pageNo, pageSize);
        if (pageIds != null) {
            page.setTotal(pageIds.getTotal());
        }
        if (listStatisticsCourse != null) {
            page.setRecords(listStatisticsCourse);
        }
        return page;
    }

    @Override
    public Page<ReportStudyCourseViewVo> courseGroupView(String orgKwd, String accountKwd, String startDate,
                                                         String endDate, Long courseId, Integer pageNo, Integer pageSize, Long companyId, Long siteId, Boolean isAdmin, Long adminId) {
        // TODO Auto-generated method stubs


        if (accountKwd != null && accountKwd.length() > 0) {
            accountKwd = accountKwd.trim();
            if (accountKwd.length() == 0) {
                accountKwd = null;
            }
        }
        if (orgKwd != null && orgKwd.length() > 0) {
            orgKwd = orgKwd.trim();
            if (orgKwd.length() == 0) {
                orgKwd = null;
            }
        }


        Page<Long> pageAccountIds = new Page<Long>(pageNo, pageSize);
        List<Long> accoundIds = null;

        //验证下管辖区是否是全平台的
        boolean isAdmin1;
        if (!isAdmin) {
            isAdmin1 = statisticsAccountRoleService.getIsAdmin(0, siteId, adminId);
        } else {
            isAdmin1 = isAdmin;
        }

        if (isAdmin1) {
            accoundIds = statisticsAccountMapper.getAccountsBycourseIdLimitIsAdmin(orgKwd, accountKwd, companyId, siteId, courseId, pageAccountIds);
        } else {
            accoundIds = statisticsAccountMapper.getAccountsBycourseIdLimitNotAdmin(orgKwd, accountKwd, companyId, siteId, courseId, adminId, pageAccountIds);
        }
        List<ReportStudyCourseViewVo> list = null;
        if (CollectionUtils.isNotEmpty(accoundIds)) {
            list = statisticsCourseRecordeMapper.courseGroupView(startDate, endDate, courseId, companyId, siteId, accoundIds);
        }
        Page<ReportStudyCourseViewVo> page = new Page<ReportStudyCourseViewVo>(pageNo, pageSize);
        if (pageAccountIds != null) {
            page.setTotal(pageAccountIds.getTotal());
        }
        if (CollectionUtils.isNotEmpty(list)) {
            page.setRecords(list);
        }
        return page;
    }

    @Override
    public Page<ReportStudyCourseAccountVo> courseAccountGroup(String orgKwd, String accountKwd, String startDate,
                                                               String endDate, Long companyId, Long siteId, Boolean isAdmin, Long adminId, Integer pageNo, Integer pageSize) {
        // TODO Auto-generated method stub
        //先筛选十个用户
        Page<Long> pageAccountIds = new Page<Long>(pageNo, pageSize);
        List<Long> accountIds = null;

        //验证下管辖区是否是全平台的
        boolean isAdmin1;
        if (!isAdmin) {
            isAdmin1 = statisticsAccountRoleService.getIsAdmin(0, siteId, adminId);
        } else {
            isAdmin1 = isAdmin;
        }

        if (isAdmin1) {
            accountIds = statisticsAccountMapper.getAccountsLimitIsAdmin(orgKwd, accountKwd, companyId, siteId, pageAccountIds);
        } else {
            accountIds = statisticsAccountMapper.getAccountsLimitNotAdmin(orgKwd, accountKwd, companyId, siteId, adminId, pageAccountIds);
        }
        //筛选出来十个id
        List<ReportStudyCourseAccountVo> list = null;
        if (CollectionUtils.isNotEmpty(accountIds)) {
            list = statisticsCourseRecordeMapper.courseAccountGroup(startDate, endDate, companyId, siteId, accountIds);
        }
        Page<ReportStudyCourseAccountVo> page = new Page<ReportStudyCourseAccountVo>(pageNo, pageSize);
        if (pageAccountIds != null) {
            page.setTotal(pageAccountIds.getTotal());
        }
        page.setRecords(list);
        return page;
    }

    @Override
    public Page<ReportStudyCourseAccountViewVo> courseAccountGroupView(Long companyId, Long accountId, Long siteId, String kwd, String startDate,
                                                                       String endDate, Integer pageNo, Integer pageSize) {
        // TODO Auto-generated method stub
        //先拿出来可以学的十门课程,已经和可见范围挂钩过
        Page<Long> pageCourseIds = new Page<Long>(pageNo, pageSize);
        List<Long> courseIds = statisticsCourseRecordeMapper.courseIdsLimit(companyId, siteId, kwd, accountId, pageCourseIds);
        List<ReportStudyCourseAccountViewVo> list = null;
        if (CollectionUtils.isNotEmpty(courseIds)) {
            list = statisticsCourseRecordeMapper.courseAccountGroupView(companyId, siteId, accountId, startDate, endDate, courseIds);
        }
        Page<ReportStudyCourseAccountViewVo> page = new Page<ReportStudyCourseAccountViewVo>(pageNo, pageSize);

        if (pageCourseIds != null) {
            page.setTotal(pageCourseIds.getTotal());
        }
        page.setRecords(list);
        return page;
    }

    @Override
    public Page<ReportStudyCourseOrgVo> courseOrgGroup(String kwd, String startDate, String endDate, Long companyId,
                                                       Long siteId, Integer pageNo, Integer pageSize, Boolean isAdmin, Long adminId) {
        // TODO Auto-generated method stub
        Page<Long> pageOrgLimit = new Page<Long>(pageNo, pageSize);
        List<Long> courseOrgIds = statisticsCourseRecordeMapper.courseOrgIdsLimit(kwd, companyId, siteId, pageOrgLimit);
        Page<ReportStudyCourseOrgVo> pageDate = new Page<ReportStudyCourseOrgVo>(pageNo, pageSize);


        List<ReportStudyCourseOrgVo> list = statisticsCourseRecordeMapper.courseOrgGroup(companyId, siteId, startDate, endDate, adminId, courseOrgIds);
        if (CollectionUtils.isNotEmpty(list)) {
            pageDate.setRecords(list);
            pageDate.setTotal(pageOrgLimit.getTotal());
        }
        return pageDate;
    }


    @Override
    public List<ReportStudyCourseAccountDetailsVo> listReportStudyCourseAccountDetailsVo(Long companyId, Long siteId,
                                                                                         String startDate, String endDate, List<Long> accountIdLimitPageSize, Boolean isAllDate) {
        // TODO Auto-generated method stub
        List<ReportStudyCourseAccountDetailsVo> listPrimitive = null;
        if (isAllDate) {
            listPrimitive = statisticsCourseRecordeMapper.listReportStudyCourseAccountDetailsVo(companyId, siteId, startDate, endDate, accountIdLimitPageSize);
        } else {
            listPrimitive = statisticsCourseRecordeMapper.listReportStudyCourseAccountDetailsVoReactRecorde(companyId, siteId, startDate, endDate, accountIdLimitPageSize);
        }
        if (CollectionUtils.isNotEmpty(listPrimitive)) {
            for (ReportStudyCourseAccountDetailsVo reportStudyCourseAccountDetailsVo : listPrimitive) {
                if (reportStudyCourseAccountDetailsVo.getFilstFinishTime() != null) {
                    reportStudyCourseAccountDetailsVo.setStudystate("已结束");
                } else if (reportStudyCourseAccountDetailsVo.getFilstFinishTime() == null && reportStudyCourseAccountDetailsVo.getStartTime() != null) {
                    reportStudyCourseAccountDetailsVo.setStudystate("进行中");
                } else {
                    reportStudyCourseAccountDetailsVo.setStudystate("未开始");
                }
                String duration = reportStudyCourseAccountDetailsVo.getTotalDuration();
                if (duration == null) {
                    duration = "0";
                }
                int totalDurationInt = Integer.valueOf(duration);
                //格式化总学习时长
                Integer hour = totalDurationInt / 3600;
                Integer minute = (totalDurationInt % 3600) / 60;
                Integer seconds = totalDurationInt % 60;
                String time = hour + ":" + minute + ":" + seconds;
                reportStudyCourseAccountDetailsVo.setTotalDuration(time);
            }
        }
        return listPrimitive;
    }


    @Override
    public String selectIntoRecorde(String startDdate, String endDate) {
        // TODO Auto-generated method stub
        String sqlBefore = "insert into statistics_course_recorde(id,course_id,account_id,site_id,org_id,learn_count,start_time,end_time,learn_time,recorde_time) "
                + "		select RIGHT(UUID_SHORT(),19) as id,a.course_id as courseId,a.account_id as accountId,a.site_id as siteId,NULL as orgId,1 as learnCount,a.finish_time as startTime,a.finish_time as endTime,0 as learnTime,a.recorde_time as recordeTime from statistics_course_message  as a"
                + "		left join statistics_course_recorde as b "
                + "		on a.course_id=b.course_id and a.account_id=b.account_id "
                + "		and DATE_FORMAT( a.finish_time,'%Y-%m-%d')=DATE_FORMAT(b.recorde_time,'%Y-%m-%d') "
                + "		where a.type=3 and b.id is null";

        String sqlCondion = " ";
        if (startDdate != null && endDate != null) {
            sqlCondion = " and ( DATE_FORMAT(a.recorde_time,'%Y-%m-%d')<=DATE_FORMAT('" + endDate
                    + "','%Y-%m-%d') "
                    + "	and  DATE_FORMAT(a.recorde_time,'%Y-%m-%d')>=DATE_FORMAT('"
                    + startDdate + "','%Y-%m-%d') )";
        }
        String sqlAfter = "  GROUP BY a.course_id,a.account_id,a.recorde_time";
        String sql = sqlBefore + sqlCondion + sqlAfter;

        System.out.println(sql);
        String result = "";
        try {
            jedisUtil.testProce(sql);
            result = "空记录插入成功";
        } catch (SQLException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            result = "空记录插入失败。原因:" + e.getMessage();
        }
        return result;
    }


    @Override
    public void insertIntoCourseGrade(List<ScormRecordVO> list) {
        // TODO Auto-generated method stub

        //先删除
        statisticsCourseGradeMapper.delete(new EntityWrapper<StatisticsCourseGrade>(new StatisticsCourseGrade()));
        logger.info("删除课程得分历史记录");
        if (CollectionUtils.isNotEmpty(list)) {
			/*List<StatisticsCourseGrade> listGrade=new ArrayList<StatisticsCourseGrade>();
			StatisticsCourseGrade scg=null;
			for (ScormRecord testCase : list) {
				scg=new StatisticsCourseGrade();
				scg.setId(idGenerator.generate());
				scg.setCourseId(testCase.getScormId());
				scg.setAccountId(testCase.getAccountId());
				scg.setScore(testCase.getScore());
				listGrade.add(scg);
			}*/
            if (CollectionUtils.isNotEmpty(list)) {
                try {
                    //6000条数据系统本身的插入时间好几分钟，jdbc来写秒插入。
                    int pageSize = 1000000;
                    double dcount = Double.valueOf(list.size()) / Double.valueOf(pageSize);
                    int pageCount = (int) Math.ceil(dcount);
                    for (int i = 0; i < pageCount; i++) {
                        int fromIndex = i * pageSize;
                        int toIndex = (i + 1) * pageSize > list.size() ? list.size() : (i + 1) * pageSize;
                        logger.info("开始循环插入课程得分,次数:{},开始:{},结束{}", i + 1, fromIndex, toIndex);
                        courseUtil.insertGrade(list.subList(fromIndex, toIndex));
                    }
                } catch (Exception e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                    logger.error("课程得分入库失败", e.getMessage());
                }
            }
        }
    }

    @Override
    public Page<ReportStudyCourseViewVo> courseGroupViewExport(String orgKwd, String accountKwd, String startDate,
                                                               String endDate, Long courseId, Integer pageNo, Integer pageSize, Long companyId, Long siteId,
                                                               Boolean isAdmin, Boolean allData, Long adminId) {

        if (accountKwd != null && accountKwd.length() > 0) {
            accountKwd = accountKwd.trim();
            if (accountKwd.length() == 0) {
                accountKwd = null;
            }
        }
        if (orgKwd != null && orgKwd.length() > 0) {
            orgKwd = orgKwd.trim();
            if (orgKwd.length() == 0) {
                orgKwd = null;
            }
        }

        Page<ReportStudyCourseViewVo> pageAccountIds = new Page<ReportStudyCourseViewVo>(pageNo, pageSize);

        //验证下管辖区是否是全平台的
        boolean isAdmin1;
        if (!isAdmin) {
            isAdmin1 = statisticsAccountRoleService.getIsAdmin(0, siteId, adminId);
        } else {
            isAdmin1 = isAdmin;
        }

        List<ReportStudyCourseViewVo> list = statisticsCourseRecordeMapper.courseGroupViewExport(startDate, endDate,
                courseId, companyId, siteId, adminId, isAdmin1, allData, orgKwd, accountKwd, pageAccountIds);

        Page<ReportStudyCourseViewVo> page = new Page<ReportStudyCourseViewVo>(pageNo, pageSize);
        if (pageAccountIds != null) {
            page.setTotal(pageAccountIds.getTotal());
        }
        if (CollectionUtils.isNotEmpty(list)) {
            page.setRecords(list);
        }

        return page;
    }

    @Override
    public List<ReportStudyCourseAccountDetailsVo> listReportStudyCourseAccountDetailsVoExport(Long companyId,
                                                                                               Long siteId, String startDate, String endDate, List<Long> courseIds, Long adminId, Boolean adminType,
                                                                                               Boolean allData, String orgKwd, String accountKwd) {
        List<ReportStudyCourseAccountDetailsVo> ds = statisticsCourseRecordeMapper.listReportStudyCourseAccountDetailsVoReactRecordeExport(companyId, siteId, startDate, endDate,
                courseIds, adminId, adminType, allData, orgKwd, accountKwd);
        return ds;
    }
}
