package com.yizhi.statistics.application.service.impl;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.course.application.vo.domain.CourseEntityVo;
import com.yizhi.statistics.application.entity.StatisticsCourse;
import com.yizhi.statistics.application.mapper.StatisticsCourseMapper;
import com.yizhi.statistics.application.service.StatisticsCourseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author yinyuyan123
 * @since 2019-03-20
 */
@Service
public class StatisticsCourseServiceImpl extends ServiceImpl<StatisticsCourseMapper, StatisticsCourse> implements StatisticsCourseService {

	@Autowired
	IdGenerator idGenerator;
	
	//定义全局
	final StatisticsCourse statisticsCourse = new StatisticsCourse();
	
	final StatisticsCourse scUpdate=new StatisticsCourse();
	
	StatisticsCourse scNew=new StatisticsCourse();
	
	@Override
	public StatisticsCourse dealCourseMessage(CourseEntityVo course, String courseDuration) {
		// TODO Auto-generated method stub
		//先查询课程信息是否存在，如果不存在插入，如果存在则更新
		Long courseId=course.getId();
		
		statisticsCourse.setCourseId(courseId);
		EntityWrapper<StatisticsCourse> wrapper=new EntityWrapper<StatisticsCourse>(statisticsCourse);
		StatisticsCourse sc = this.selectOne(wrapper);
		Long id=null;
		if(sc!=null) {
			id=sc.getId();
			//更新
			scUpdate.setId(id);
			scUpdate.setCourseId(courseId);
			scUpdate.setCourseName(course.getName());
			scUpdate.setCourseState(course.getShelves());
			scUpdate.setCourseCode(course.getCode());
			scUpdate.setCourseDuration(courseDuration);
			scUpdate.setCourseCreateTime(course.getCreateTime());
			scUpdate.setCompanyId(course.getCompanyId());
			scUpdate.setSiteId(course.getSiteId());
			scUpdate.setOrgId(course.getOrgId());
			scUpdate.setGrantCertificate(course.getGrantCertificate());// 课程的证书规则
			//如果两者不相等则更新
			if(!sc.toStringVO().equals(scUpdate.toStringVO())) {
				this.updateById(scUpdate);
			}
			
		}
		else {
			//插入
			scNew.setId(idGenerator.generate());
			scNew.setCourseId(courseId);
			scNew.setCourseName(course.getName());
			scNew.setCourseState(course.getShelves());
			scNew.setCourseCode(course.getCode());
			scNew.setCourseDuration(courseDuration);
			scNew.setCourseCreateTime(course.getCreateTime());
			scNew.setCompanyId(course.getCompanyId());
			scNew.setSiteId(course.getSiteId());
			scNew.setOrgId(course.getOrgId());
			scNew.setScope(null);
			scNew.setGrantCertificate(course.getGrantCertificate()); // 课程的证书规则
			//this.insert(scNew);
			return scNew;
		}
		return null;
	}

	@Override
	public StatisticsCourse getStatisticsCourse(Long courseId) {
		// TODO Auto-generated method stub
		StatisticsCourse sc=new StatisticsCourse();
		sc.setCourseId(courseId);
		return this.selectOne(new EntityWrapper<StatisticsCourse>(sc));
	}

	

	

}
