package com.yizhi.statistics.application.service.impl;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.statistics.application.entity.StatisticsForumAccount;
import com.yizhi.statistics.application.mapper.StatisticsForumAccountMapper;
import com.yizhi.statistics.application.service.IStatisticsForumAccountService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author taoge123
 * @since 2020-02-13
 */
@Service
public class StatisticsForumAccountServiceImpl extends ServiceImpl<StatisticsForumAccountMapper, StatisticsForumAccount> implements IStatisticsForumAccountService {

    @Autowired
    private IdGenerator idGenerator;

    @Override
    public Boolean deleteAllData() {
        StatisticsForumAccount statisticsForumAccount = new StatisticsForumAccount();
        return this.delete(new EntityWrapper<>(statisticsForumAccount));
    }

    @Override
    public Page<StatisticsForumAccount> getPage(String keyword, Long siteId, Integer pageNo, Integer pageSize) {
        Page page = new Page(pageNo,pageSize);
        StatisticsForumAccount statisticsForumAccount = new StatisticsForumAccount();
        statisticsForumAccount.setSiteId(siteId);
        EntityWrapper wrapper = new EntityWrapper(statisticsForumAccount);
        wrapper.andNew()
                .like("account_name",keyword)
                .or()
                .like("full_name",keyword)
                .orderBy("account_name",true);
         return this.selectPage(page,wrapper);
    }
}
