package com.yizhi.statistics.application.service.impl;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.statistics.application.entity.StatisticsForum;
import com.yizhi.statistics.application.mapper.StatisticsForumMapper;
import com.yizhi.statistics.application.service.IStatisticsForumService;
import org.apache.ibatis.session.RowBounds;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author taoge123
 * @since 2020-02-13
 */
@Service
public class StatisticsForumServiceImpl extends ServiceImpl<StatisticsForumMapper, StatisticsForum> implements IStatisticsForumService {

    @Override
    public Boolean deleteAllData() {
        StatisticsForum statisticsForum = new StatisticsForum();
        return this.delete(new EntityWrapper<>(statisticsForum));
    }

    @Override
    public Page<StatisticsForum> getPage(String keyword, String startDate, String endDate, Long siteId, Integer pageNo, Integer pageSize) {
        Page page = new Page(pageNo, pageSize);

        page.setRecords(baseMapper.getPage(startDate,endDate,keyword,siteId,new RowBounds(page.getOffset(),page.getLimit())));
        page.setTotal(baseMapper.getPageNum(startDate,endDate,keyword,siteId));
        return page;
    }
}
