package com.yizhi.statistics.application.service.impl;


import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.statistics.application.entity.StatisticsResearch;
import com.yizhi.statistics.application.mapper.StatisticsResearchMapper;
import com.yizhi.statistics.application.service.StatisticsResearchService;
import org.springframework.stereotype.Service;

import java.util.Date;

/**
 * <p>
 * 调研 服务实现类
 * </p>
 *
 * @author hutao123
 * @since 2019-04-16
 */
@Service
public class StatisticsResearchServiceImple extends ServiceImpl<StatisticsResearchMapper, StatisticsResearch> implements StatisticsResearchService {

    @Override
    public Boolean insertMainResearch(StatisticsResearch research) {
        Long researchId = research.getId();
        StatisticsResearch sc = new StatisticsResearch();
        sc.setId(researchId);
        EntityWrapper<StatisticsResearch> wrapper = new EntityWrapper<StatisticsResearch>(sc);
        sc = this.selectOne(wrapper);
        if (sc != null) {
            //更新
            sc.setTrainingProjectId(research.getTrainingProjectId());
            sc.setResearchNo(research.getResearchNo());
            sc.setPoint(research.getPoint());
            sc.setName(research.getName());
            sc.setStartTime(research.getStartTime());
            sc.setEndTime(research.getEndTime());
            sc.setVisibleRange(research.getVisibleRange());
            sc.setState(research.getState());
            sc.setDeleted(research.getDeleted());
            sc.setCreateById(research.getCreateById());
            sc.setCreateByName(research.getCreateByName());
            sc.setCreateTime(research.getCreateTime());
            sc.setCompanyId(research.getCompanyId());
            sc.setSiteId(research.getSiteId());
            sc.setOrgId(research.getOrgId());
            sc.setRecordCreateTime(new Date());
            this.updateById(sc);
            return true;
        } else {
            //插入
            this.insert(research);
            return true;
        }
    }
}
