package com.yizhi.statistics.application.service.impl;


import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.toolkit.CollectionUtils;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.statistics.application.entity.StatisticsTrainingPlanActivity;
import com.yizhi.statistics.application.mapper.StatisticsTrainingPlanActivityMapper;
import com.yizhi.statistics.application.service.IStatisticsTrainingPlanActivityService;
import com.yizhi.training.application.vo.domain.TpPlanActivityVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 学习计划中的活动 服务实现类
 * </p>
 *
 * @author wfd123
 * @since 2019-05-14
 */
@Service
public class StatisticsTrainingPlanActivityServiceImpl extends ServiceImpl<StatisticsTrainingPlanActivityMapper, StatisticsTrainingPlanActivity> implements IStatisticsTrainingPlanActivityService {

	@Autowired
	private IdGenerator idGenerator;
	
	@Override
	public void dealStatisticsTrainingPlanActivityByTpId(Long tpId, List<TpPlanActivityVo> listTpPlanActivity) {
		// TODO Auto-generated method stub
		StatisticsTrainingPlanActivity stpa=new StatisticsTrainingPlanActivity();
		stpa.setTrainingProjectId(tpId);
		this.delete(new EntityWrapper<StatisticsTrainingPlanActivity>(stpa));
		//先删除对应关系，在添加对应关系,而不是去更新
		if(CollectionUtils.isNotEmpty(listTpPlanActivity)) {
			List<StatisticsTrainingPlanActivity> insertListStatisticsTrainingPlanActivity=new ArrayList<StatisticsTrainingPlanActivity>();
			StatisticsTrainingPlanActivity stpaInsert=null;
			for (TpPlanActivityVo tpPlanActivity : listTpPlanActivity) {
				stpaInsert=new StatisticsTrainingPlanActivity();
				stpaInsert.setId(idGenerator.generate());
				stpaInsert.setTrainingProjectId(tpPlanActivity.getTrainingProjectId());
				stpaInsert.setTpPlanId(tpPlanActivity.getTpPlanId());
				stpaInsert.setType(tpPlanActivity.getType());
				stpaInsert.setRelationId(tpPlanActivity.getRelationId());
				stpaInsert.setName(tpPlanActivity.getName());
				stpaInsert.setSiteId(tpPlanActivity.getSiteId());
				stpaInsert.setCompanyId(tpPlanActivity.getCompanyId());
				insertListStatisticsTrainingPlanActivity.add(stpaInsert);
			}
			this.insertBatch(insertListStatisticsTrainingPlanActivity);
		}
		
	}

}
