package com.yizhi.statistics.application.service.impl;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.toolkit.CollectionUtils;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.statistics.application.entity.StatisticsTrainingPlan;
import com.yizhi.statistics.application.mapper.StatisticsTrainingPlanMapper;
import com.yizhi.statistics.application.service.IStatisticsTrainingPlanService;
import com.yizhi.training.application.vo.domain.TpPlanVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author wfd123
 * @since 2019-05-31
 */
@Service
public class StatisticsTrainingPlanServiceImpl extends ServiceImpl<StatisticsTrainingPlanMapper, StatisticsTrainingPlan> implements IStatisticsTrainingPlanService {

	@Autowired
	private IdGenerator idGenerator;
	
	@Override
	public void selectSourcePlanToStatistics(List<TpPlanVo> listTpPlanByTrainingProjectId) {
		// TODO Auto-generated method stub

		List<StatisticsTrainingPlan> listPlan=null;
		if(CollectionUtils.isNotEmpty(listTpPlanByTrainingProjectId)) {
			 StatisticsTrainingPlan stp=null;
			 listPlan=new ArrayList<StatisticsTrainingPlan>();
			for (TpPlanVo tpPlan : listTpPlanByTrainingProjectId) {
				stp=new StatisticsTrainingPlan();
				stp.setId(idGenerator.generate());
				stp.setTrainingProjectId(tpPlan.getTrainingProjectId());
				stp.setPlanId(tpPlan.getId());
				stp.setPlanName(tpPlan.getName());
				stp.setCompanyId(tpPlan.getCompanyId());
				stp.setSiteId(tpPlan.getSiteId());
				listPlan.add(stp);
			}
			this.insertBatch(listPlan);
		}	
	}

	@Override
	public void deleteStatisticsTrainingPlan(Long trainingProjectId) {
		// TODO Auto-generated method stub
		StatisticsTrainingPlan stp=new StatisticsTrainingPlan();
		stp.setTrainingProjectId(trainingProjectId);
		this.delete(new EntityWrapper<StatisticsTrainingPlan>(stp));
	}
}
