package com.yizhi.statistics.application.service.impl;

import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.toolkit.CollectionUtils;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.statistics.application.entity.StatisticsTrainingStudentActivityRecord;
import com.yizhi.statistics.application.mapper.StatisticsTrainingStudentActivityRecordMapper;
import com.yizhi.statistics.application.service.IStatisticsTrainingStudentActivityRecordService;
import com.yizhi.statistics.application.util.TrainingInsertBatchUtil;
import com.yizhi.training.application.feign.TrainingProjectReportClient;
import com.yizhi.training.application.vo.domain.TpStudentActivityRecordVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 学员完成活动记录（这里无论有没有被设置成别的活动的开启条件，都记录） 服务实现类
 * </p>
 *
 * @author wfd123
 * @since 2019-05-13
 */
@Service
public class StatisticsTrainingStudentActivityRecordServiceImpl extends ServiceImpl<StatisticsTrainingStudentActivityRecordMapper, StatisticsTrainingStudentActivityRecord> implements IStatisticsTrainingStudentActivityRecordService {

	@Autowired
	private TrainingProjectReportClient trainingProjectReportClient;
	@Autowired
	private IdGenerator idGenerator;
	
	@Autowired
	private TrainingInsertBatchUtil trainingInsertBatchUtil;
	
	@Autowired
	private StatisticsTrainingStudentActivityRecordMapper statisticsTrainingStudentActivityRecordMapper;
	
	@Override
	public void dealGetAllRecordeByTimeLimit(String startDate, String endDate) {
		// TODO Auto-generated method stub
		//先进行删除
		statisticsTrainingStudentActivityRecordMapper.deleteLimitTime(startDate, endDate);
		//然后添加
		//初始化的时候因为数据量太大，因此分业务id导入;
		Long ttt=System.currentTimeMillis();
		List<Long> recordeWorkIds=trainingProjectReportClient.getRecordeAllWorkId();
		if(CollectionUtils.isNotEmpty(recordeWorkIds)) {
			for (int i=0;i<recordeWorkIds.size();i++) {
				Long relationId=recordeWorkIds.get(i);
				List<TpStudentActivityRecordVo>list=trainingProjectReportClient.getAllRecordeByTimeLimit(startDate, endDate,relationId);
				System.out.println("业务个数："+recordeWorkIds.size()+"。第"+(i+1)+"个业务，业务Id："+relationId+"。本业务数据量："+list.size());
				if(CollectionUtils.isNotEmpty(list)) {
					List<StatisticsTrainingStudentActivityRecord> listInsert=new ArrayList<StatisticsTrainingStudentActivityRecord>();
					StatisticsTrainingStudentActivityRecord stsa=null;
					for (TpStudentActivityRecordVo tpStudentActivityRecord : list) {
						stsa=new StatisticsTrainingStudentActivityRecord();
						stsa.setId(idGenerator.generate());
						stsa.setType(tpStudentActivityRecord.getType());
						stsa.setAccountId(tpStudentActivityRecord.getAccountId());
						stsa.setRelationId(tpStudentActivityRecord.getRelationId());
						stsa.setScore(tpStudentActivityRecord.getScore());
						stsa.setSeconds(tpStudentActivityRecord.getSeconds());
						stsa.setFinished(tpStudentActivityRecord.getFinished());
						stsa.setFinishDate(tpStudentActivityRecord.getFinishDate());
						stsa.setSiteId(tpStudentActivityRecord.getSiteId());
						listInsert.add(stsa);
					}
					Long t1=System.currentTimeMillis();
				/*	this.insertBatch(listInsert);*/
					
					try {
						trainingInsertBatchUtil.insertBatchStatisticsTrainingProjectRecorde(listInsert);
					} catch (SQLException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					Long t2=System.currentTimeMillis();
					System.out.println("业务Id："+relationId+"。单独耗时(ms):"+(t2-t1)+"。总共时长"+(t2-ttt));
				}
			}
		}
	}
}
