package com.yizhi.statistics.application.service.impl;

import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.toolkit.CollectionUtils;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.statistics.application.entity.StatisticsTrainingStudentPlanRecorde;
import com.yizhi.statistics.application.mapper.StatisticsTrainingStudentPlanRecordeMapper;
import com.yizhi.statistics.application.service.IStatisticsTrainingStudentPlanRecordeService;
import com.yizhi.training.application.vo.domain.TpStudentPlanRecordVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 计划完成记录，只有计划完成才会有记录 服务实现类
 * </p>
 *
 * @author wfd123
 * @since 2019-05-14
 */
@Service
public class StatisticsTrainingStudentPlanRecordeServiceImpl extends ServiceImpl<StatisticsTrainingStudentPlanRecordeMapper, StatisticsTrainingStudentPlanRecorde> implements IStatisticsTrainingStudentPlanRecordeService {

	@Autowired
	private StatisticsTrainingStudentPlanRecordeMapper statisticsTrainingStudentPlanRecordeMapper;
	
	@Autowired
	private IdGenerator idGenerator;

	@Override
	public void dealIStatisticsTrainingStudentPlanRecordeByTpIdAndTimeLimit(Long tpId, String startDate, String endDate,
			List<TpStudentPlanRecordVo> listStatisticsTrainingStudentPlanRecorde) {
		// TODO Auto-generated method stub
		statisticsTrainingStudentPlanRecordeMapper.deleteStatisticsTrainingStudentPlanRecordeByTpIdAndTimeLimit(tpId, startDate, endDate);
		if(CollectionUtils.isNotEmpty(listStatisticsTrainingStudentPlanRecorde)) {
			List<StatisticsTrainingStudentPlanRecorde> insertList=new ArrayList<StatisticsTrainingStudentPlanRecorde>();
			StatisticsTrainingStudentPlanRecorde stspr=null;
			for (TpStudentPlanRecordVo statisticsTrainingStudentPlanRecorde : listStatisticsTrainingStudentPlanRecorde) {
				stspr=new StatisticsTrainingStudentPlanRecorde();
				stspr.setId(idGenerator.generate());
				stspr.setTrainingProjectId(statisticsTrainingStudentPlanRecorde.getTrainingProjectId());
				stspr.setSiteId(statisticsTrainingStudentPlanRecorde.getSiteId());
				stspr.setTpPlanId(statisticsTrainingStudentPlanRecorde.getTpPlanId());
				stspr.setAccountId(statisticsTrainingStudentPlanRecorde.getAccountId());
				stspr.setFinishDate(statisticsTrainingStudentPlanRecorde.getFinishDate());
				insertList.add(stspr);
			}
			this.insertBatch(insertList);
		}
		
	}
}
