package com.yizhi.statistics.application.service.impl;

import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.toolkit.CollectionUtils;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.statistics.application.entity.StatisticsTrainingStudentRecorde;
import com.yizhi.statistics.application.mapper.StatisticsTrainingStudentRecordeMapper;
import com.yizhi.statistics.application.service.IStatisticsTrainingStudentRecordeService;
import com.yizhi.training.application.vo.domain.TpStudentProjectRecordVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 培训项目完成情况，只有计划完成才会有记录 服务实现类
 * </p>
 *
 * @author wfd123
 * @since 2019-05-14
 */
@Service
public class StatisticsTrainingStudentRecordeServiceImpl extends ServiceImpl<StatisticsTrainingStudentRecordeMapper, StatisticsTrainingStudentRecorde> implements IStatisticsTrainingStudentRecordeService {

	
	@Autowired
	private StatisticsTrainingStudentRecordeMapper statisticsTrainingStudentRecordeMapper;
	
	@Autowired
	private IdGenerator idGenerator;
	
	@Override
	public void dealStatisticsTrainingStudentRecordeByTpIdAndTimeLimit(Long tpId, String startDate, String endDate,List<TpStudentProjectRecordVo> listTpStudentProjectRecord) {
		// TODO Auto-generated method stub
		//先删除这几天的，在进行插入，防止多次插入
		statisticsTrainingStudentRecordeMapper.deleteStatisticsTrainingStudentRecordeByTpIdAndTimeLimit(tpId, startDate, endDate);
		if(CollectionUtils.isNotEmpty(listTpStudentProjectRecord)) {
			List<StatisticsTrainingStudentRecorde> listInsert=new ArrayList<StatisticsTrainingStudentRecorde>();
			StatisticsTrainingStudentRecorde insertStatisticsTrainingStudentRecorde=null;
			for (TpStudentProjectRecordVo tpStudentProjectRecord : listTpStudentProjectRecord) {
				insertStatisticsTrainingStudentRecorde=new StatisticsTrainingStudentRecorde();
				insertStatisticsTrainingStudentRecorde.setId(idGenerator.generate());
				insertStatisticsTrainingStudentRecorde.setTrainingProjectId(tpStudentProjectRecord.getTrainingProjectId());
				insertStatisticsTrainingStudentRecorde.setSiteId(tpStudentProjectRecord.getSiteId());
				insertStatisticsTrainingStudentRecorde.setAccountId(tpStudentProjectRecord.getAccountId());
				insertStatisticsTrainingStudentRecorde.setFinishDate(tpStudentProjectRecord.getFinishDate());
				listInsert.add(insertStatisticsTrainingStudentRecorde);
			}
			this.insertBatch(listInsert);
		}
	}

}
