package com.yizhi.statistics.application.util;

import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.course.application.vo.ScormRecordVO;
import com.yizhi.statistics.application.entity.vo.CourseCalculateTimeVo;
import org.apache.commons.collections.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.datasource.DataSourceUtils;
import org.springframework.stereotype.Component;

import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;


@Component
public class CourseUtil {
	
	final SimpleDateFormat sim = new SimpleDateFormat("yyyy-MM-dd");
	
	
	@Autowired
	private DataSource dataSource;	

	@Autowired
	private IdGenerator idGenerator;
	
	private Logger logger = LoggerFactory.getLogger(CourseUtil.class);
	
	public  CourseCalculateTimeVo  calculateTime(Map<String,Object> map,Date middleMaxTime){
		
		CourseCalculateTimeVo cctv=new CourseCalculateTimeVo();
		
		String startDateString=null;
		String endDateString=null;
		
		Date dCurDate = null;
		Date
				startDate = null;
		Date endDate = null;
		
		if (map != null) {
			startDateString = (String) map.get("startDate");
			endDateString = (String) map.get("endDate");
		}

		if (startDateString != null ) {
			try {
				startDate = sim.parse(startDateString);
			}catch (Exception e) {
				logger.error("CourseUtil-calculateTime",e);
			}
		}

		if (endDateString != null) {
			try {
				endDate = sim.parse(endDateString);
			}catch (Exception e) {
				logger.error("CourseUtil-calculateTime",e);
			}
		}

		if (startDateString == null) {
			if (middleMaxTime != null) {
				dCurDate = middleMaxTime;
				startDateString = sim.format(dCurDate);
				try {
					startDate = sim.parse(startDateString);
				} catch (ParseException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			} else {
				startDateString = "2000-01-01";
				try {
					startDate = sim.parse(startDateString);
				} catch (ParseException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
		if (endDateString == null) {
			dCurDate = addDay(new Date(), -1);
			endDateString = sim.format(dCurDate);
			try {
				endDate = sim.parse(endDateString);
			} catch (ParseException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		cctv.setStartDate(startDate);
		cctv.setEndDate(endDate);
		return cctv;
	}
	
	
	
	public Date addDay(Date date, int num) {
		Calendar calendar = new GregorianCalendar();
		calendar.setTime(date);
		calendar.add(calendar.DATE, num);
		date = calendar.getTime();
		return date;
	}
	
	

	
	public void insertGrade(List<ScormRecordVO> listStatisticsCourseGrade) throws Exception {
		String prefix="insert into statistics_course_grade(id,account_id,course_id,score) values ";
		StringBuffer buffer=new StringBuffer();
		logger.info("拼接课程得分记录入库SQL");
		String sql=null;
		if(CollectionUtils.isNotEmpty(listStatisticsCourseGrade)) {
			for (ScormRecordVO statisticsCourseGrade : listStatisticsCourseGrade) {
				buffer.append("("+idGenerator.generate()+","+statisticsCourseGrade.getAccountId()+","+statisticsCourseGrade.getScormId()+","+statisticsCourseGrade.getScore()+")");
				buffer.append(",");
			}
			String suffix=null;
			suffix=buffer.substring(0,buffer.length()-1)+";";
			sql=prefix+suffix;
		}
		
		
		Connection conn = null;
		
		PreparedStatement preStatement = null;
		com.mysql.jdbc.PreparedStatement mysqlPreStatement = null;
		try{
			// sql编译
			conn = DataSourceUtils.getConnection(dataSource);
			preStatement = conn.prepareStatement(sql);
			mysqlPreStatement = preStatement.unwrap(com.mysql.jdbc.PreparedStatement.class);
			// 执行
			preStatement.executeUpdate();
		} catch(Exception e){
			e.printStackTrace();
			throw e;
		} finally {
			//关闭数据库连接
			if (mysqlPreStatement != null) {
				mysqlPreStatement.close();
			}
			if (preStatement != null) {
				preStatement.close();
			}
			if (conn != null) {
				DataSourceUtils.releaseConnection(conn, dataSource);
			}
			
			buffer.delete(0, buffer.length());
		}
	}

}
