package com.yizhi.statistics.application.util;

import com.alibaba.fastjson.JSONObject;
import com.yizhi.core.application.file.constant.FileConstant;
import com.yizhi.core.application.file.util.OssUpload;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;

/**
 * @Date 2020/9/20 11:36 下午
 * @Author lvjianhui
 **/
public class CreateFormartExcelUtils {

    /**
     * filename
     * 第一行 部门名称考试统计yyyymmdd
     * 第二行 统计周期：yyyy-mm-dd~yyyy-mm-dd
     * 第三行 数据头 部门编码、部门名称、所在组....
     * data 真正的数据
     */

    public static String createFormartExcel(
            String fileName,
            String raw1Data,
            String raw2Data,
            List<String> headNames,
            String startAt,
            String endAt,
            List<JSONObject> data) throws IOException {
        String uploadUrl = null;
        //创建excel文件
        XSSFWorkbook wb = new XSSFWorkbook();
        //创建报表页
        XSSFSheet sheet = wb.createSheet(raw1Data);
        //创建表头
        XSSFRow row = sheet.createRow(0);

        CellRangeAddress cra = new CellRangeAddress(0, 0, 0, 6);
        //表头合并单元格
        sheet.addMergedRegion(cra);
        XSSFCell cell = row.createCell(0);
        cell.setCellValue(raw1Data);//填写表头名
        row = sheet.createRow(1);
        CellRangeAddress cra2 = new CellRangeAddress(1, 1, 0, 6);
        sheet.addMergedRegion(cra2);
        cell = row.createCell(0);
        cell.setCellValue(raw2Data);

        row = sheet.createRow(2);

        Integer cellNum = headNames.size();
        for (int i = 0; i < cellNum; i++) {
            row.createCell(i).setCellValue(headNames.get(i));
        }

        Integer rowNum = 2;
        for (JSONObject rowData : data) {
            row = sheet.createRow(rowNum + 1);
            rowNum++;
            for (int i = 0; i < cellNum; i++) {
                row.createCell(i).setCellValue(rowData.getString(headNames.get(i)));
            }
        }

        String requestPath = FileConstant.SAVE_PATH;
        File fileDir = new File(requestPath);
        if (!fileDir.exists()) {
            fileDir.mkdir();
        }


        String path = requestPath + "/" + fileName;
//        String path = "/Users/lvjianhui/work/yizhi" + "/" + fileName;
        FileOutputStream os = null;
        File file = null;
        try {
            os = new FileOutputStream(path);
            wb.write(os);
            uploadUrl = OssUpload.upload(path, fileName);//阿里云返回url
            file = new File(path);
            return uploadUrl;
            //            success(taskContext, "成功", uploadUrl);
        } catch (Exception e) {
            throw e;
        } finally {
            if (os != null) {
                os.close();
            }
            if (wb != null) {
                wb.close();
            }
            if (file != null) {
                file.delete();
            }
        }
    }
}
