package com.yizhi.statistics.application.util;

import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.xssf.streaming.SXSSFCell;
import org.apache.poi.xssf.streaming.SXSSFRow;
import org.apache.poi.xssf.streaming.SXSSFSheet;
import org.apache.poi.xssf.streaming.SXSSFWorkbook;
import org.springframework.stereotype.Component;

@Component
public  class ExcelUtil {
	
	
	//创建表头
	public  SXSSFSheet  createExcel(String[] str,SXSSFWorkbook  wb,String sheetName,String headerName,String startDate,String endDate) {
		SXSSFSheet sheet=wb.createSheet(sheetName);
		SXSSFRow row = sheet.createRow(0);
		CellStyle style = wb.createCellStyle();
		style.setAlignment(HorizontalAlignment.CENTER);
		Integer headRowNum=0;
		if(str!=null&&str.length>0) {
			headRowNum=str.length;
		}
		CellRangeAddress cra = new CellRangeAddress(0, 0, 0, headRowNum); 
		sheet.addMergedRegion(cra);
		SXSSFCell cell = row.createCell(0);
		cell.setCellValue(headerName);
		cell.setCellStyle(style);
		SXSSFRow row2 = sheet.createRow(1);
		
		CellRangeAddress cra2 = new CellRangeAddress(1, 1, 0, 3);
		sheet.addMergedRegion(cra2);
		Cell cell2 = row2.createCell(0);
		cell2.setCellValue("统计周期:" + startDate + "~" + endDate);

		Row row3 = sheet.createRow(2);
		if(str!=null&&str.length>0) {
			for (int i = 0; i < str.length; i++) {
				row3.createCell(i).setCellValue(str[i]);
			}
		}
		return sheet;
	}
	

}
