package com.yizhi.statistics.application.util;

import java.util.Date;

import org.apache.commons.lang3.StringUtils;

import com.yizhi.statistics.application.request.practice.PracticeReportByUserDetailReq;
import com.yizhi.statistics.application.request.practice.PracticeReportByUserReq;
import com.yizhi.util.application.date.DateUtil;

public class ParamUtil {

	private static final String DATE_FORMAT = "yyyy-MM-dd";
	
	public static void setDate(PracticeReportByUserReq param) {
		if(StringUtils.isEmpty(param.getDateToString())) {
			// 结束日期如果没选，设置为今天
			param.setDateTo(DateUtil.nextDate(new Date()));
		}else {
			Date endDate = DateUtil.valueof(param.getDateToString(), DATE_FORMAT);
			param.setDateTo(DateUtil.nextDate(endDate));
		}
		
		if(StringUtils.isEmpty(param.getDateFromString())) {
			// 开始日期如果没选，设置为本月1号
			param.setDateFrom(DateUtil.getFirstDayOfMonth(new Date()));
		}else {
			param.setDateFrom(DateUtil.valueof(param.getDateFromString(), DATE_FORMAT));
		}
	}
	
	public static void setDetailDate(PracticeReportByUserDetailReq param) {
		if(StringUtils.isEmpty(param.getDateToString())) {
			// 结束日期如果没选，设置为今天
			param.setDateTo(DateUtil.nextDate(new Date()));
		}else {
			Date endDate = DateUtil.valueof(param.getDateToString(), DATE_FORMAT);
			param.setDateTo(DateUtil.nextDate(endDate));
		}
		
		if(StringUtils.isEmpty(param.getDateFromString())) {
			// 开始日期如果没选，设置为本月1号
			param.setDateFrom(DateUtil.getFirstDayOfMonth(new Date()));
		}else {
			param.setDateFrom(DateUtil.valueof(param.getDateFromString(), DATE_FORMAT));
		}
	}
}
