package com.yizhi.statistics.application.util;

import com.yizhi.course.application.vo.CourseAccountReport;
import com.yizhi.system.application.system.remote.ReportClient;
import com.yizhi.system.application.vo.ReportAccountRespVO;
import com.yizhi.system.application.vo.ReportRangeAccountReqVO;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;


/**
 * 作用：根据企业ID查询该企业下全平台可见或指定范围的学员信息
 * @author wangfeida
 *
 */
@Component
public class SystemAccountUtil {

	@Autowired
	private ReportClient reportClient;
	
	
	/**
	 * 去sysytem服务查询人员信息
	 * 
	 * @param companyId 企业ID
	 * @param siteId	站点ID
	 * @param orgIdsAndAccountIds 指定范围IDs（全平台可见，将该值设置为null）
	 * @return
	 * @throws ClassNotFoundException
	 * @throws IOException
	 */
	public List<ReportAccountRespVO> getAccountMessageFromSystem(Long companyId, Long siteId, CourseAccountReport orgIdsAndAccountIds, Integer scope) throws ClassNotFoundException, IOException {
		List<ReportAccountRespVO> listReportAccountRespVO = null;
		// 获取用户信息
		System.out.println(Thread.currentThread().getName() + "   站点Id" + siteId + "，被本线程占用，开始去查询人员信息");
		ReportRangeAccountReqVO rrarv = new ReportRangeAccountReqVO();
		if(scope==1) {
			rrarv.setSiteId(siteId);
		}
		if(scope==2) {
			rrarv.setSiteId(siteId);
			rrarv.setOrgIds(orgIdsAndAccountIds.getOrgIds());
			rrarv.setAccountIds(orgIdsAndAccountIds.getAccountIds());
		}
		List<ReportAccountRespVO> listSystem = reportClient.getRangeAccounts(rrarv);
	    if(CollectionUtils.isEmpty(listSystem)) {
		     listReportAccountRespVO=new ArrayList<ReportAccountRespVO>();
	    }
	    else {
	    	listReportAccountRespVO=listSystem;
	    }
		return listReportAccountRespVO;
	}
	
	
}
