package com.yizhi.statistics.application.util;

import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.statistics.application.course.vo.RoleManage;
import com.yizhi.statistics.application.entity.StatisticsAccountRole;
import com.yizhi.statistics.application.service.IStatisticsAccountRoleService;
import com.yizhi.system.application.constant.AuthzConstant;
import com.yizhi.system.application.feign.AuthFeignClient;
import com.yizhi.system.application.system.remote.ReportClient;
import com.yizhi.system.application.vo.HQAccountInManageParam;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.amqp.core.Message;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;
@RestController()
@Component
public class SystemRoleUtil {

	@Autowired
	private AuthFeignClient authFeignClient;
	
	@Autowired
	private IStatisticsAccountRoleService statisticsAccountRoleService;
	/*
	@Autowired
	private RabbitTemplate rabbitTemplate;*/
	
	@Autowired
	private ReportClient reportClient;
	
	@Autowired
	private IdGenerator idGenerator;
	
	@Autowired
	private JedisUtil jedisUtil;


	

	
	
	@GetMapping("/test/mq")
	public void sendMsg() {
		RoleManage roleManage=new RoleManage();
	
		List<Long> accountDeleteIds=new ArrayList<Long>();
		accountDeleteIds.add(1L);
		accountDeleteIds.add(2L);
		roleManage.setAdminId(1314L);
		roleManage.setAccountDeleteIds(accountDeleteIds);
		System.out.println(roleManage);
		
		//rabbitTemplate.convertAndSend("exchange.statistics","routingKey.statistics",roleManage);
	}
	
	/**
	 * 随时监听消息通道,管理人的管理权限随时更改
	 */
	//@RabbitListener(queues="routingKey.statistics")
	public void receive(Message message) {
		System.out.println(message.getBody());
		RoleManage roleManage=new RoleManage();
		if(roleManage!=null) {
			Long adminId=roleManage.getAdminId();
			List<StatisticsAccountRole> accountInsertIds=roleManage.getListStatisticsAccountRole();
			if(CollectionUtils.isNotEmpty(accountInsertIds)) {
				//批量插入
				Long t1=System.currentTimeMillis();
				HQAccountInManageParam hp=new HQAccountInManageParam();
				hp.setAccountId(1314l);
				hp.setSiteId(1314l);
				hp.setModuleType(AuthzConstant.moduleType.statistics_course);
				
				reportClient.getRangeAccountsInManage(hp);
			}
			List<Long> accountDeleteIds=roleManage.getAccountDeleteIds();
			if(CollectionUtils.isNotEmpty(accountInsertIds)) {
				statisticsAccountRoleService.deleteRoleByAdminId(adminId, accountDeleteIds);
			}	
		}
	}
}
