package com.yizhi.statistics.application.util;

import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.statistics.application.entity.StatisticsTrainingStudentActivityRecord;
import com.yizhi.util.application.domain.Response;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.datasource.DataSourceUtils;
import org.springframework.stereotype.Component;

import javax.sql.DataSource;
import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.List;



@Component
public class TrainingInsertBatchUtil {
	
	//字段分割符
		private final static String FIELD_STERMINATED = "'\t'";
		
		//行分割符
		private final static String LINE_STERMINATED = "'\r\n'";
		
		private final static String FENGEFU = "\t";  //tab键
		private final static String HUANHANGFU = "\r\n";  //换行
	
	
	//复用对象
	private StringBuilder strBuilder = new StringBuilder();
	
	private SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	
			
	
	
	private final static String COLUMNS = "(id,type,account_id,relation_id,score,seconds,finished,finish_date,site_id) ";
	

	
	private final static String EXECUTE_SQL = "load data local infile ''  into table statistics_training_student_activity_record fields terminated by "
			+ FIELD_STERMINATED + "enclosed by '' escaped by 'N'" + " lines terminated by " + LINE_STERMINATED + " "
			+ COLUMNS;
	
	





	@Autowired
	IdGenerator idGenerator;
	

	
	@Autowired
	private DataSource dataSource;	
	
	
	
	public Response<String> insertBatchStatisticsTrainingProjectRecorde(List<StatisticsTrainingStudentActivityRecord> insertList)
			throws SQLException {

		Connection conn = null;

		InputStream in = null;
		PreparedStatement preStatement = null;
		com.mysql.jdbc.PreparedStatement mysqlPreStatement = null;
		try{
			// sql编译
			conn = DataSourceUtils.getConnection(dataSource);
			preStatement = conn.prepareStatement(EXECUTE_SQL);
			mysqlPreStatement = preStatement.unwrap(com.mysql.jdbc.PreparedStatement.class);
			in = switchStream(insertList);
			mysqlPreStatement.setLocalInfileInputStream(in);
			// 执行
			preStatement.executeQuery();
		} catch(Exception e){
			e.printStackTrace();
			throw e;
		} finally {
			//大对象手动显示的设置为空保证GC时被释放
			if(in != null){
				in = null;
			}
			
			//关闭数据库连接
			if (mysqlPreStatement != null) {
				mysqlPreStatement.close();
			}
			if (preStatement != null) {
				preStatement.close();
			}
			if (conn != null) {
				DataSourceUtils.releaseConnection(conn, dataSource);
			}
		}
		return Response.ok();
	}
	
	
	
	
	
	public InputStream switchStream(List<StatisticsTrainingStudentActivityRecord> insertList) {

		Long id = null;
		for (StatisticsTrainingStudentActivityRecord st : insertList) {
			id = idGenerator.generate();
			strBuilder.append(id); // 主键
			strBuilder.append(FENGEFU);
			strBuilder.append(st.getType());// 业务类型
			strBuilder.append(FENGEFU);
			strBuilder.append(st.getAccountId());// 
			strBuilder.append(FENGEFU);
			strBuilder.append(st.getRelationId());// 
			strBuilder.append(FENGEFU);
			if(st.getScore()!=null) {
				strBuilder.append(st.getScore());// 
			}
			else {
				strBuilder.append(-10000000);
			}
			
			strBuilder.append(FENGEFU);
			if(st.getSeconds()!=null) {
				strBuilder.append(st.getSeconds());// 
			}
			else {
				strBuilder.append(-10000000);
			}
			
			strBuilder.append(FENGEFU);
			strBuilder.append(st.getFinished());// 
			strBuilder.append(FENGEFU);
			
			if(st.getFinishDate()==null) {
				//如果查到时间为空，设置这个时间，因为我发现有的时候这个时间真的为空。
				strBuilder.append(simpleDateFormat.format("1994-08-08"));// 培训项目的创建时间
			}
			else {
				strBuilder.append(simpleDateFormat.format(st.getFinishDate()));// 培训项目的创建时间
			}
			
			strBuilder.append(FENGEFU);
			strBuilder.append(st.getSiteId());
			strBuilder.append(HUANHANGFU);

		}
		byte[] bytes = strBuilder.toString().getBytes();
		InputStream in = new ByteArrayInputStream(bytes);
		//大对象手动显示的设置为空保证GC时被释放
		bytes = null;
		//清空之前的内容
		strBuilder.delete(0, strBuilder.length());
		return in;
	}

}
