package com.yizhi.statistics.application.util;


import com.yizhi.statistics.application.entity.vo.CourseCalculateTimeVo;
import org.springframework.stereotype.Component;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Map;

@Component
public class TrainingUtil {
	
	final SimpleDateFormat sim = new SimpleDateFormat("yyyy-MM-dd");
	
	
	
	public  CourseCalculateTimeVo  calculateTime(Map<String,Object> map,Date middleMaxTime) {
		
		CourseCalculateTimeVo cctv=new CourseCalculateTimeVo();
		
		String startDateString=null;
		String endDateString=null;
		
		Date dCurDate = null;
		Date startDate = null;
		Date endDate = null;
		
		if (map != null) {
			startDateString = (String) map.get("startDate");
			endDateString = (String) map.get("endDate");
		}
		
		if (startDateString == null) {
			// 从中间表取最大日期，如有有记录，那就是最大日期
			if (middleMaxTime != null) {
				// 如果表的记录是27号 则startDate就是28号
				dCurDate = addDay(middleMaxTime, 1);
				startDateString = sim.format(dCurDate);
				try {
					startDate = sim.parse(startDateString);
				} catch (ParseException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			} else {
				//课程的记录甚至比课程的创建时间还早，因此取最早的时间
				
				startDateString ="2000-01-01";
				try {
					startDate = sim.parse(startDateString);
				} catch (ParseException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}else {
			try {
				startDate = sim.parse(startDateString);
			}catch (ParseException e) {
				e.printStackTrace();
			}
		}


		if (endDateString == null) {
			dCurDate = addDay(new Date(), -1);
			endDateString = sim.format(dCurDate);
			try {
				endDate = sim.parse(endDateString);
			} catch (ParseException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}else {
			try {
				endDate = sim.parse(endDateString);
			}catch (ParseException e) {
				e.printStackTrace();
			}


		}


		cctv.setStartDate(startDate);
		cctv.setStartDateString(startDateString);
		cctv.setEndDate(endDate);
		cctv.setEndDateString(endDateString);
		return cctv;
	}
	
	
	
	public Date addDay(Date date, int num) {
		Calendar calendar = new GregorianCalendar();
		calendar.setTime(date);
		calendar.add(calendar.DATE, num);
		date = calendar.getTime();
		return date;
	}
	

}
